-- Core file for the DKOne WOW addon
-- Author: Zorben on Proudmoore-US

-- Addon bails if character is not a DK
if select(2,UnitClass("player"))  ~= "DEATHKNIGHT" then 
	DisableAddOn("DKOne")
	return
end

local addonName, addonTable = ... --Pulls back the Addon-Local Variables and stores them locally
-- Slash command for DKOne addon
SLASH_DKOne1 = "/DKOne"
-- We make a local reference for the per character database since we call it so frequently
local DB
DKOne = {} -- Create Primary Object to hang functions and variables off of
local Main = CreateFrame("Frame",nil,UIParent); -- Primary Frame
Main.Pbuttons = {} -- The two action priority buttons
Main.CDbuttons = {} -- The two action cooldown buttons
Main.Runes = {} -- The Rune Display
-- These are local version for use in the OnUpdate function
local Pbuttons = {}		-- The main buttons displayed for the priority actions
local CDbuttons = {}	-- The main buttons displayed for the cooldown actions
local Rune = {}			-- The main display for rune information

local aL = addonTable.DKOneAbilityList() -- This is a local version of the abilities list
local events = {} -- list of all Events to track
local delay = 0 -- Variable for throttling the OnUpdate function
local cd, start, duration = 0, 0 , 0 -- Just local variables we reuse when calculating cooldowns
local blanktexture = Main:CreateTexture() -- We create a blank texture for displaying when there is no spell
blanktexture:SetTexture(1, 1, 1, 0)
aL.NoSpell.Icon = blankTexture -- We set the icon for NoSpell to be just a blank field

local runeStart, runeDuration, runeReady, runeCD	-- local variables reused in calculating rune CDs in the local function RuneCDs()
local oldTime, _						-- local variable used in the function ClearOldAOETargets()
local runeorder = {"B1", "B2", "U1", "U2", "F1", "F2"} -- Rune Order used in Blizzard API, remember BUF
local r1order = {"B1", "U1", "F1"} -- 1st rune of each type, used in UpdateResource()
local r2order = {"B2", "U2", "F2"} -- 2nd rune of each type, used in UpdateResource()
local aoeTargets = {}				-- table used to track different targets hit by aoe damage, key is srcUID, value is timestamp
local numtargets = 0				-- number of targets in the aoeTargets table
local cd, start, duration -- local variables used in update status
local myff, mybp, myhulk, myrange, targetTimeToDie -- local variables used in update status
local targetHealthArray = {}		-- Array for storing targets health in order to estimate time to die
local targetTimeArray = {}			-- Array for storing time in order to estimate time to die
local targetHealth = 1				-- This is used in calculating time to die in the update status function
local healthi = 1					-- position in targetHealthArray used in calculating TTD
local difHealth, difTime, oldTarget, numHealthArray -- locals used in TTD calculation
local enoughrp = false				-- Used in the Update UI function to check cooldown resources
local isInstance, instanceType		-- Use in the PLAYER_ENTERING_WORLD event function
local tempPresence					-- Use in the UPDATE_SHAPESHIFT_FORM event function

local timestamp, eventtype, srcGUID, destGUID, spellId -- Used by the COMBAT_LOG_EVENT_UNFILTERED event
--------FUNCTIONS -----------
local GetTime = GetTime			-- local references to functions used in the COMBAT_LOG_EVENT_UNFILTERED event
local tostring = tostring
local unpack = unpack			-- local reference to function used in the UpdateUI function
local GetRuneCooldown = GetRuneCooldown -- local reference to function used in the RuneCd function
local pairs = pairs 			-- local reference to function used in the ClearOldAOETargets function
local GetSpellCooldown = GetSpellCooldown	-- local reference to function used in the UpdateStatus function
local GetCombatRatingBonus = GetCombatRatingBonus	-- local reference to function used in the UpdateStatus function
local UnitPower = UnitPower	-- local reference to function used in the UpdateStatus function
local GetRuneType = GetRuneType	-- local reference to function used in the UpdateStatus function
local UnitHealth = UnitHealth	-- local reference to function used in the UpdateStatus function
local GetTotemInfo = GetTotemInfo	-- local reference to function used in the UpdateStatus function
local UnitHealthMax = UnitHealthMax	-- local reference to function used in the UpdateStatus function
local select = select	-- local reference to function used in the UpdateStatus function
local UnitAura = UnitAura	-- local reference to function used in the UpdateStatus function
local UnitName = UnitName	-- local reference to function used in the UpdateStatus function
local UnitBuff = UnitBuff	-- local reference to function used in the UpdateStatus function
local GetSpellInfo = GetSpellInfo	-- local reference to function used in the UpdateStatus function
local IsSpellInRange = IsSpellInRange	-- local reference to function used in the UpdateStatus function
local floor = floor	-- local reference to function used in the UpdateStatus function
local min = min	-- local reference to function used in the UpdateStatus function
local max = max	-- local reference to function used in the Redraw function
local UnitLevel = UnitLevel	-- local reference to function used in the UpdateStatus function
local UnitInRaid = UnitInRaid	-- local reference to function used in the UpdateStatus function
local GetShapeshiftForm = GetShapeshiftForm	-- local reference to function used in the UpdateStatus function
local UnitClass = UnitClass	-- local reference to function used in the ADDON_LOADED function
local print = print	-- local reference to function used in the ADDON_LOADED function
local DisableAddOn = DisableAddOn	-- local reference to function used in the ADDON_LOADED function
local wipe = wipe	-- local reference to function used in the ADDON_LOADED function
local StaticPopupDialogs = StaticPopupDialogs	-- local reference to function used in the ADDON_LOADED function
local StaticPopup_Show = StaticPopup_Show	-- local reference to function used in the ADDON_LOADED function
local GetAddOnMetadata = GetAddOnMetadata	-- local reference to function used in the ADDON_LOADED function
local CreateFrame = CreateFrame	-- local reference to function used in the CreateButton function
local UIParent = UIParent	-- local reference to Object used in the Init function
local IsInInstance = IsInInstance	-- local reference to function used in the PLAYER_ENTERING_WORLD function
local GetNumGlyphSockets = GetNumGlyphSockets	-- local reference to function used in the SetGlyphs function
local GetGlyphSocketInfo = GetGlyphSocketInfo	-- local reference to function used in the SetGlyphs function
local GetTalentInfo = GetTalentInfo	-- local reference to function used in the SetTalents function
local IsSpellKnown = IsSpellKnown	-- local reference to function used in the CheckUseable function
local GetInventoryItemID = GetInventoryItemID	-- local reference to function used in the CheckItems function
local GetInventorySlotInfo = GetInventorySlotInfo	-- local reference to function used in the CheckItems function
local GetPrimaryTalentTree = GetPrimaryTalentTree	-- local reference to function used in the ACTIVE_TALENT_GROUP_CHANGED function
local UnitGUID = UnitGUID	-- local reference to function used in the COMBAT_LOG_EVENT_UNFILTERED function
local UnitCanAttack = UnitCanAttack	-- local reference to function used in the PLAYER_TARGET_CHANGED function
local tinsert = tinsert	-- local reference to function used in the pairsByKeys function
local sort = sort	-- local reference to function used in the pairsByKeys function
local strrep = strrep	-- local reference to function used in the tprint function
local type = type	-- local reference to function used in the tprint function
local InterfaceOptionsFrame_OpenToCategory = InterfaceOptionsFrame_OpenToCategory	-- local reference to function used in the OpenOptions function
local strsplit = strsplit	-- local reference to function used in the SlashCmdList.DKOne function
local strlower = strlower	-- local reference to function used in the SlashCmdList.DKOne function
local format = format	-- local reference to function used in the PrintRuneStatus function

local opt, fontFace, fontFlags 	-- Used in redrawing the UI elements
-- Used in the strata level for the frames, default is 3 set by the DKOneDB.strata variable
local strataLevels = {
	"BACKGROUND",
	"LOW",
	"MEDIUM",
	"HIGH",
	"DIALOG",
	"FULLSCREEN",
	"FULLSCREEN_DIALOG",
	"TOOLTIP",
}

-- Background texture, flat grey
local BGTEX = "Interface\\AddOns\\DKOne\\textures\\Flat"
local borderType = {
	"Interface\\AddOns\\DKOne\\textures\\border",					-- light
	"Interface\\AddOns\\DKOne\\textures\\border_medium",			-- medium
	"Interface\\AddOns\\DKOne\\textures\\border_heavy"				-- heavy
}



local DKPaction = {aL.HornOfWinter, aL.BloodStrike}	-- Priority Action Queue, intialized with Horn of Winter and Blood Strike
local DKCDaction = {aL.AntiMagicShell, aL.EmpowerRuneWeapon }	-- Cooldown Action Queue, intialized with Anti-Magic Shell and Empower Rune Weapon
local DKCD = {{cd = 0, start = 0, duration = 0, enoughrp = true},{cd = 0, start = 0, duration = 0, enoughrp = true}} -- {Cooldown, start, duration} for the 2 cooldown actions in DKCDaction

-- Primary storage of Current Player Data that is changing rapidly during combat
local DKStatus = {
			RP = 0,					-- Runic Power
			B1 = 0,					-- Cooldown Remaining on first blood rune, order does not change, 0 indicates rune is ready
			B2 = 0,					-- Cooldown remaining on 2nd blood rune
			U1 = 0,					-- 1st unholy rune
			U2 = 0,					-- 2nd unholy rune
			F1 = 0,					-- 1st frost rune
			F2 = 0,					-- 2nd frost rune
			NotDeath = {true,true,true,true,true,true},	-- Runes that are not Death Runes are marked true, otherwise false
			RuneCD = {0,0,0},		-- Number of Non-Death Runes off CD  {B,U,F}
			DRuneCD = {0,0,0,0},	-- Number of Death Runes off CD  {B,U,F, Total of B,U,F}
			RuneDur = 10,			-- Current time it takes a rune to come off Cd when used
			Rime = 0,				-- Stacks of freezing fog buff from rime talent and T13 2pc, 0 means no freezing fog buff
			RotFC = 0,				-- How long on Rune of the Fallen Crusader buff
			Pillar = 0,				-- Time left on Pillar of Frost Buff
			PillarCD = 0,			-- Time left on Pillar of Frost Cooldown
			HasPet = false,			-- Does player have a ghoul out
			PetDur = 0,				-- How long will pet last
			Doom = 0,				-- Stacks of Sudden Doom , including from T13 2pc, 0 means no proc
			Hulk = 0,				-- Time left on Dark Transformation buff, 0 means no pet or buff
			SI = 0,					-- Stacks of Shadow Infusion on pet
			UF = 0,					-- Unholy Frenzy
			KM = false,				-- Killing Machine Buff
			-- Removed MoP
			--CS = false,				-- Crimson Scourge Buff for free Blood Boil
			DW = false,				-- Dual Wielding
			WON = false,			-- Free Rune Tap from Will of Necropolis talent
			VB = 0,					-- Vampiric Blood Duration
			Bone = 0,				-- Bone Shield Stacks
			SoB = 0,				-- Scent of Blood Stacks
			FF = 0,					-- Time left on Frost Fever for current target
			BP = 0,					-- Time left for Blood Plague for current target
			BC = 0,					-- Blood Charges from the Blood Tap Talent
			BS = 0,					-- Current Value of Blood Shield
			BSDur = 0,				-- How long Current Blood Shield has left
			ASDebuff = false,		-- Does the current target have the 20% attack speed slow
			PDRDebuff = false,		-- Does the current target have the 10% Physical damage reduction debuff
			InCombat = false,		-- Currently in combat
			Presence = 3,			-- Current Presence:  1 = BLOOD, 2 = FROST, 3 = UNHOLY , or  0 = NONE
			Melee = true,			-- Current Target is in Melee range
			AOE = false,			-- Currently hitting more than the AOE threshold number of targets
			Time = 0,				-- Current time
			GCD = 1,				-- GCD, minimum time between strikes and spells
			GCDLeft = 0,			-- Time left on current GCD
			Health = 1,				-- Players Health
			MaxHealth = 1,			-- Players Max Health
			PerHealth = 100,		-- Percent Health of Player
			APBuff	= false,		-- Strength buff from Horn of Winter or Equivalent
			BL = false,				-- Under effect of Bloodlust or equivalent
			TimeToDie = 600,		-- Estimate of current targets life expectancy in seconds
			TargetIsBoss = false,	-- Target is a raid boss
			TargetHostile = false,	-- Is the players current target Hostile
			TargetHealth = 1,		-- Health of Hostile Target
			TargetPerHealth = 100,	-- Percentage Health of a Hostile Target
		}

		-- Player Data that does not typically change during combat
local DKPlayerStats = {
			Spec = 2,				-- Player Spec: 1 = BLOOD, 2 = FROST, 3 = UNHOLY, 0 = Unspecced
			MaxRP = 100,				-- Maximum Runic Power of player
			--Glyphs
			OutbreakGlyphed = false,	-- Outbreak Glyph Outbreak costs 40 RP and has no CD 
			MindFreezeGlyphed = false, -- increase in the runic power cost of Mind Freeze
			ShiftingPresenceGlyphed = false,	-- retain 70% of runic power when shifting presence
			DarkSuccorGlyphed = false,	-- Dark Succor Glyphed, for extra healing after honorable kill
			VampiricBloodGlyphed = false,	-- Vampiric Blood GLphed for extra heals
			-- Talents
			RoilingBlood = false,
			PlagueLeech = false,			
			UnholyBlight = false,			
			Lichborne = false,			
			AntiMagicZone = false,			
			Purgatory = false,			
			DeathsAdvance = false,			
			Chilblains = false,			
			Asphyxiate = false,			
			DeathPact = false,			
			DeathSiphon = false,			
			Conversion = false,			
			BloodTap = false,			
			RunicEmpowerment = false,			
			RunicCorruption = false,			
			GorfiendsGrasp = false,			
			RemorselessWinter = false,			
			DesecratedGround = false,	
			-- Blood Talents			
			PointsInScarletFever = 2, -- Each point in scarlet fever debuffs targets of blood plague with 5% damage reduction
			PointsInSangFort = 2, -- Each point in Sanguine Fortitude reduces the costs of Icebound fortitude by 10
			-- Frost Talents
			PointsInRPMastery = 0,	--Increases total runic power by 10 per point
			PointsInEndlessWinter = 0, -- Each point in Endless Winter reduces the costs of Mind Freeze by 10
			PointsInChillOfTheGrave = 0,	-- Increases Runic Power generated by abilities by 10
			PointsInImpFrostPres = 0,	-- Increases runic power generation
			-- Unholy
			PointsInEpidemic = 0,	-- Epidemic Talent in Unholy tree increases disease durations by 4 secs for each point
			PointsInRunicCorruption = 0, -- Runic Corruption, reduces DC cost
			-- Trinkets Equipped, only Creche of the Final Dragon and Eye of Unmaking currently implemented
			CrecheEquipped = false,	-- Is the trinket Creche of the Final Dragon (any version) Equipped
			EyeEquipped = false,	-- Is the trinket, Eye of Unmaking (any version) Equipped
			-- Player is in some sort of Instance
			InInstance = false,	-- Player is in a 5 man instance
			InRaid = false,		-- Player is in a raid
			InBG = false,			-- Player is in a BG
			InArena = false,			-- Player is in an Arena
			InAnyInstance = false,	-- Player is in any of , Raid, Instance, BG, Arena
			-- The current rotation the player is using
			Rotation = {prio = "none",
						prioAOE = "none",
						prioR = "none",			-- Current Rotation
						prioCD = "none",
						aoenum = 3},
		}
--These addon functions let us pass references to the tables to other files, rotation.lua in this case
function addonTable.DKOneDKStatus()
	return DKStatus
end			
function addonTable.DKOneDKPlayerStats()
	return DKPlayerStats
end			

-- ---------------------------------------------------------------------------------------------------------------------
-- DEFAULT VALUES
-- ---------------------------------------------------------------------------------------------------------------------
-- These values are set when DKOne is first started, then they are stored on a per character basis
-- They can be reset by using the Reset All button on the first page of the DKOne Interface Options
-- screen. They can be partially reset on a per page basis by using the Default button in the lower left
-- The reason for this inefficient type of construction is that I want to retain the original table pointer
-- which is passed to all the subfiles when the addon is loaded. If I just construct a new table with the 
-- Database name all the other files lose reference to it. I could use wipe(t), but I wanted the option to only 
-- reset subcategories of the DB, like reset the rotation values but leave the action button options the same

local function ConstructDB()
	if not DB then
		DB = {}
		DKOneDB = DB -- I construct and set the database table locally, but I need the global to point to the table as well
		DB.Action1 = {}
		DB.Action1.borderColor = {}
		DB.Action1.borderColorRange = {}
		DB.Action1.borderColorAOE = {}
		DB.Action2 = {}
		DB.Action2.borderColor = {}
		DB.Action2.borderColorRange = {}
		DB.Action2.borderColorAOE = {}
		DB.CD1 = {}
		DB.CD1.borderColor = {}
		DB.CD1.borderColorCD = {}
		DB.CD1.buttonColorClear = {}
		DB.CD1.buttonColorCD = {}
		DB.CD1.borderColorCDUser = {}
		DB.CD2 = {}
		DB.CD2.borderColor = {}
		DB.CD2.borderColorCD = {}
		DB.CD2.buttonColorClear = {}
		DB.CD2.buttonColorCD = {}
		DB.CD2.borderColorCDUser = {}	
		DB.AOELabel = {}
		DB.AOELabel.fontColor = {}
		DB.TTDLabel = {}
		DB.TTDLabel.fontColor = {}
		DB.CDText = {}
		DB.CDText.fontColorLong = {}
		DB.CDText.fontColorShort = {}
		DB.CDText.fontColorUser = {}
		DB.RotationBlood = {}
		DB.RotationFrost = {}
		DB.RotationFrostDW = {}
		DB.RotationUnholy = {}
		DB.RotationNone = {}
		DB.RuneFrame = {}
		DB.RuneFrame.colorRFbg = {}
		DB.RuneFrame.colorR = {{},{},{},{}}
		DB.RuneFrame.colorRdark = {{},{},{},{}}
		DB.RuneFrame.colorRlight = {{},{},{},{}}
		DB.RuneFrame.colorFF = {}
		DB.RuneFrame.colorFFbg = {}
		DB.RuneFrame.colorBP = {}
		DB.RuneFrame.colorBPbg = {}
		DB.RuneFrame.colorRP = {}
		DB.RuneFrame.colorRPbg = {}
		DB.RuneFrame.fontColorB1 = {}
		DB.RuneFrame.fontColorB2 = {}
		DB.RuneFrame.fontColorB3 = {}
		DB.RuneFrame.fontColorB4 = {}
		DB.RuneFrame.colorBS = {}
		DB.RuneFrame.colorBSbg = {}
	end
end
function addonTable.ResetDB()
	-- DKOneDB
	DB.version = 50001.2 -- For future upgrade compatibility   expansion..patch..version
	DB.enabled = true	-- Is DKOne Addon enabled
	DB.ShowOnlyInCombat = false	-- Only Calculate and show buttons in combat
	DB.ShowAlwaysInRaid = true 	-- This modifies the show only in combat choice so buttons are always on if instanced
	DB.priorityActions = true	-- Calculate and show the 2 priority actions
	DB.cdActions = true		-- Calculate and show the 2 cooldown actions
	DB.showRF = true		-- Calculate and show the the Rune Frame
	DB.frequency = .1		-- Time between updates in secs (so .1 is 10 times per second)
	DB.scale = 1 	-- Scales all the UI elemtes, seems to work pretty smoothly
	-- Next 2 are not implemented in the options choices, but can be changed here
	-- This reduces the icon size slightly on the button so the borders dont overwrite the edges
	DB.zoomIcons = true
	DB.strata = 3 -- All frames are drawn on the Medium Strata level
end
function addonTable.ResetDBAD()
	-- Setting for each of the 4 buttons
	-- Action1: Main Action Priority button
	DB.Action1.show = true	-- should the button be shown 
	DB.Action1.locked = true	-- is the button locked
	DB.Action1.showGlow = false	-- Place glow around correponding action button
	DB.Action1.size = 64	-- size of button
	DB.Action1.x = 0	-- x position of center of button relative to center of UI
	DB.Action1.y = -128	-- y position of the center of the button relative to center of UI
	DB.Action1.alpha = 1	--Transparency of button, 1 is opaque, 0 is transparent
	DB.Action1.borderShow = true	-- show border for this button
	DB.Action1.borderColor = {0, 0, 0, 1}	-- Black, default color of border when not at range or AOEing
	DB.Action1.borderColorRange = {1, 0, 0, 1}	-- Red, default color of border when target is at range and using ranged priority
	DB.Action1.borderColorAOE = {1, 1, 1, 1}	-- White, default color of border when AOEing and using AOE priority
	DB.Action1.borderThickness = 2		-- 1 = light, 2 = medium, 3 = heavy
	DB.Action1.point = "CENTER"	-- reference point on button
	DB.Action1.pointParent = "CENTER" -- reference point on parent
	-- Action2: Secondary Action Priority button, Action1 is its parent
	DB.Action2.show = true	-- should the button be shown 
	DB.Action2.locked = true	-- is the button locked
	DB.Action2.size = 32	-- size of button
	DB.Action2.x = 32	-- x position of center of button relative to its parent
	DB.Action2.y = 0	-- y position of the center of the button relative to its parent
	DB.Action2.alpha = 1	--Transparency of button, 1 is opaque, 0 is transparent
	DB.Action2.borderShow = true	-- show border for this button
	DB.Action2.borderColor = {0, 0, 0, 1}	-- Black, default color of border when not at range or AOEing
	DB.Action2.borderColorRange = {1, 0, 0, 1}	-- Red, default color of border when target is at range and using ranged priority
	DB.Action2.borderColorAOE = {1, 1, 1, 1}	-- White, default color of border when AOEing and using AOE priority
	DB.Action2.borderThickness = 2		-- 1 = light, 2 = medium, 3 = heavy
	DB.Action2.point = "BOTTOMLEFT"	-- reference point on button
	DB.Action2.pointParent = "BOTTOMRIGHT" -- reference point on parent
	-- CD1: Main Cooldown Priority button
	DB.CD1.show = true	-- should the button be shown 
	DB.CD1.locked = true	-- is the button locked
	DB.CD1.size = 64	-- size of button
	DB.CD1.x = -160	-- x position of center of button relative to center of UI
	DB.CD1.y = -128	-- y position of the center of the button relative to center of UI
	DB.CD1.alpha = 1	--Transparency of button, 1 is opaque, 0 is transparent
	DB.CD1.borderShow = true	-- show border for this button
	DB.CD1.borderColor = {0, 0, 0, 1}	-- Black, default color of border when not on CD
	DB.CD1.borderColorCD = {.5, .5, .5, 1}	-- Gray, default color of border when action is on CD
	DB.CD1.buttonColorClear = {1, 1, 1, 1} 	-- Transparent, default color of tinting of button when action is not on CD
	DB.CD1.buttonColorCD = {.5, .5, .5, 1}	-- Gray, default color of tinting of button when action is on CD
	DB.CD1.borderColorCDUser = {0, 1, 0, 1}	-- Green, default color when action is on a user set cd or is resource limited
	DB.CD1.borderThickness = 2		-- 1 = light, 2 = medium, 3 = heavy
	DB.CD1.point = "CENTER"	-- reference point on button
	DB.CD1.pointParent = "CENTER" -- reference point on parent
	-- CD2: Secondary Cooldown Priority button, Action1 is its parent
	DB.CD2.show = true	-- should the button be shown 
	DB.CD2.locked = true	-- is the button locked
	DB.CD2.size = 32	-- size of button
	DB.CD2.x = 32	-- x position of center of button relative to its parent
	DB.CD2.y = 0	-- y position of the center of the button relative to its parent
	DB.CD2.alpha = 1	--Transparency of button, 1 is opaque, 0 is transparent
	DB.CD2.borderShow = true	-- show border for this button
	DB.CD2.borderColor = {0, 0, 0, 1}	-- Black, default color of border when not on CD
	DB.CD2.borderColorCD = {.5, .5, .5, 1}	-- Gray, default color of border when action is on CD
	DB.CD2.buttonColorClear = {1, 1, 1, 1} 	-- Transparent, default color of tinting of button when action is not on CD
	DB.CD2.buttonColorCD = {.5, .5, .5, 1}	-- Gray, default color of tinting of button when action is on CD
	DB.CD2.borderColorCDUser = {0, 1, 0, 1}	-- Green, default color when action is on a user set cd or is resource limited
	DB.CD2.borderThickness = 2		-- 1 = light, 2 = medium, 3 = heavy
	DB.CD2.point = "BOTTOMLEFT"	-- reference point on button
	DB.CD2.pointParent = "BOTTOMRIGHT" -- reference point on parent
end
function addonTable.ResetDBLB()
	-- AOELabel: Secondary Cooldown Priority button, CD2 is its parent
	DB.AOELabel.show = true	-- should the label be shown 
	DB.AOELabel.showAlways = false	-- Show label even when not AOEing
	DB.AOELabel.locked = true	-- is the label locked
	DB.AOELabel.fontSize = 30	-- size of font
	DB.AOELabel.x = 0	-- x position of center of button relative to its parent
	DB.AOELabel.y = -10	-- y position of the center of the button relative to its parent
	DB.AOELabel.alpha = 1	--Transparency of button, 1 is opaque, 0 is transparent
	DB.AOELabel.fontColor = {1, 1, 1, 1}	-- White, default color of border when not at range or AOEing
	DB.AOELabel.includePeriodic = true -- Include periodic damage from dots and DnD when calculating number of targets
	DB.AOELabel.AOEWindow = 3	-- This parameter (in secs) controls the timeframe in which damage to 
					-- targets counts toward the number of targets
	DB.AOELabel.AOEPrefix = "AOE: "	-- Prefix to place before number of targets
	DB.AOELabel.point = "TOP"	-- reference point on button
	DB.AOELabel.pointParent = "BOTTOM" -- reference point on parent
	-- TTDLabel: Secondary Cooldown Priority button, Action1 is its parent
	DB.TTDLabel.show = true	-- should the label be shown 
	DB.TTDLabel.showAlways = false	-- Show label at all times
	DB.TTDLabel.window = 10 -- Window for the sampling average in estimating TTD
	DB.TTDLabel.locked = true	-- is the label locked
	DB.TTDLabel.fontSize = 30	-- size of font
	DB.TTDLabel.x = 0	-- x position of center of button relative to its parent
	DB.TTDLabel.y = 10	-- y position of the center of the button relative to its parent
	DB.TTDLabel.alpha = 1	--Transparency of button, 1 is opaque, 0 is transparent
	DB.TTDLabel.fontColor = {1, 1, 1, 1}	-- White, default color of border when not at range or AOEing
	DB.TTDLabel.TTDPrefix = "TTD: "	-- Prefix to place before time to die
	DB.TTDLabel.TTDMaxDisplay = 600	-- Time to die must be less than this for TTD label to display (Max TTD is 600 secs)
	DB.TTDLabel.point = "BOTTOM"	-- reference point on button
	DB.TTDLabel.pointParent = "TOP" -- reference point on parent
	-- CDText: Secondary Cooldown Priority button, CD2 is its parent
	DB.CDText.show = true	-- should the label be shown 
	DB.CDText.locked = true	-- is the label locked
	DB.CDText.fontSize = 30	-- size of font
	DB.CDText.x = 0	-- x position of center of label relative to its parent
	DB.CDText.y = 0	-- y position of the center of the label relative to its parent
	DB.CDText.alpha = 1	--Transparency of label, 1 is opaque, 0 is transparent
	DB.CDText.CDLong = 5 -- Time left on Cd when we switch from fontColorLong to fontColorShort
	DB.CDText.fontColorLong = {1, 1, 0, 1}	-- Yellow, color of font when native cooldown is more than 5 secs
	DB.CDText.fontColorShort = {1, 0, 0, 1}	-- Red, color of font when native cooldown is less than 5 secs
	DB.CDText.fontColorUser = {0, 1, 0, 1}	-- Green, color of font when on user or resource driven cooldown
	DB.CDText.point = "CENTER"	-- reference point on Label
	DB.CDText.pointParent = "CENTER" -- reference point on parent
end
function addonTable.ResetDBRot()
	-- rotation
	-- RotationFrost: Priorities while in frost spec
	-- Default is 2H, for mop we add dual wield
	DB.RotationFrost.prio = "fpres howbuff pil out ublight ffHB pl bpPS obkm srf btKM ob22 ob2 bt10 fs rime how ob111 ob bt5 erw"	-- Generic priority
	DB.RotationFrost.prioR = "fpres howbuff out hb pl dc dnd how"	-- Priority while at range
	DB.RotationFrost.prioAOE = "fpres howbuff pil bt5 srf out ublight hb11 fs90 hb2 rime fs60 bpPS ob2u hb fs how erw"	-- Priority while AOEing
	DB.RotationFrost.prioCD = "rdmax malv da erw rw asphyx"	-- Cooldown priority
	DB.RotationFrost.aoenum = 3 -- number of targets necessary to trigger aoe priority while Frost specced
	-- RotationFrost: Priorities while in dual wield frost spec
	-- Default is 2H, for mop we add dual wield
	DB.RotationFrostDW.prio = "fpres howbuff pil out ublight ffHB pl bpPS fs bt5 srf rime ob hb how erw"	-- Generic priority
	DB.RotationFrostDW.prioR = "fpres howbuff out hb pl dc dnd how"	-- Priority while at range
	DB.RotationFrostDW.prioAOE = "fpres howbuff pil bt5 srf ublight out hb11 fs90 hb2 rime fs60 bpPS ob2u hb fs how erw"	-- Priority while AOEing
	DB.RotationFrostDW.prioCD = "rdmax malv da erw rw asphyz"	-- Cooldown priority
	DB.RotationFrostDW.aoenum = 3 -- number of targets necessary to trigger aoe priority while Frost specced
	-- RotationUnholy: Priorities while in unholy spec
	DB.RotationUnholy.prio = "upres howbuff rd bt5 dt sru dcnohulk dcams out ublight pl fesFFBP itFF bpPS dnd2110 ss2110 fes22110 fes11d11 dc90 doom dnd ss fes dc erw how"	-- Generic priority
	DB.RotationUnholy.prioR = "upres howbuff rd bt5 dt out pl itFF dnd2110 dc90 dnd dc how"	-- Priority while at range
	DB.RotationUnholy.prioAOE = "upres howbuff rd uf dt sg sru ublight out bt5 itFF bpPS dnd fes22110 dc bb bt erw how"	-- Priority while AOEing
	DB.RotationUnholy.prioCD = " uf rd malv sg da erw rw asphyx"	-- Cooldown priority
	DB.RotationUnholy.aoenum = 4 -- number of targets necessary to trigger aoe priority while Unholy specced
	-- RotationBlood: Priorities while in blood spec
	DB.RotationBlood.prio = "bpres howbuff outdebuff itdebuff bpdebuff bone bt5 vb50 pact50 out ublight pl ds rt75won srb rs60 rt50 itFF bpPS hs15 how"	-- Generic priority
	DB.RotationBlood.prioR = "bpres howbuff bone bt5 vb50 pact50 out pl rt75won rt50 dnd dc bb how"	-- Priority while at range
	DB.RotationBlood.prioAOE = "bpres howbuff bt5 bone rd vb50 pact50 rt75won rt50 dnd ublight out srb bb rs how"	-- Priority while AOEing
	DB.RotationBlood.prioCD = "bone rd vb drw icef pact50 da erw rw ams earthen"	-- Cooldown priority
	DB.RotationBlood.aoenum = 5 -- number of targets necessary to trigger aoe priority while Blood specced
	-- RotationNone: Priorities while in No spec, set to blank for now
	DB.RotationNone.prio = "itFF bpPS bs dc"	-- Generic priority
	DB.RotationNone.prioR = "itFF dc"	-- Priority while at range
	DB.RotationNone.prioAOE = "itFF bpPS bs dc"	-- Priority while AOEing
	DB.RotationNone.prioCD = "bf dg"	-- Cooldown priority
	DB.RotationNone.aoenum = 3 -- number of targets necessary to trigger aoe priority while not specced
end
function addonTable.ResetDBRF()
	-- RuneFrame: Rune Display
	DB.RuneFrame.locked = true	-- is the Display locked
	DB.RuneFrame.x = 0	-- x position of center of Display relative to center of UI
	DB.RuneFrame.y = -330	-- y position of the center of the Display relative to center of UI
	DB.RuneFrame.colorRFbg = {0, 0, 0, 1} -- RuneFrame background color
	DB.RuneFrame.runeOrder = 4 -- There are 6 possible runeorders, they are, from top to bottom or left to right,
	-- 1 == BBUUFF
	-- 2 == BBFFUU
	-- 3 == UUBBFF
	-- 4 == UUFFBB
	-- 5 == FFBBUU
	-- 6 == FFUUBB
	-- Individual rune Statusbars
	DB.RuneFrame.runeOrientation = "HORIZONTAL" -- Which way rune bars are oriented "HORIZONTAL" or "VERTICAL"
	DB.RuneFrame.widthR = 50 -- Length of an individual rune statusbar, the overall display is sized to match the runes
	DB.RuneFrame.heightR = 12 -- Height of an individual rune statusbar, the overall display is sized to match the runes
	DB.RuneFrame.padding = 4 -- Space between Runes
	DB.RuneFrame.colorRbg = { .1, .1, .1, 1} -- Color behind runes
	DB.RuneFrame.showRlabels = false -- Show time left on each rune bar
	DB.RuneFrame.formatRlabels = 2 -- 1 = 4.5, 2 == 4, 3 = 4.5/8.5, 4 = 4/8  first number would be time left on rune, 2nd number is total time
	DB.RuneFrame.offxRlabels = 0 -- x offset for runelabels from center of bar
	DB.RuneFrame.offyRlabels = 0	-- y offset for runelabels from center of bar
	DB.RuneFrame.fontsizeRlabels = 10 -- fontsize of runelabels
	DB.RuneFrame.doFlash = true -- Should runes flash when they come off CD
	DB.RuneFrame.flashTimer = .3 -- How long in secs do runes flash after finishing refresh
	DB.RuneFrame.colorR[1] = { 0.77, 0.12, 0.23, 1} -- Blood
	DB.RuneFrame.colorR[2] = { 0.3, 0.8, 0.1, 1} 	-- Unholy
	DB.RuneFrame.colorR[3] = { 0, 0.4, 0.7, 1}		-- Frost
	DB.RuneFrame.colorR[4] = { 0.51, 0.19, 0.67, 1}	-- Death
	DB.RuneFrame.colorRdark[1] = { 0.6, 0.1, 0.21, 1} -- Blood
	DB.RuneFrame.colorRdark[2] = { 0.20, 0.52, 0.07, 1} 	-- Unholy
	DB.RuneFrame.colorRdark[3] = { 0, 0.33, 0.58, 1} 		-- Frost
	DB.RuneFrame.colorRdark[4] = { 0.41, 0.20, 0.52, 1}	-- Death
	DB.RuneFrame.colorRlight[1] = { 0.99, 0.27, 0.51, 1} -- Blood
	DB.RuneFrame.colorRlight[2] = { 0.68, 0.99, 0.46, 1} 	-- Unholy
	DB.RuneFrame.colorRlight[3] = { 0.27, 0.73, 0.99, 1} 		-- Frost
	DB.RuneFrame.colorRlight[4] = { 0.8, 0.32, 0.99, 1}	-- Death
	-- Frost Fever and Blood Plague
	DB.RuneFrame.showDots = true -- Show the Dots Statsubars
	DB.RuneFrame.orientDots = "HORIZONTAL" -- Orientation of Dots statusbar
	DB.RuneFrame.widthDots = 30 -- Width of Dots Statusbar
	DB.RuneFrame.heightDots = 12 -- Height of Dots Statusbar
	DB.RuneFrame.showDlabels = true -- Show time left on each Dots bar
	DB.RuneFrame.formatDlabels = 2 -- 1 = 4.5, 2 == 4, 3 = 4.5/8.5, 4 = 4/8  first number would be time left on Dots, 2nd number is total time
	DB.RuneFrame.offxDlabels = 0 -- x offset for Dots label from center of bar
	DB.RuneFrame.offyDlabels = 4	-- y offset for Dots labels from center of bar
	DB.RuneFrame.fontsizeDlabels = 14 -- fontsize of Dots labels
	DB.RuneFrame.pointFF = "BOTTOMLEFT" -- Reference point of Frost Fever Statusbar
	DB.RuneFrame.pointFFparent = "TOPLEFT" -- Reference point on parent of Frost Fever Statusbar
	DB.RuneFrame.offxFF = 0 -- x offset of Frost Fever Statusbar
	DB.RuneFrame.offyFF = 0 -- y offset of Frost Fever Statusbar
	DB.RuneFrame.pointBP = "BOTTOMRIGHT" -- Reference point of Blood Plague Statusbar
	DB.RuneFrame.pointBPparent = "TOPRIGHT" -- Reference point on parent of Blood Plague Statusbar
	DB.RuneFrame.offxBP = 0 -- x offset of Blood Plague Statusbar
	DB.RuneFrame.offyBP = 0 -- y offset of Blood Plague Statusbar
	DB.RuneFrame.colorFF = {0, 0.5, 1, 1} -- Color of Frost Fever Statusbar
	DB.RuneFrame.colorFFbg = {0, 0.06, .125, 1} -- Color of background of Frost Fever Statusbar
	DB.RuneFrame.colorBP = {0.70, 0.2, 0.3, 1} -- Color of Blood Plague Statusbar
	DB.RuneFrame.colorBPbg = {0.15, 0.05, .16, 1} -- Color of background of Blood Plague Statusbar
	-- Runic Power
	DB.RuneFrame.showRP = true -- Show the Runic Power Statusbar
	DB.RuneFrame.orientRP = "HORIZONTAL" -- Orientation of Dots statusbar
	DB.RuneFrame.heightRP = 15 -- height of Runic Power statusbar
	DB.RuneFrame.widthRP = 0 -- width of Runic Power statusbar, defaults to width of Runeframe if set to 0
	DB.RuneFrame.showRPlabels = true -- Show time left on Runic Power bar
	DB.RuneFrame.formatRPlabels = 2 -- 2 == 43, 4 = 32/100 first number would be Runic Power, 2nd number is total Runic Power
	DB.RuneFrame.offxRPlabels = 0 -- x offset for Runic Power label from center of bar
	DB.RuneFrame.offyRPlabels = 0	-- y offset for Runic Power labels from center of bar
	DB.RuneFrame.fontsizeRPlabels = 14 -- fontsize of Runic Power labels
	DB.RuneFrame.pointRP = "TOP" -- Reference point of Runic Power Statusbar
	DB.RuneFrame.pointRPparent = "BOTTOM" -- Reference point on parent of Runic Power Statusbar
	DB.RuneFrame.offxRP = 0 -- x offset of Runic Power Statusbar
	DB.RuneFrame.offyRP = 0 -- y offset of Runic Power Statusbar
	DB.RuneFrame.colorRP = {0, 0.8, 1, 1} -- Color of Runic Power Statusbar
	DB.RuneFrame.colorRPbg = {0, 0.1, .125, 1} -- Color of background of Runic Power Statusbar
	--colorRPspark = {1, 1, 1, 1}, -- Color of spark texture TODO This doesnt seem to work
	DB.RuneFrame.showSpark = true -- Show lines dividing RP bar
	-- Button 1
	DB.RuneFrame.showB1 = true -- Show the B1 button
	DB.RuneFrame.sizeB1 = 48 -- Size of Button
	DB.RuneFrame.pointB1 = "BOTTOM" -- Referenece point of button
	DB.RuneFrame.pointB1parent = "TOP" -- Reference point of parent
	DB.RuneFrame.offxB1 = 0 -- x offset of Button
	DB.RuneFrame.offyB1 = 50 -- y offset of Button
	DB.RuneFrame.showB1labels = true -- Show time left on Runic Power bar
	DB.RuneFrame.offxB1labels = 0 -- x offset for Runic Power label from center of bar
	DB.RuneFrame.offyB1labels = 0	-- y offset for Runic Power labels from center of bar
	DB.RuneFrame.fontsizeB1labels = 18 -- fontsize of Runic Power labels
	DB.RuneFrame.fontColorB1 = {1, 0, 0, 1} -- Red
	-- Button 2
	DB.RuneFrame.showB2 = true -- Show the B2 button
	DB.RuneFrame.sizeB2 = 32 -- Size of Button
	DB.RuneFrame.pointB2 = "BOTTOM" -- Referenece point of button
	DB.RuneFrame.pointB2parent = "TOP" -- Reference point of parent
	DB.RuneFrame.offxB2 = 0 -- x offset of Button
	DB.RuneFrame.offyB2 = 8 -- y offset of Button
	DB.RuneFrame.showB2labels = true -- Show time left on Runic Power bar
	DB.RuneFrame.offxB2labels = 0 -- x offset for Runic Power label from center of bar
	DB.RuneFrame.offyB2labels = 0	-- y offset for Runic Power labels from center of bar
	DB.RuneFrame.fontsizeB2labels = 18 -- fontsize of Runic Power labels
	DB.RuneFrame.fontColorB2 = {1, 0, 0, 1} -- Red
	-- Button 3
	DB.RuneFrame.showB3 = true -- Show the B3 button
	DB.RuneFrame.sizeB3 = 32 -- Size of Button
	DB.RuneFrame.pointB3 = "TOPRIGHT" -- Referenece point of button
	DB.RuneFrame.pointB3parent = "TOPLEFT" -- Reference point of parent
	DB.RuneFrame.offxB3 = 0 -- x offset of Button
	DB.RuneFrame.offyB3 = 0 -- y offset of Button
	DB.RuneFrame.showB3labels = true -- Show time left on Runic Power bar
	DB.RuneFrame.offxB3labels = 0 -- x offset for Runic Power label from center of bar
	DB.RuneFrame.offyB3labels = 0	-- y offset for Runic Power labels from center of bar
	DB.RuneFrame.fontsizeB3labels = 18 -- fontsize of Runic Power labels
	DB.RuneFrame.fontColorB3 = {1, 0, 0, 1} -- Red
	-- Button 4
	DB.RuneFrame.showB4 = true -- Show the B4 button
	DB.RuneFrame.sizeB4 = 32 -- Size of Button
	DB.RuneFrame.pointB4 = "TOPLEFT" -- Referenece point of button
	DB.RuneFrame.pointB4parent = "TOPRIGHT" -- Reference point of parent
	DB.RuneFrame.offxB4 = 0 -- x offset of Button
	DB.RuneFrame.offyB4 = 0 -- y offset of Button
	DB.RuneFrame.showB4labels = true -- Show time left on Runic Power bar
	DB.RuneFrame.offxB4labels = 0 -- x offset for Runic Power label from center of bar
	DB.RuneFrame.offyB4labels = 0	-- y offset for Runic Power labels from center of bar
	DB.RuneFrame.fontsizeB4labels = 18 -- fontsize of Runic Power labels
	DB.RuneFrame.fontColorB4 = {1, 0, 0, 1} -- Red
	-- Blood Shield
	DB.RuneFrame.showBS = true -- Show the Runic Power Statusbar
	DB.RuneFrame.showBSempty = true --Show Blood Shield Bar even when empty
	DB.RuneFrame.orientBS = "HORIZONTAL" -- Orientation of Dots statusbar
	DB.RuneFrame.heightBS = 30 -- height of Runic Power statusbar
	DB.RuneFrame.widthBS = 0 -- width of Runic Power statusbar, defaults to width of Runeframe if set to 0
	DB.RuneFrame.showBSlabels = true -- Show time left on Runic Power bar
	DB.RuneFrame.showBSlabelszero = true  -- Show label even when its zero
	DB.RuneFrame.offxBSlabels = 0 -- x offset for Runic Power label from center of bar
	DB.RuneFrame.offyBSlabels = 0	-- y offset for Runic Power labels from center of bar
	DB.RuneFrame.fontsizeBSlabels = 18 -- fontsize of Runic Power labels
	DB.RuneFrame.pointBS = "TOP" -- Reference point of Runic Power Statusbar
	DB.RuneFrame.pointBSparent = "BOTTOM" -- Reference point on parent of Runic Power Statusbar
	DB.RuneFrame.offxBS = 0 -- x offset of Runic Power Statusbar
	DB.RuneFrame.offyBS = -20 -- y offset of Runic Power Statusbar
	DB.RuneFrame.colorBS = {0.70, 0.2, 0.3, 1} -- Color of Runic Power Statusbar
	DB.RuneFrame.colorBSbg = {0.15, 0.05, .16, 1} -- Color of background of Runic Power Statusbar
	DB.RuneFrame.showBSSpark = true	-- Show BS duration Spark
	DB.RuneFrame.sparkWidth = 8 	-- Spark Width
	DB.RuneFrame.sparkHeight = 8 	-- Spark Height
	--DKOneDB.RuneFrame.sparkSide = "BOTTOM"	-- Show spark along bottom TODO This isnt implemented, not sure if its necessary
	--DKOneDB.RuneFrame.sparkDir = "LEFTtoRIGHT" -- Spark Direction
end
function addonTable.ResetDBValues()
	ConstructDB()
	-- These functions can also be called individually from the options file
	addonTable.ResetDB()
	addonTable.ResetDBAD()
	addonTable.ResetDBLB()
	addonTable.ResetDBRot()
	addonTable.ResetDBRF()
end

-- We make a local reference since we call the database variable so frequently
--local DB = DKOneDB
-- Function to return cooldown on a rune
local function RuneCD(rune, currentTime) 	
	runeStart, runeDuration, runeReady = GetRuneCooldown(rune) -- Blizz API
	if runeReady then -- rune is off CD
		return 0
	else
		runeCD = runeStart + runeDuration - currentTime -- Time remaining on rune CD
		if runeCD < 0 then 	-- Annoyingly this can return negative numbers when a rune is almost refreshed
			return 0		-- So we check and set to zero if this is the case
		else
			return runeCD
		end
	end
end
-- This goes through and counts all the runes off CD
local function CountRunesOffCD()
	for i = 1,3 do -- Go through each rune type
		-- Intialize number of runes off CD to zero
		DKStatus.RuneCD[i] = 0
		DKStatus.DRuneCD[i] = 0
		-- First rune of type  1,3,5
		if DKStatus[r1order[i]] == 0 then -- 0 would indicate its off CD
			if DKStatus.NotDeath[2*i - 1] then -- increment the correct count
				DKStatus.RuneCD[i] = DKStatus.RuneCD[i] + 1
			else
				DKStatus.DRuneCD[i] = DKStatus.DRuneCD[i] + 1
			end
		end
		-- Second rune of type  2,4,6
		if DKStatus[r2order[i]] == 0 then -- 0 would indicate its off CD
			if DKStatus.NotDeath[2*i] then -- increment the correct count
				DKStatus.RuneCD[i] = DKStatus.RuneCD[i] + 1
			else
				DKStatus.DRuneCD[i] = DKStatus.DRuneCD[i] + 1
			end
		end
	end
	-- the 4th deathrune count is just a sum of all 3 types
	DKStatus.DRuneCD[4] = DKStatus.DRuneCD[1] + DKStatus.DRuneCD[2] + DKStatus.DRuneCD[3]
end
-- Goes through the aoeTargets table and gets rid of old entries
local function ClearOldAOETargets(currentTime) -- aoeTargets is a hash table with key = destGUID and value = timestamp
	oldTime = currentTime - DB.AOELabel.AOEWindow -- Time stamp older than the aoe window
	for k,v in pairs(aoeTargets) do -- Go through all the destGUIDs in table
		if v < oldTime then -- for those with timestamps outside the aoe window
			aoeTargets[k] = nil -- remove them
			numtargets = numtargets - 1 -- decrease the count of aoe targets by 1
		end
	end
end
-- Update all the fields in the DKStatus table to their current value
local function UpdateStatus()
	DKStatus.Time = GetTime() -- Current game time
	ClearOldAOETargets(DKStatus.Time) -- Goes through the aoeTargets table and gets rid of old entries
	-- Compare the current number of active targets to the spec specific AOE threshold
	if numtargets >= DKPlayerStats.Rotation.aoenum then
		DKStatus.AOE = true
	else
		DKStatus.AOE = false
	end
	
	-- gcd value, we use a presence change since it doesnt require resources and is never on cooldown
	start, duration = GetSpellCooldown(48266) -- Use the SpellID of Frost Presence to calculate time left in GCD
	if start == 0 then
		DKStatus.GCDLeft = 0
	else
		DKStatus.GCDLeft = start + duration - DKStatus.Time	-- time left in GCD
	end
	--DKStatus.Presence = GetShapeshiftForm(nil) -- The presence the player is in
	-- The stupid event that is suppose to fire when you change presences is spammy and not reliable I found
	-- So I just check it continously, may revisit this later and make it an event though
	-- GCD is always 1 sec now
	--[[if DKStatus.Presence == 3 then -- This GCD is just the time between button presses, not the current cooldown on the GCD
		DKStatus.GCD = 1
	else -- This may just be an estimate, other haste effects not given by Combat rating bonus would effect it
		DKStatus.GCD = 1.5/(1+GetCombatRatingBonus(20)/100) 
	end]]
	if DKStatus.Presence == 2 then
		aL.FrostStrike.Cost[5] = 20
	end
	DKStatus.RP = UnitPower("player", 6) -- Current Runic Power
	-- Get the current cooldown on each rune, determine which ones are not Death runes
	for i = 1,6 do
		DKStatus[runeorder[i]] =  RuneCD(i, DKStatus.Time)
		DKStatus.NotDeath[i]  = GetRuneType(i) ~= 4 and true or false -- NotDeath is true if rune is not type Death Rune, otherwise false
	end
	-- This function just counts up how many runes of each type are off cooldown
	-- it sets the DKStatus.RuneCD and DKStatus.DRuneCD tables
	CountRunesOffCD() --Update DKStatus.RuneCD
	
	-- How long it currently takes a rune to come off cooldown when fully depleted
	_, DKStatus.RuneDur, _ = GetRuneCooldown(1)
	-- The players current health percentage
	DKStatus.Health = UnitHealth("player")
	DKStatus.MaxHealth = UnitHealthMax("player")
	DKStatus.PerHealth = 100*DKStatus.Health/DKStatus.MaxHealth
		
	-- This function was a pain in the ass to find for some obscure reason /sarc	
	DKStatus.HasPet, _, start, duration = GetTotemInfo(1)
	cd = start + duration - DKStatus.Time
	if cd <= 0 then 
		DKStatus.PetDur = 0
	else
		DKStatus.PetDur = cd
	end
	-- Check Debuffs on current target, specifically diseases
	if true then
		_,_,_,_,_,_,myff = UnitAura("Target", aL.FrostFever.Name, nil, "PLAYER|HARMFUL") -- Check duration of my frost fever
		_,_,_,_,_,_,mybp = UnitAura("Target", aL.BloodPlague.Name, nil, "PLAYER|HARMFUL") -- Check duration of my blood plague
		if myff == nil then
			DKStatus.FF = 0
		else
			DKStatus.FF = myff - DKStatus.Time
		end
		if mybp == nil then
			DKStatus.BP = 0
		else
			DKStatus.BP = mybp - DKStatus.Time
		end
	end
	if DKPlayerStats.BloodTap then
		DKStatus.BC = aL.BloodCharge:GetStacks()
	else
		DKStatus.BC = 0
	end
	-- Spec specific  buffs
	if DKPlayerStats.Spec == 1 then
		-- Check for Will of Necropolis buff, 2 different componenets, free rune tap, 96171, and damage reduction, 81162
		-- this is just checking for the free rune tap, since the names are the same we have to check by SpellId
		-- which is why we have the true in the function call
		DKStatus.WON = aL.WillOfTheNecropolis:GetBuff(true) -- Free rune tap buff from the will of Necropolis talent 
		DKStatus.VB = aL.VampiricBlood:GetBuffDur(DKStatus.Time) 
		DKStatus.Bone = aL.BoneShield:GetStacks()
		DKStatus.SoB = aL.ScentOfBlood:GetStacks()
		DKStatus.BS = select(14,UnitAura("player", aL.BloodShield.Name, nil, "PLAYER|HELPFUL")) or 0 --Value of BloodShield
		DKStatus.BSDur = aL.BloodShield:GetBuffDur(DKStatus.Time)
		-- Check for Tank Debuffs
		--[[if DKStatus.TargetHostile then -- Only check if its a hostile target
			if DKStatus.FF == 0 then
				if (UnitAura("Target", aL.InfectedWounds.Name, nil, "HARMFUL")) or (UnitAura("Target", aL.JudgementsOfTheJust.Name, nil, "HARMFUL")) or (UnitAura("Target", aL.Thunderclap.Name, nil, "HARMFUL")) or (UnitAura("Target", aL.FrostFever.Name, nil, "HARMFUL")) then
					DKStatus.ASDebuff = true
				else
					DKStatus.ASDebuff = false
				end
			else
				DKStatus.ASDebuff = true
			end
			if DKStatus.BP == 0 then
				if (UnitAura("Target", aL.DemoralizingRoar.Name, nil, "HARMFUL")) or (UnitAura("Target", aL.Vindication.Name, nil, "HARMFUL")) or (UnitAura("Target", aL.DemoralizingShout.Name, nil, "HARMFUL")) or (UnitAura("Target", aL.ScarletFever.Name, nil, "HARMFUL")) then
					DKStatus.PDRDebuff = true
				else
					DKStatus.PDRDebuff = false
				end
			else
				DKStatus.PDRDebuff = true
			end
		else
			DKStatus.ASDebuff = false
			DKStatus.PDRDebuff = false
		end]]
	end
	if DKPlayerStats.Spec == 2 then
		DKStatus.Rime = aL.Rime:GetStacks() -- Freezing Fog Buff from Rime talent
		-- Check for Killing Machine buff
		DKStatus.KM = aL.KillingMachine:GetBuff() -- Killing machine buff from the killing machine talent
		DKStatus.Pillar = aL.PillarOfFrost:GetBuffDur(DKStatus.Time)
		start, duration = GetSpellCooldown(aL.PillarOfFrost.SpellId)
		cd = start + duration - DKStatus.Time
		if cd <= 0 then 
			DKStatus.PillarCD = 0
		else
			DKStatus.PillarCD = cd
		end
		DKStatus.RotFC = aL.RuneOfTheFallenCrusader:GetBuffDur(DKStatus.Time)
	end
	
	if DKPlayerStats.Spec == 3 then
		-- Some of these buffs are on pet so we use original functions
		DKStatus.HasPet = UnitName("pet") and true or false
		--Cant use the abilities:GetBuff() function because buff is on pet
		_,_,_,DKStatus.SI = UnitAura("pet", aL.ShadowInfusion.Name, nil, "HELPFUL" ) -- Shadow Infusion, Get stacks
		DKStatus.SI = DKStatus.SI or 0
		-- Pet is Hulked out
		_,_,_,_,_,_,myhulk = UnitAura("pet", aL.DarkTransformation.Name, nil, "HELPFUL" ) -- Dark Transformation Buff
		if myhulk == nil then
			DKStatus.Hulk = 0
		else
			DKStatus.Hulk = myhulk - DKStatus.Time
		end
		DKStatus.Doom = aL.SuddenDoom:GetStacks()  -- With T13 2pc can have up to 2 stacks of sudden doom	
		DKStatus.RotFC = aL.RuneOfTheFallenCrusader:GetBuffDur(DKStatus.Time)
		DKStatus.UF = aL.UnholyFrenzy:GetBuffDur(DKStatus.Time)
	end
	-- Check for any of the AP buffs
	DKStatus.APBuff = aL.HornOfWinter:GetBuff() or aL.BattleShout:GetBuff() or aL.TrueshotAura:GetBuff()
	
	-- Check for bloodlust buff
	DKStatus.BL = aL.Heroism:GetBuffDur(DKStatus.Time) + aL.Bloodlust:GetBuffDur(DKStatus.Time) + aL.TimeWarp:GetBuffDur(DKStatus.Time) + aL.AncientHysteria:GetBuffDur(DKStatus.Time)

	-- Check if current target is in range
	myrange = IsSpellInRange(aL.BloodStrike.Name, "target") -- we just use blood strike to check range
	-- Only sets out of melee if you have a current target, that target is attackable and that target is out of range
	if myrange == 0 and DKStatus.TargetHostile then
		DKStatus.Melee =  false
	else -- This will be true if you have no target, target is friendly, or if you are in melee range
		DKStatus.Melee =  true
	end
	-- We estimate a TTD (Time To Die) based on how much the bosses health has decreased in the last 3 seconds
	if DKStatus.TargetHostile then -- Only check if its a hostile target
		DKStatus.TargetHealth = UnitHealth("target") -- current health
		DKStatus.TargetPerHealth = 100*DKStatus.TargetHealth/UnitHealthMax("target")
		if oldTarget then -- Has filled up the Health Array
			difHealth = targetHealthArray[healthi] - DKStatus.TargetHealth
			difTime = DKStatus.Time - targetTimeArray[healthi]
			targetHealthArray[healthi] = DKStatus.TargetHealth
			targetTimeArray[healthi] = DKStatus.Time
		else -- Hasnt filled up the health array
			difHealth = targetHealthArray[1] - DKStatus.TargetHealth
			difTime = DKStatus.Time - targetTimeArray[1] 
			targetHealthArray[healthi] = DKStatus.TargetHealth
			targetTimeArray[healthi] = DKStatus.Time
			if healthi == numHealthArray then -- last entry in Health array
				oldTarget = true
			end
		end
		healthi = (healthi + 1)%numHealthArray -- we use modulo to wrap around healtharray index
		if difHealth <= 0  or difTime <= 0 then -- healing or not taking any damage
			DKStatus.TimeToDie = 601
		else -- we round it off and set a max of 10 minutes, the formula is just (current Health)*(difference in time/difference in health)
			DKStatus.TimeToDie = floor( min((DKStatus.TargetHealth*difTime/difHealth), 600) + .5)
		end
	else-- If we dont have a current target or its not hostile we set time to die to 601 and it's not displayed
		DKStatus.TimeToDie = 601
		DKStatus.TargetHealth = 1
		DKStatus.TargetPerHealth = 100
	end
		
	-- Check if the current target is a boss
	DKStatus.TargetIsBoss = UnitLevel("target") == -1 or (UnitLevel("target") >= UnitLevel("player") + 2 and not UnitInRaid("player"))
	DKStatus.Presence = GetShapeshiftForm(nil) -- The presence the player is in
	-- The stupid event that is suppose to fire when you change presences is spammy and not reliable I found
	-- So I just check it continously, may revisit this later and make it an event though
end

-- updates the 4 skill buttons
local function UpdateUI()
	-- Two sets of buttons, user may have 1 set turned off
	if DB.priorityActions then -- First we do the Priority action Buttons
		for i = 1,2 do
			Pbuttons[i].texture:SetTexture(DKPaction[i].Icon)
		end
		-- This was originally going to be a glow overlay of buttons on the actionbars
		-- but the default glows are already to many, so all the buttons end up being lit
		-- and it ended up not being worth it
		-- local oldAction
		--[[if DB.Action1.showGlow and DKPaction[1] ~= oldAction then
			if DKPaction[1].actionButton then
				ActionButton_ShowOverlayGlow(DKPaction[1].actionButton)
				if oldAction and oldAction.actionButton then
					ActionButton_HideOverlayGlow(oldAction)
				else
					print("Couldn't find OldAction: ", tostring(oldAction), tostring(oldAction and oldAction.Name))
				end
				oldAction = DKPaction[1]
			else
				print("Couldn't find button: ", DKPaction[1].Name)
			end
		end]]
		-- The main priority action button gets 2 other features, we show the global cooldown 
		-- on its face, and we color its border depending on whether target is at range and 
		-- whether we are in AOE mode. AOE takes priority over range since we often AOE at range
		start, duration = GetSpellCooldown(48266) -- This is the cooldown on changing to frost presence
		if duration and duration > 0 then	-- We use it to get the GCD left TODO, do I really need to do this twice an update?
			Pbuttons[1].cooldown:SetCooldown(start, duration)
			Pbuttons[1].cooldown:Show()
		else
			Pbuttons[1].cooldown:Hide() -- We hide the GCD if there isnt one
		end
		if DKStatus.AOE then -- Here we color the border of the main priority button
			Pbuttons[1].border:SetVertexColor(unpack(DB.Action1.borderColorAOE))
			Pbuttons[2].border:SetVertexColor(unpack(DB.Action2.borderColorAOE))
			if DB.AOELabel.show or DB.AOELabel.showAlways then
				Pbuttons[1].aoelabel:SetText(DB.AOELabel.AOEPrefix..numtargets) 	-- There is an AOE label under the button
				Pbuttons[1].aoelabel:Show()			-- showing the current number of targets
			else
				Pbuttons[1].aoelabel:Hide()	
			end
		else
			if DB.AOELabel.showAlways then
				Pbuttons[1].aoelabel:SetText(DB.AOELabel.AOEPrefix..numtargets)
				Pbuttons[1].aoelabel:Show()	
			else
				Pbuttons[1].aoelabel:Hide() -- We turn the AOE label off
			end
			if DKStatus.Melee then -- This is the default status
				Pbuttons[1].border:SetVertexColor(unpack(DB.Action1.borderColor))
				Pbuttons[2].border:SetVertexColor(unpack(DB.Action2.borderColor))
			else -- If we aren't AOEing and target is not in melee range we use the ranged priority incated here
				Pbuttons[1].border:SetVertexColor(unpack(DB.Action1.borderColorRange))
				Pbuttons[2].border:SetVertexColor(unpack(DB.Action2.borderColorRange))
			end
		end
		if DB.Action1.show then
			Pbuttons[1]:Show()
		else
			Pbuttons[1]:Hide()
		end
		if DB.Action2.show then
			Pbuttons[2]:Show()
		else
			Pbuttons[2]:Hide()
		end
		-- This displays the estimated time to die
		if DB.TTDLabel.show and DKStatus.TimeToDie <= DB.TTDLabel.TTDMaxDisplay and (not DB.TTDLabel.TTDBossOnly or DKStatus.TargetIsBoss) then
			Pbuttons[1].ttdlabel:SetText(DB.TTDLabel.TTDPrefix..DKStatus.TimeToDie)
			Pbuttons[1].ttdlabel:Show()
		else
			Pbuttons[1].ttdlabel:Hide()
		end
	else -- We hide the buttons
		Pbuttons[1]:Hide()
		Pbuttons[2]:Hide()
	end
	if DB.cdActions then -- Next we do the Cooldown action buttons
		for i = 1,2 do -- First, just display the icon associated with the cooldown action
			CDbuttons[i].texture:SetTexture(DKCDaction[i].Icon)
			-- Next we want to show the cooldown associated with the action on the button
			-- we may use the actions native cooldown or a user generated cooldown
			-- duration  > 10 tells us it's on a real cooldown and not the gcd or one generated by not having a free rune
			if DKCD[i].cd > 0 and DKCD[i].duration > 10 then 
				-- This turns off omnicc from overlaying a countdown timer on top of my cooldown
				CDbuttons[i].cooldown.noCooldownCount = true
				-- Just set the cooldown
				CDbuttons[i].cooldown:SetCooldown(DKCD[i].start, DKCD[i].duration)
				-- Color the border
				CDbuttons[i].border:SetVertexColor(unpack(DB.CD1.borderColorCD))
				-- Tint the actual icon
				CDbuttons[i].texture:SetVertexColor(unpack(DB.CD1.buttonColorCD))
				-- Text counting down the cooldown
				if DB.CDText.show then
					CDbuttons[i].cdtext:SetFormattedText("%d", DKCD[i].cd)
					-- Text changes color as the count down gets close
					if DKCD[i].cd > DB.CDText.CDLong then
						CDbuttons[i].cdtext:SetTextColor(unpack(DB.CDText.fontColorLong))
					else
						CDbuttons[i].cdtext:SetTextColor(unpack(DB.CDText.fontColorShort))
					end
					CDbuttons[i].cdtext:Show()
				else
					CDbuttons[i].cdtext:Hide()
				end
			-- In this case the action isnt on the standard cooldown, but we dont want to use it for some reason
			-- It may be that we dont have the resources or that we prefer to line it up with something else
			-- like a proc or a different cooldown
			elseif (0 < DKCD[i].cd and DKCD[i].cd < 997 and DKCD[i].duration == 0) or DKCD[i].duration == 10 or not DKCD[i].enoughrp then 
				-- if the cooldown is 0 then we dont have enough runic power, set cd to 2
				if not DKCD[i].enoughrp then
					DKCD[i].cd = 2
				end
				-- For DKs, cooldowns that use runes are put on a 10 sec CD if the rune is used
				-- so we weed those out so the actions aren't constantly shuffling as we use runes
				-- If we are missing a rune just set cd to 3
				if DKCD[i].duration == 10 then
					DKCD[i].cd = 3
				end
				-- we dont tint the actual button when on one of these types of cooldowns
				CDbuttons[i].texture:SetVertexColor(unpack(DB.CD1.buttonColorClear))
				-- We have a different color for the border to incicate this type of cooldown
				CDbuttons[i].border:SetVertexColor(unpack(DB.CD1.borderColorCDUser)) 
				if DB.CDText.show then -- We set a countdown time on its face
					CDbuttons[i].cdtext:SetFormattedText("%d", DKCD[i].cd)
					CDbuttons[i].cdtext:SetTextColor(unpack(DB.CDText.fontColorUser))
					CDbuttons[i].cdtext:Show()
				else
					CDbuttons[i].cdtext:Hide()
				end
				CDbuttons[i].cooldown:Hide()
			else -- Action is not on cooldown
				CDbuttons[i].texture:SetVertexColor(unpack(DB.CD1.buttonColorClear))
				CDbuttons[i].border:SetVertexColor(unpack(DB.CD1.borderColor))
				CDbuttons[i].cdtext:Hide()
				CDbuttons[i].cooldown:Hide()
			end	
		end
		if DB.CD1.show then
			CDbuttons[1]:Show()
		else
			CDbuttons[1]:Hide()
		end
		if DB.CD2.show then
			CDbuttons[2]:Show()
		else
			CDbuttons[2]:Hide()
		end
	else
		CDbuttons[1]:Hide()
		CDbuttons[2]:Hide()
	end
end

-- updates all the displayed elements
local function OnUpdate(self, elapsed)
	delay = delay + elapsed  	-- We only want to recalculate everything at a certain frequency that
								-- is usually less than the frame rate to save on computation
	if delay > DB.frequency then
		delay = 0 -- reset delay so it doesnt continue to trigger the if statement every time
		UpdateStatus() -- Used by priority actions, cooldown actions, and Rune Display
		if DB.showRF then
			Rune:updateRuneFrame() -- Calling DKOne.Rotation() changes the DKStatus variable, so we call everything else first
			Rune:Show()
		else
			Rune:Hide()
		end
		-- We allow the player to turn off updating and hide the buttons out of combat if they want
		if not DB.ShowOnlyInCombat or (DB.ShowOnlyInCombat and DKStatus.InCombat) or (DB.ShowAlwaysInRaid and DKPlayerStats.InAnyInstance) then
			if DB.cdActions then -- We are calculating the 2 CD actions
				-- This function is in the rotation file, it returns the 2 cooldown actions and their cooldown info
				DKCDaction[1], DKCDaction[2], DKCD[1].cd, DKCD[1].start, DKCD[1].duration, DKCD[2].cd, DKCD[2].start, DKCD[2].duration = addonTable.RotationCD()
				-- Check if there is enough runic power to perform the action
				DKCD[1].enoughrp = DKStatus.RP >= DKCDaction[1].Cost[5]
				if DKCDaction[2].Cost[5] > 0 then
					DKCD[2].enoughrp = DKStatus.RP >= DKCDaction[1].Cost[5] + DKCDaction[2].Cost[5]
				else
					DKCD[2].enoughrp = true
				end
			end
			if DB.priorityActions then -- We are calculating the 2 priority actions
				-- This function is in the rotation file, it returns the 2 actions it modifies the DKStatus table and should be called last
				DKPaction[1], DKPaction[2] = addonTable.Rotation()
			end
			UpdateUI() -- We update the button displays with the new info
		else -- Hide the buttons if we are not calculating the actions
			Pbuttons[1]:Hide()
			Pbuttons[2]:Hide()
			CDbuttons[1]:Hide()
			CDbuttons[2]:Hide()
		end
	end
end

-- create button
local function CreateButton(name, size, point, parent, pointParent, offsetx, offsety)
	name = "DKOneMain" .. name
	local button
	button = CreateFrame("Button", name , parent)
	button:EnableMouse(false)
	button:SetWidth(size)
	button:SetHeight(size)
	button.texture = button:CreateTexture("$parentIcon", "BACKGROUND")
	button.texture:SetAllPoints()
	button.texture:SetTexture(BGTEX)
	button.border = button:CreateTexture(nil, "BORDER") -- not $parentBorder so it can work when bf is enabled
	button.border:SetAllPoints()
	button.border:SetTexture(borderType[DB.Action1.borderThickness])
	button.border:SetVertexColor(DB.Action1.borderColor)
	button.cooldown = CreateFrame("Cooldown", "$parentCooldown", button)
	button.cooldown:SetAllPoints(button)
	button:ClearAllPoints()
	button:SetPoint(point, parent, pointParent, offsetx, offsety)
	-- This is a legacy option, not sure if its worth keeping, not implemented in Options choices
	if DB.zoomIcons then
		button.texture:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	end
	button:Hide()
	return button
end

-- initialize main frame and all the buttons
-- This creates all the frames, while redraw sets all the parameters
local function Init()
	Main:SetPoint("CENTER", UIParent, 0, 0)
	local texture = Main:CreateTexture(nil, "BACKGROUND")
	texture:SetAllPoints()
	texture:SetTexture(BGTEX)
	texture:SetVertexColor(unpack(DB.CD1.buttonColorClear))
	texture:Hide()
	Main.texture = texture
	Main:SetScale(DB.scale)
	
	opt = DB.Action1
	Main.Pbuttons[1] = CreateButton("Action1", opt.size, opt.point, Main, opt.pointParent, opt.x, opt.y)
	Main.Pbuttons[1]:RegisterForDrag("LeftButton")
	Main.Pbuttons[1]:SetScript("OnDragStart", function(self) self:StartMoving() end)
	Main.Pbuttons[1]:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		local centerx, centery = UIParent:GetCenter()
		DB.Action1.x = floor(self:GetLeft() + DB.Action1.size/2 - centerx/DB.scale + .5)
		DB.Action1.y = floor(self:GetBottom() + DB.Action1.size/2 - centery/DB.scale + .5)
	end)
		
	-- This is the aoe label code under the main action button
	Main.Pbuttons[1].aoelabel = Main.Pbuttons[1]:CreateFontString("$parentCount", "OVERLAY", "TextStatusBarText")
	Main.Pbuttons[1].aoelabel:SetJustifyH("CENTER")
	
	-- Time to die label above the main action  Button
	Main.Pbuttons[1].ttdlabel = Main.Pbuttons[1]:CreateFontString("$parentCount", "OVERLAY", "TextStatusBarText")
	Main.Pbuttons[1].ttdlabel:SetJustifyH("CENTER")
	
	-- init secondary skill button
	opt = DB.Action2
	Main.Pbuttons[2] = CreateButton("Action2", opt.size, opt.point, Main.Pbuttons[1], opt.pointParent, opt.x, opt.y)
	Main.Pbuttons[2]:RegisterForDrag("LeftButton")
	Main.Pbuttons[2]:SetScript("OnDragStart", function(self) self:StartMoving() end)
	Main.Pbuttons[2]:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		DB.Action2.x = floor(self:GetLeft() - Main.Pbuttons[1]:GetRight() + .5)
		DB.Action2.y = floor(self:GetBottom() - Main.Pbuttons[1]:GetBottom() + .5)
	end)
	-- Primary Cooldown button
	opt = DB.CD1
	Main.CDbuttons[1] = CreateButton("CD1", opt.size, opt.point, Main, opt.pointParent, opt.x, opt.y)
	Main.CDbuttons[1]:RegisterForDrag("LeftButton")
	Main.CDbuttons[1]:SetScript("OnDragStart", function(self) self:StartMoving() end)
	Main.CDbuttons[1]:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		local centerx, centery = UIParent:GetCenter()
		DB.CD1.x = floor(self:GetLeft() + DB.CD1.size/2 - centerx/DB.scale + .5)
		DB.CD1.y = floor(self:GetBottom() + DB.CD1.size/2 - centery/DB.scale + .5)
	end)
	Main.CDbuttons[1].cdtext = Main.CDbuttons[1]:CreateFontString("$parentCount", "OVERLAY", "TextStatusBarText")
	Main.CDbuttons[1].cdtext:SetJustifyH("CENTER")
	
	-- Secondary Cooldown button
	opt = DB.CD2
	Main.CDbuttons[2] = CreateButton("CD2", opt.size, opt.point, Main.CDbuttons[1], opt.pointParent, opt.x, opt.y)
	Main.CDbuttons[2]:RegisterForDrag("LeftButton")
	Main.CDbuttons[2]:SetScript("OnDragStart", function(self) self:StartMoving() end)
	Main.CDbuttons[2]:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		DB.CD2.x = floor(self:GetLeft() - Main.CDbuttons[1]:GetRight() + .5)
		DB.CD2.y = floor(self:GetBottom() - Main.CDbuttons[1]:GetBottom() + .5)
	end)
	Main.CDbuttons[2].cdtext = Main.CDbuttons[2]:CreateFontString("$parentCount", "OVERLAY", "TextStatusBarText")
	Main.CDbuttons[2].cdtext:SetJustifyH("CENTER")
	-- We make local references to the buttons to speed up updating
	Pbuttons = Main.Pbuttons
	CDbuttons = Main.CDbuttons
	
	-- Rune Display
	Main.RuneDisplay = addonTable.createRuneFrame(Main)
	Main.RuneDisplay:RegisterForDrag("LeftButton")
	Main.RuneDisplay:SetScript("OnDragStart", function(self) self:StartMoving() end)
	Main.RuneDisplay:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		local centerx, centery = UIParent:GetCenter()
		DB.RuneFrame.x = floor(self:GetLeft() + self:GetWidth()/2 - centerx/DB.scale + .5)
		DB.RuneFrame.y = floor(self:GetBottom() + self:GetHeight()/2 - centery/DB.scale + .5)
	end)
	Rune = Main.RuneDisplay
	-- Redraw sets all the user defined characteristics of the UI elements
	addonTable.Redraw()
	-- All the option panels are created in the options file
	addonTable.DKOneOptions()
end

function events:ADDON_LOADED(arg1)
	if arg1 == "DKOne" then
		-- When our addon is loaded, we bail if its not a DK
		if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then
			print("|cFFFF0000DKOne is an addon intended for DK's only. You should probably disable it on this toon to save memory|r")
			addonTable.Disable()
			DisableAddOn("DKOne")
			return
		end
		-- for debugging, sets the database to the default everytime
		if DKOneDB ~= nil and DKOneDB.version == 501001 then
			wipe(DKOneDB)
			DKOneDB = nil
		end
		if DKOneDB == nil then
			-- We populate the database if this is the first time using this addon with this character
			addonTable.ResetDBValues()
			StaticPopupDialogs["DKOne_new"] = {
				preferredIndex = 3, -- Apparently this reduces the likelihood of tainting some blizz code since 
									-- pop ups are reused
				text = "If this is the first time you are using DKOne, would you like to visit the Option Menus?",
				button1 = "Yes",
				button2 = "No",
				OnAccept = function()
					addonTable.OpenOptions()
				end,
				timeout = 0,
				whileDead = true,
				hideOnEscape = true,
			}
			StaticPopup_Show("DKOne_new")
		end
		DB = DKOneDB
		DB.version = GetAddOnMetadata("DKOne", "Version") -- For future upgrade compatibility 
		-- The initialization function creates all the display elements
		Init()
	end
end

-- change to haste mastery or crit
--function events:COMBAT_RATING_UPDATE()
	-- Isn't needed at the moment
--end
-- Player has changed presence
function events:UPDATE_SHAPESHIFT_FORM() 
	tempPresence = GetShapeshiftForm(nil) -- The presence the player is in
	-- Presence changes the cost of Frost Strike in MoP need to change that
	-- and the divider lines on the runi power bar
	if tempPresence ~= DKStatus.Presence then
		DKStatus.Presence = tempPresence
		if DKPlayerStats.Spec == 2 and DKStatus.Presence == 2 then
			aL.FrostStrike.Cost[5] = 20
		elseif DKPlayerStats.Spec == 2 and DKStatus.Presence ~= 2 then	
			aL.FrostStrike.Cost[5] = 35
		end
		if DB.RuneFrame.showSpark and DKPlayerStats.Spec == 2 then
			Rune:redrawRuneSpark()
		end
	end
end

-- Player has entered combat
function events:PLAYER_REGEN_DISABLED() 
	DKStatus.InCombat = true
end
-- Player has left combat
function events:PLAYER_REGEN_ENABLED() 
	DKStatus.InCombat = false
	wipe(aoeTargets)
	numtargets = 0
	DKStatus.AOE = false
end
-- Anytime player enters a new zone or at the end of the login process
function events:PLAYER_ENTERING_WORLD() 
	local isInstance, instanceType = IsInInstance()
	if isInstance == 1 then
		DKPlayerStats.InAnyInstance = true
		if instanceType == "party" then
			DKPlayerStats.InInstance = true
		elseif instanceType == "raid" then
			DKPlayerStats.InRaid = true
		elseif instanceType == "pvp" then
			DKPlayerStats.InBG = true
		elseif instanceType == "arena" then
			DKPlayerStats.InArena = true
		end
	else
		DKPlayerStats.InInstance = false
		DKPlayerStats.InRaid = false
		DKPlayerStats.InBG = false
		DKPlayerStats.InArena = false
		DKPlayerStats.InAnyInstance = false
	end
end
-- Go through and find all the glphs and set glyph variables under DKPlayerStats
local function SetGlyphs()
--print(NUM_GLYPH_SLOTS)
--print(GetNumGlyphSockets())
	for i = 1, NUM_GLYPH_SLOTS do	
		--print(GetGlyphSocketInfo(i))
		if select(4, GetGlyphSocketInfo(i)) == 43826 then  	-- SpellId of Glyph of Outbreak
			DKPlayerStats.OutbreakGlyphed = true
		elseif select(4, GetGlyphSocketInfo(i)) == 43549 then -- SpellId of Glyph of Mind Freeze
			DKPlayerStats.MindFreezeGlyphed = true -- increase in the runic power cost of Mind Freeze
		elseif select(4, GetGlyphSocketInfo(i)) == 43543 then -- SpellId of Glyph of Shifting Presence
			DKPlayerStats.ShiftingPresenceGlyphed = true	-- retain 70% of runic power when shifting presence
		elseif select(4, GetGlyphSocketInfo(i)) == 68793 then -- SpellId of Glyph of Dark Succor
			DKPlayerStats.DarkSuccorGlyphed = true	-- Increases Death Strike heal to 20% after kill
		elseif select(4, GetGlyphSocketInfo(i)) == 43554 then -- SpellId of Glyph of Vampiric Blood
			DKPlayerStats.VampiricBloodGlyphed = true	-- Increases bonus healing of Vampiric blood
		end
		--print(i, DKPlayerStats.VampiricBloodGlyphed)
	end
end

-- Go through and set talent variables under DKPlayerStats
local function SetTalents()
	-- Blood
	--local name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq, test1, test2, test3 = GetTalentInfo(3, true)
	--print("test",name, iconPath, tier, column, currentRank, maxRank, isExceptional, meetsPrereq, test1, test2, test3)
	DKPlayerStats.RoilingBlood = select(5, GetTalentInfo(1))
	DKPlayerStats.PlagueLeech = select(5, GetTalentInfo(2))		
	DKPlayerStats.UnholyBlight = select(5, GetTalentInfo(3))		
	DKPlayerStats.Lichborne = select(5, GetTalentInfo(4))		
	DKPlayerStats.AntiMagicZone = select(5, GetTalentInfo(5))
	DKPlayerStats.Purgatory = select(5, GetTalentInfo(6))
	DKPlayerStats.DeathsAdvance = select(5, GetTalentInfo(7))	
	DKPlayerStats.Chilblains = select(5, GetTalentInfo(8))
	DKPlayerStats.Asphyxiate = select(5, GetTalentInfo(9))
	DKPlayerStats.DeathPact = select(5, GetTalentInfo(10))
	DKPlayerStats.DeathSiphon = select(5, GetTalentInfo(11))
	DKPlayerStats.Conversion = select(5, GetTalentInfo(12))
	DKPlayerStats.BloodTap = select(5, GetTalentInfo(13))
	DKPlayerStats.RunicEmpowerment = select(5, GetTalentInfo(14))
	DKPlayerStats.RunicCorruption = select(5, GetTalentInfo(15))
	DKPlayerStats.GorfiendsGrasp = select(5, GetTalentInfo(16))
	DKPlayerStats.RemorselessWinter = select(5, GetTalentInfo(17))
	DKPlayerStats.DesecratedGround = select(5, GetTalentInfo(18))
	--DKPlayerStats.PointsInScarletFever = select(5, GetTalentInfo(1,6)) -- Scarlet Fever debuffs target with 5% damage reduction per point
	--DKPlayerStats.PointsInSangFort = select(5, GetTalentInfo(1,12)) -- Sanguine Fortitude in the blood tree reduces the cost of Icebound Fortitude by 10 points per point
	-- Frost
	--DKPlayerStats.PointsInRPMastery = select(5, GetTalentInfo(2,1)) -- Runic Power Mastery in Frost Talent tree increases Maximum Runic Power
	--DKPlayerStats.PointsInEndlessWinter = select(5, GetTalentInfo(2,7)) -- Endless Winter in the frost tree reduces the cost of Mind Freeze by 10 points per
	--DKPlayerStats.PointsInChillOfTheGrave = select(5, GetTalentInfo(2, 9)) -- Chill of the Grave Talent in the frost tree increases runic power generation from 4 spells
	-- Unholy
	--DKPlayerStats.PointsInRunicCorruption = select(5, GetTalentInfo(3, 7))	-- Runic Corruption, reduces DC cost
	--DKPlayerStats.PointsInEpidemic = select(5, GetTalentInfo(3, 3))	--
end

-- Adjust the costs of abilities in Abilities list to reflect talents and Glyphs
local function AdjustCosts()
	-- Costs
	--aL.IceboundFortitude.Cost[5] = 20 - 10*DKPlayerStats.PointsInSangFort
	if DKPlayerStats.MindFreezeGlyphed then
		aL.MindFreeze.Cost[5] = 20
	else
		aL.MindFreeze.Cost[5] = 0
	end
	if DKPlayerStats.OutbreakGlyphed then
		aL.Outbreak.Cost[5] = 40
	else
		aL.Outbreak.Cost[5] = 0
	end
	if DKPlayerStats.Spec == 1 then
		aL.IceboundFortitude.Cost[5] = 0
	else
		aL.IceboundFortitude.Cost[5] = 20
	end
	if DKPlayerStats.Spec == 3 then
		aL.DeathCoil.Cost[5] = 40
	else
		aL.DeathCoil.Cost[5] = 32
	end
end

-- We check every spell in the ability list (excluding items) to check if its useable
-- Things like buffs and such will be set to false, but thats okay.
-- Our action and cooldown buttons only show spells the players can cast
local function CheckUseable()
	for k, v in pairs(aL) do
		-- We make sure its not an item and its not the made up spell NoSpell
		if not aL[k].IsItem and aL[k].SpellId ~= 0 then
			aL[k].Useable = IsSpellKnown(aL[k].SpellId)
			--[[if aL[k].SpellId == 49143 then
				print(aL[k].Name, aL[k].SpellId, IsSpellKnown(aL[k].SpellId))
				local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo("Frost Strike")
				print(name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange)
				local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(44, "spell")
				print(name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange)
				local skillType, spellId = GetSpellBookItemInfo("Frost Strike")
				print(skillType, spellId)
				local skillType, spellId = GetSpellBookItemInfo(44, "spell")
				print(skillType, spellId)
				local name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(spellId)
				print(name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange)
			end]]
		end
	end
	--TODO MoP bug work around
	if DKPlayerStats.Spec == 2 then
		aL.FrostStrike.Useable = true
	end
	if DKPlayerStats.Asphyxiate then
		aL.Asphyxiate.Useable = true
	end
	
end

--Specifically to check which trinkets are equipped TODO add a bunch of trinkets :)
local function CheckItems()
	local TrinkId0 = GetInventoryItemID("player", (GetInventorySlotInfo("Trinket0Slot"))) or 0
	local TrinkId1 = GetInventoryItemID("player", (GetInventorySlotInfo("Trinket1Slot"))) or 0
	-- If we have any Flavor of Creche of the Final Dragon in either trinket slot set to true
	if TrinkId0 == 77972 or TrinkId0 == 77205 or TrinkId0 == 77992 or TrinkId1 == 77972 or TrinkId1 == 77205 or TrinkId1 == 77992 then
		DKPlayerStats.CrecheEquipped = true
	end
	-- If we have any Flavor of Eye of Unmaking in either trinket slot set to true
	if TrinkId0 == 77977 or TrinkId0 == 77200 or TrinkId0 == 77997 or TrinkId1 == 77977 or TrinkId1 == 77200 or TrinkId1 == 77997 then
		DKPlayerStats.EyeEquipped = true
	end
	DKStatus.DW = OffhandHasWeapon()
	
end

	-- TODO This is for engineering glove enchants, still figuring it out
	-- enchantId for synapse springs appears to be 4179
	-- Apparently this doesnt work only gives base enchant, dont know of a way to get engineering enchant
	--local itemLink = GetInventoryItemLink("player", GetInventorySlotInfo("HandsSlot"))
	--local itemString = string.match(itemLink, "item[%-?%d:]+")
	--local _, itemId, enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId, linkLevel, reforgeId = strsplit(":", itemString)
	--local enchantId = (select(3,strsplit(":", itemString)))
	--print("Enchant ID is: ", enchantId)

-- Recheck which trinkets are equipped
function events:PLAYER_EQUIPMENT_CHANGED()
	CheckItems()
	addonTable.UpdateRotation() --In case we swapped from 2H to DW
end

-- Triggers on respeccs or changing glyphs
-- Crappy part is it triggers when you lose spells but before you
-- learn new ones, so we end up updating rotation more than necessary
function events:PLAYER_TALENT_UPDATE()
	events:ACTIVE_TALENT_GROUP_CHANGED()
end

-- We use this in our intialization since it triigers late 
-- after spells are known
function events:QUEST_LOG_UPDATE()
	-- After start we dont need the event anymore
	Main:UnregisterEvent("QUEST_LOG_UPDATE")
	-- Register for events triggered when we change spells we know
	Main:RegisterEvent("PLAYER_TALENT_UPDATE")
	Main:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	-- Update the rotation
	events:ACTIVE_TALENT_GROUP_CHANGED()
	-- Have a problem where item information isn't loaded
	-- when the ability file is first read so we reload it here
	addonTable.DKOneLoadItemIcons()
end
-- Each specs priorities and aoe parameter is stored in the database
-- This function copies it over to the DKPlayerStats table
function addonTable.UpdateRotation()
	if DKPlayerStats.Spec == 1 then
		DKPlayerStats.Rotation.prio = DB.RotationBlood.prio
		DKPlayerStats.Rotation.prioAOE = DB.RotationBlood.prioAOE
		DKPlayerStats.Rotation.prioR = DB.RotationBlood.prioR
		DKPlayerStats.Rotation.prioCD = DB.RotationBlood.prioCD
		DKPlayerStats.Rotation.aoenum = DB.RotationBlood.aoenum
	elseif DKPlayerStats.Spec == 2 then
		if DKStatus.DW then
			DKPlayerStats.Rotation.prio = DB.RotationFrostDW.prio
			DKPlayerStats.Rotation.prioAOE = DB.RotationFrostDW.prioAOE
			DKPlayerStats.Rotation.prioR = DB.RotationFrostDW.prioR
			DKPlayerStats.Rotation.prioCD = DB.RotationFrost.prioCD
			DKPlayerStats.Rotation.aoenum = DB.RotationFrostDW.aoenum
		else
			DKPlayerStats.Rotation.prio = DB.RotationFrost.prio
			DKPlayerStats.Rotation.prioAOE = DB.RotationFrost.prioAOE
			DKPlayerStats.Rotation.prioR = DB.RotationFrost.prioR
			DKPlayerStats.Rotation.prioCD = DB.RotationFrost.prioCD
			DKPlayerStats.Rotation.aoenum = DB.RotationFrost.aoenum
		end
	elseif DKPlayerStats.Spec == 3 then
		DKPlayerStats.Rotation.prio = DB.RotationUnholy.prio
		DKPlayerStats.Rotation.prioAOE = DB.RotationUnholy.prioAOE
		DKPlayerStats.Rotation.prioR = DB.RotationUnholy.prioR
		DKPlayerStats.Rotation.prioCD = DB.RotationUnholy.prioCD
		DKPlayerStats.Rotation.aoenum = DB.RotationUnholy.aoenum
	elseif DKPlayerStats.Spec == 0 then
		DKPlayerStats.Rotation.prio = DB.RotationNone.prio
		DKPlayerStats.Rotation.prioAOE = DB.RotationNone.prioAOE
		DKPlayerStats.Rotation.prioR = DB.RotationNone.prioR
		DKPlayerStats.Rotation.prioCD = DB.RotationNone.prioCD
		DKPlayerStats.Rotation.aoenum = DB.RotationNone.aoenum
	end
	-- The updated priorities for the players current spec are then used to update the queue
	-- This global function is in the rotation file
	addonTable.UpdateQueue(DKPlayerStats.Rotation)
end
-- Triggered by changing active talent group (for those with dual specs)
function events:ACTIVE_TALENT_GROUP_CHANGED() 	
	DKPlayerStats.Spec = GetSpecialization() 	-- Checks the spec of the player 1 = BLOOD, 2 = FROST, 3 = UNHOLY (nil if unspecced)
	--print(DKPlayerStats.Spec)
	if DKPlayerStats.Spec == nil then 			-- Sets the spec number to 0 for those that are unspecced
		DKPlayerStats.Spec = 0
	end
	-- Go through and update player info with current talents, glyphs, and items
	SetGlyphs()
	SetTalents()
	AdjustCosts()
	CheckUseable()
	CheckItems()
	--DKPlayerStats.MaxRP = 100 + 10*DKPlayerStats.PointsInRPMastery -- Permanently track the players maximum possible Runic Power
	DKStatus.Presence = GetShapeshiftForm(nil) -- Check the players presence
	--print(DKStatus.Presence)
	addonTable.UpdateRotation()
	-- Some status variables are only checked for specific specs, set them to
	-- 0 or false in case someone manages to change specs while they are positive
	DKStatus.WON = false
	DKStatus.BS = 0
	DKStatus.SoB = 0
	DKStatus.BSDur = 0
	DKStatus.Rime = 0
	DKStatus.KM = false
	DKStatus.SI = 0
	DKStatus.Hulk = 0
	DKStatus.Doom = 0
	DKStatus.Pillar = 0
	DKStatus.PillarCD = 0
	DKStatus.PetDur = 0
	DKStatus.RotFC = 0
	DKStatus.VB = 0
	DKStatus.Bone = 0
	DKStatus.ASDebuff = false
	DKStatus.PDRDebuff = false
	addonTable.Redraw()
	--events:ACTIONBAR_SLOT_CHANGED() -- This was for the glow button overlay but I stopped the idea for now
end

-- Currently used to track a number of targets for determining whether to AOE
-- and trinket proccs for a trinket with an internal cooldown
function events:COMBAT_LOG_EVENT_UNFILTERED(timestamp, eventtype, _, 
        srcGUID, _, _, _,
        destGUID, _, _, _, spellId)
	if srcGUID == UnitGUID("player") then -- The player is the source of the event
		-- The player has damaged or missed some target
		if (eventtype == "SPELL_DAMAGE" or eventtype == "SPELL_MISSED") then
			-- We check if the target is in the table already
			if aoeTargets[destGUID] == nil then
				numtargets = numtargets + 1 -- If not add 1 to the number of targets
			end
			aoeTargets[destGUID] = GetTime() -- Update the time stamp for the target
		-- Its not obvious if we want to include periodic damage, namely dot ticks, in our checks
		-- so Ive let the player set it as an option, note DnD counts as spell damage, not periodic damage.
		elseif eventtype == "SPELL_PERIODIC_DAMAGE" and DB.AOELabel.includePeriodic then
			if aoeTargets[destGUID] == nil then
				numtargets = numtargets + 1
			end
			aoeTargets[destGUID] = GetTime()
		end
		-- This is checking for Procs from the trinket Creche of the Final Dragon, 
		-- it checks for all 3 versions of the buff from the trinket, the buff is called Find Weakness
		if eventtype == "SPELL_AURA_APPLIED"  and (spellId == aL.Creche.SpellId or spellId == 107988 or spellId == 109742) then
			-- If the trinket procs we note the time in order to track the internal cooldown
			aL.Creche.Start = GetTime()
		end
	end
end

-- Mostly used by the time to die label, but also for the melee/range check	
function events:PLAYER_TARGET_CHANGED()
	-- True if the player can attack his target
	DKStatus.TargetHostile = UnitCanAttack("player", "target") and true or false
	if DKStatus.TargetHostile then
		oldTarget = false
		targetHealthArray[1] = UnitHealth("target") -- current health
		targetTimeArray[1] = GetTime() -- Current game time
		healthi = 1
	end
end	

-- This was for putting a glow overlay on the current action button
-- the idea has been abandoned for now because there end up
-- being to many glows from the default blizzard ones
-- If anybody knows how to turn off the default blizzard button glows
-- (not the overlays in the center of your screen), while keeping the 
-- button glow functionality please let me know
--[[
local actionButtons, actionType, spellIdOrMacro
local function SearchActionBarsBlizzard(actionBar)
	actionButtons, actionType, spellIdOrMacro = {actionBar:GetChildren()}
	for i = 1, #actionButtons do
		if actionButtons[i].action then
			actionType, spellIdOrMacro = GetActionInfo(actionButtons[i].action)
			if actionType then
				for k,v in pairs(aL) do
					if (actionType == "spell" and spellIdOrMacro == aL[k].SpellId) or (actionType == "macro" and (select(2, GetMacroInfo(spellIdOrMacro))) == aL[k].Icon) then
						aL[k].actionButton = actionButtons[i]
					end
				end
			end
		end
	end
end
local function SearchActionBarsBartender()
	for _, actionBar in Bartender4:GetModule("ActionBars"):GetAll() do
		for i = 1, actionBar:GetButtons() do
			actionType, spellIdOrMacro = GetActionInfo(actionBar.buttons[i]._state_action)
			if actionType then
				for k,v in pairs(aL) do
					if (actionType == "spell" and spellIdOrMacro == aL[k].SpellId) or (actionType == "macro" and (select(2, GetMacroInfo(spellIdOrMacro))) == aL[k].Icon) then
						aL[k].actionButton = actionBar.buttons[i]
					end
				end
			end
		end
	end
end
local function SearchActionBarsDominos()
	print("in search AB dominoes")
	local actionButtons, actionType, spellIdOrMacro
	for _, actionBar in Dominos.Frame:GetAll() do
		if actionBar.buttons then
			for _, button in pairs(actionBar.buttons) do
				
				if button:GetAttribute('action--base') then
					
					actionType, spellIdOrMacro = GetActionInfo(button:GetAttribute('action--base'))
					if spellIdOrMacro == 57330 then
						print("Get Attribute in button, spellid", spellIdOrMacro)
					end
					for k,v in pairs(aL) do
						if (actionType == "spell" and spellIdOrMacro == aL[k].SpellId) or (actionType == "macro" and (select(2, GetMacroInfo(spellIdOrMacro))) == aL[k].Icon) then
							if k == "HornOfWinter" then
								print("linked button and ability",aL[k].Name, button:GetName())
							end
							aL[k].actionButton = button
						end
					end
				end
			end
		end
	end
end
local actionButtonMoved = true
function events:ACTIONBAR_SHOWGRID()
	actionButtonMoved = true
end
function events:ACTIONBAR_HIDEGRID()
	actionButtonMoved = true
end
function events:ACTIONBAR_PAGE_CHANGED()
	actionButtonMoved = true
	events:ACTIONBAR_SLOT_CHANGED()
end
function events:ACTIONBAR_SLOT_CHANGED()
	print("in slot changed")
	if actionButtonMoved then
		print("in button moved")
		for k,v in pairs(aL) do
			--print("in ab nil")
			aL[k].actionButton = nil
		end
		if Bartender4 then
			SearchActionBarsBartender()
		elseif Dominos then
			print("Dominos in slot changed")
			SearchActionBarsDominos()
		else
			SearchActionBarsBlizzard(MainMenuBarArtFrame)
			SearchActionBarsBlizzard(MultiBarLeft)
			SearchActionBarsBlizzard(MultiBarRight)
			SearchActionBarsBlizzard(MultiBarBottomLeft)
			SearchActionBarsBlizzard(MultiBarBottomRight)
		end
		actionButtonMoved = false
	end
end]]

-- bit of lua voodoo to set all the event functions to their events
Main:SetScript("OnEvent", function(self, event, ...) events[event](self, ...) end)
-- Register all the events
for k, _ in pairs(events) do
    Main:RegisterEvent(k) -- Register all the events defined by functions above
end
Main:SetScript("OnUpdate", OnUpdate);  -- OnUpdate run the OnUpdate function
-- By unregistering for these on startup it skips straight to
-- the QUEST_LOG_UPDATE function which only fires after spells are known 
-- and saves us from reinitializing queues multiple times until the spells are known
Main:UnregisterEvent("PLAYER_TALENT_UPDATE")
Main:UnregisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

function addonTable.Redraw()
	-- The main button isnt actually displayed
	-- could set a toggle to drag all the UI elements together using 
	-- DKOne.Main, but havent yet
	Main:SetFrameStrata(strataLevels[DB.strata])
	Main:SetWidth(DB.Action1.size + 10)
	Main:SetHeight(DB.Action1.size + 10)
	Main:SetScale(DB.scale)
	-- The Primary Action Priority display button
	Main.Pbuttons[1]:SetHeight(DB.Action1.size)
	Main.Pbuttons[1]:SetWidth(DB.Action1.size)
	Main.Pbuttons[1]:SetAlpha(DB.Action1.alpha)
	Main.Pbuttons[1]:EnableMouse( not DB.Action1.locked)
	Main.Pbuttons[1]:SetMovable( not DB.Action1.locked)
	Main.Pbuttons[1]:ClearAllPoints()
	Main.Pbuttons[1]:SetPoint(DB.Action1.point, Main, DB.Action1.pointParent, DB.Action1.x, DB.Action1.y)
	
	-- This is the aoe label code under the Primary Action Priority display button
	fontFace, _, fontFlags = Main.Pbuttons[1].aoelabel:GetFont()
	Main.Pbuttons[1].aoelabel:SetFont(fontFace, DB.AOELabel.fontSize, fontFlags)
	Main.Pbuttons[1].aoelabel:ClearAllPoints()
	Main.Pbuttons[1].aoelabel:SetTextColor(unpack(DB.AOELabel.fontColor))
	Main.Pbuttons[1].aoelabel:SetPoint(DB.AOELabel.point, Main.Pbuttons[1], DB.AOELabel.pointParent, DB.AOELabel.x, DB.AOELabel.y)
		
	-- Time to die label above the Primary Action Priority display button
	fontFace, _, fontFlags = Main.Pbuttons[1].ttdlabel:GetFont()
	Main.Pbuttons[1].ttdlabel:SetFont(fontFace, DB.TTDLabel.fontSize, fontFlags)
	Main.Pbuttons[1].ttdlabel:ClearAllPoints()
	Main.Pbuttons[1].ttdlabel:SetTextColor(unpack(DB.TTDLabel.fontColor))
	Main.Pbuttons[1].ttdlabel:SetPoint(DB.TTDLabel.point, Main.Pbuttons[1], DB.TTDLabel.pointParent, DB.TTDLabel.x, DB.TTDLabel.y)
	-- Primary Action Priority display button border
	Main.Pbuttons[1].border:SetTexture(borderType[DB.Action1.borderThickness])
	Main.Pbuttons[1].border:SetVertexColor(DB.Action1.borderColor)
	if DB.Action1.borderShow then
		Main.Pbuttons[1].border:Show()
	else
		Main.Pbuttons[1].border:Hide()
	end
	Main.Pbuttons[1].aoelabel:Show()
	Main.Pbuttons[1].ttdlabel:Show()
	if DB.Action1.show then
		Main.Pbuttons[1]:Show()
	else
		Main.Pbuttons[1]:Hide()
	end
	
	-- Secondary Action Priority display button
	Main.Pbuttons[2]:SetHeight(DB.Action2.size)
	Main.Pbuttons[2]:SetWidth(DB.Action2.size)
	Main.Pbuttons[2]:SetAlpha(DB.Action2.alpha)
	Main.Pbuttons[2]:EnableMouse( not DB.Action2.locked)
	Main.Pbuttons[2]:SetMovable( not DB.Action2.locked)
	Main.Pbuttons[2]:ClearAllPoints()
	Main.Pbuttons[2]:SetPoint(DB.Action2.point, Main.Pbuttons[1], DB.Action2.pointParent , DB.Action2.x, DB.Action2.y)
	Main.Pbuttons[2]:SetAlpha(DB.Action2.alpha)
	Main.Pbuttons[2].border:SetTexture(borderType[DB.Action2.borderThickness])
	Main.Pbuttons[2].border:SetVertexColor(DB.Action2.borderColor)
	Main.Pbuttons[2].border:Show()
	if DB.Action2.borderShow then
		Main.Pbuttons[2].border:Show()
	else
		Main.Pbuttons[2].border:Hide()
	end
	if DB.Action2.show then
		Main.Pbuttons[2]:Show()
	else
		Main.Pbuttons[2]:Hide()
	end
	
	-- Primary Cooldown button
	Main.CDbuttons[1]:SetHeight(DB.CD1.size)
	Main.CDbuttons[1]:SetWidth(DB.CD1.size)
	Main.CDbuttons[1]:SetAlpha(DB.CD1.alpha)
	Main.CDbuttons[1].border:SetTexture(borderType[DB.CD1.borderThickness])
	Main.CDbuttons[1].border:SetVertexColor(DB.CD1.borderColor)
	Main.CDbuttons[1]:EnableMouse( not DB.CD1.locked)
	Main.CDbuttons[1]:SetMovable( not DB.CD1.locked)
	Main.CDbuttons[1]:ClearAllPoints()
	Main.CDbuttons[1]:SetPoint(DB.CD1.point, Main, DB.CD1.pointParent, DB.CD1.x, DB.CD1.y)
	if DB.CD1.borderShow then
		Main.CDbuttons[1].border:Show()
	else
		Main.CDbuttons[1].border:Hide()
	end
	-- Countdown text on cooldown button
	Main.CDbuttons[1].cdtext:SetFont(fontFace, DB.CDText.fontSize, fontFlags)
	Main.CDbuttons[1].cdtext:ClearAllPoints()
	Main.CDbuttons[1].cdtext:SetTextColor(unpack(DB.CDText.fontColorLong))
	Main.CDbuttons[1].cdtext:SetAlpha(DB.CDText.alpha)
	Main.CDbuttons[1].cdtext:SetPoint(DB.CDText.point, Main.CDbuttons[1], DB.CDText.pointParent, DB.CDText.x, DB.CDText.y)
	if DB.CD1.show then
		Main.CDbuttons[1]:Show()
	else
		Main.CDbuttons[1]:Hide()
	end
		
	-- Secondary Cooldown button
	Main.CDbuttons[2]:SetHeight(DB.CD2.size)
	Main.CDbuttons[2]:SetWidth(DB.CD2.size)
	Main.CDbuttons[2]:SetAlpha(DB.CD2.alpha)
	Main.CDbuttons[2].border:SetTexture(borderType[DB.CD2.borderThickness])
	Main.CDbuttons[2].border:SetVertexColor(DB.CD2.borderColor)
	Main.CDbuttons[2]:EnableMouse( not DB.CD2.locked)
	Main.CDbuttons[2]:SetMovable( not DB.CD2.locked)
	Main.CDbuttons[2]:ClearAllPoints()
	Main.CDbuttons[2]:SetPoint(DB.CD2.point, Main.CDbuttons[1], DB.CD2.pointParent, DB.CD2.x, DB.CD2.y)
	if DB.CD2.borderShow then
		Main.CDbuttons[2].border:Show()
	else
		Main.CDbuttons[2].border:Hide()
	end
	-- Countdown text on cooldown button
	Main.CDbuttons[2].cdtext:SetFont(fontFace, DB.CDText.fontSize, fontFlags)
	Main.CDbuttons[2].cdtext:ClearAllPoints()
	Main.CDbuttons[2].cdtext:SetTextColor(unpack(DB.CDText.fontColorLong))
	Main.CDbuttons[2].cdtext:SetAlpha(DB.CDText.alpha)
	Main.CDbuttons[2].cdtext:SetPoint(DB.CDText.point, Main.CDbuttons[2], DB.CDText.pointParent, DB.CDText.x, DB.CDText.y)
	if DB.CD2.show then
		Main.CDbuttons[2]:Show()
	else
		Main.CDbuttons[2]:Hide()
	end
	
	DB.frequency = max(.05, min(1, DB.frequency)) -- Sets bounds of frequency between  0.05 and 1, option panel slider should take care of this though
	numHealthArray = floor(DB.TTDLabel.window/DB.frequency + .5)
	for i = 1, numHealthArray do -- We create an array equal to 3 seconds of updates
		targetHealthArray[i] = 1 
		targetTimeArray[i] = 1
	end
	-- How long it currently takes a rune to come off cooldown when fully depleted
	-- need to update this before drawing runeframes
	_, DKStatus.RuneDur, _ = GetRuneCooldown(1)
	if DB.showRF then
		Main.RuneDisplay:EnableMouse( not DB.RuneFrame.locked)
		Main.RuneDisplay:SetMovable( not DB.RuneFrame.locked)
		Rune:redrawRuneFrame()
		Rune:Show()
	else
		Rune:Hide()
	end
end


-- This shuts down the addon, current memory for tables is still being used
-- but the addon isnt doing any processing or updating
function addonTable.Disable()
	Main:Hide()
	Main:UnregisterAllEvents()
	Main:SetScript("OnUpdate", nil);  -- OnUpdate run the OnUpdate function
	DB.enabled = false
end
-- This function effectively turns the DKOne addon back on after its been disabled
function addonTable.Enable()
	Main:Show() -- show all the elements
	DB.enabled = true 
	-- Have to reregister all the events
	for k, _ in pairs(events) do
		Main:RegisterEvent(k) -- Register all the events defined by functions above
	end
	-- Quest log event is only used for startup
	Main:UnregisterEvent("QUEST_LOG_UPDATE")
	Main:SetScript("OnUpdate", OnUpdate);  -- OnUpdate run the OnUpdate function
	-- Make sure talents and glyphes havent changed while we were off
	events:ACTIVE_TALENT_GROUP_CHANGED()
	-- Redraw the current elements
	addonTable.Redraw()
end

-- Print out the current status of all runes
local function PrintRuneStatus()
	print("B1: ", format("%.1d",DKStatus.B1), " ", "B2: ", format("%.1d",DKStatus.B2))
	print("U1: ", format("%.1d",DKStatus.U1), " ", "U2: ", format("%.1d",DKStatus.U2))
	print("F1: ", format("%.1d",DKStatus.F1), " ", "F2: ", format("%.1d",DKStatus.F2))
	print("Rune Count: ", DKStatus.RuneCD[1], DKStatus.RuneCD[2], DKStatus.RuneCD[3])
	print("Death Rune Count: ", DKStatus.DRuneCD[1], DKStatus.DRuneCD[2], DKStatus.DRuneCD[3], DKStatus.DRuneCD[4])
	print("Death Runes: ", tostring(DKStatus.NotDeath[1]), tostring(DKStatus.NotDeath[2]), tostring(DKStatus.NotDeath[3]), tostring(DKStatus.NotDeath[4]), tostring(DKStatus.NotDeath[5]), tostring(DKStatus.NotDeath[6]))
end
-- Returns keys in order
local function pairsByKeys (t)
	local a = {}
	for n in pairs(t) do 
		tinsert(a, n) 
	end
	sort(a)
	local i = 0      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1
		if a[i] == nil then 
			return nil
		else 
			return a[i], t[a[i]]
		end
	end
	return iter
end
-- Prints tables recursively in alphanumeric order by key
local function tprint (tbl, indent)
	local formatting
	if not indent then 
		indent = 0 
	end
	for k, v in pairsByKeys(tbl) do
		formatting = strrep(" ", indent) .. k .. ": "
		if type(v) == "table" then
			print(formatting)
			tprint(v, indent+indent)
		else
		print(formatting .. tostring(v))
    end
  end
end
-- Print out various tables for debugging purposes
local function PrintDB()
	tprint(DB,4)
end
local function PrintStat()
	tprint(DKStatus,4)
end
local function PrintPlayerStat()
	tprint(DKPlayerStats,4)
end
local function PrintaL()
	tprint(aL,4)
end
function addonTable.OpenOptions()
	InterfaceOptionsFrame_OpenToCategory("DKOne")
end
function SlashCmdList.DKOne(msg, editbox)
	print("In Slash command")
    msg = {strsplit(" ", strlower(msg))}
    if msg[1] == "options" or msg[1] == "opt" or msg[1] == "configuration" or msg[1] == "config" then
         print("Opening Options")
		 addonTable.OpenOptions()
	elseif msg[1] == "rune" then
         print("Current Rune Status:")
		 PrintRuneStatus()
	elseif msg[1] == "status" then
         print("Current Status:")
		 PrintStat()
	elseif msg[1] == "stats" then
         print("Current Player Stats:")
		 PrintPlayerStat()
	elseif msg[1] == "db" then
         print("Current Database:")
		 PrintDB()
	elseif msg[1] == "al" then
         print("Current Ability List:")
		 PrintaL()
	elseif msg[1] == "version" or msg[1] == "ver" then
         print("DKOne Version: ", DB.version)
	elseif msg[1] == "test" then
         addonTable.TestFunction(1)
	else
        print("DKOne (version: |cFFFFD000" .. GetAddOnMetadata("DKOne", "Version") .. "|r) - Commands:")
		print("/DKOne options - Open the Options Panel")
		print("/DKOne rune - Prints current rune status")
		print("/DKOne status - Prints status (DKStatus Table)")
		print("/DKOne stats - Prints current stats (DKPlayerStats Table)")
		print("/DKOne db - Prints current database (DKOneDB Table)")
		print("/DKOne al - Prints current ability list (aL Table) -  warning very long")
		print("/DKOne version - Prints the version number of this DKOne")
	end
end