-- Additional file for the DKOne WOW addon
-- Author: Zorben on Proudmoore-US

-- Addon bails if character is not a DK
if select(2,UnitClass("player"))  ~= "DEATHKNIGHT" then 
	DisableAddOn("DKOne") 
	return
	
end
local addonName, addonTable = ... --Pulls back the Addon-Local Variables and stores them locally
local DB 
local r, g, b, a --red, green, blue, alpha, used in ColorBox functions
local actions, actionsCD
local actionsBlood = {}
local actionsFrost = {}
local actionsUnholy = {}
local anchorMenu = {
	{text = "TOPLEFT"},
	{text = "TOP"},
	{text = "TOPRIGHT"},
	{text = "RIGHT"},
	{text = "BOTTOMRIGHT"},
	{text = "BOTTOM"},
	{text = "BOTTOMLEFT"},
	{text = "LEFT"},
	{text = "CENTER"},
}
local orientMenu = {
	{text = "HORIZONTAL"},
	{text = "VERTICAL"}
}
local orderMenu = {
	{text = "BBUUFF", value = 1,},
	{text = "BBFFUU", value = 2,},
	{text = "UUBBFF", value = 3,},
	{text = "UUFFBB", value = 4,},
	{text = "FFBBUU", value = 5,},
	{text = "FFUUBB", value = 6,},
}
local timeFormatMenu = { --1 = 4.5, 2 == 4, 3 = 4.5/8.5, 4 = 4/8
	{text = "4.3", value = 1,},
	{text = "4", value = 2,},
	{text = "4.3/7.8", value = 3,},
	{text = "4/8", value = 4,},
}
local timeFormatMenu2 = { -- 2 == 43,  4 = 32/100
	{text = "32", value = 2,},
	{text = "32/100", value = 4,},
}
local info = {} -- Reused in creating menus, createMenu()
local checkedenabled = true
-- helper functions for GUI --

local NameCount = 0;
local function GetUniqueName()
	NameCount = NameCount + 1
	return "DKOne_"..NameCount
end

local fontFace, fontSize, fontFlags
-- Options frames
local OptionsPanel, OPAD, OPLB, OPRot, OPRF, OPDoc, OPDocLegend
-- local function pointers
local unpack = unpack --Local version of library functions
local CreateFrame = CreateFrame --Local version of library functions
local wipe = wipe --Local version of library functions
local pairs = pairs --Local version of library functions
local ColorPickerFrame = ColorPickerFrame --Local version of library functions
local OpacitySliderFrame = OpacitySliderFrame --Local version of library functions
local tonumber = tonumber --Local version of library functions
local max = max --Local version of library functions
local min = min --Local version of library functions
local strmatch = strmatch --Local version of library functions
local format = format --Local version of library functions
local InterfaceOptions_AddCategory = InterfaceOptions_AddCategory --Local version of library functions
local tostring = tostring --Local version of library functions
local tinsert = tinsert --Local version of library functions
local sort = sort --Local version of library functions
local strsub = strsub --Local version of library functions
local type = type --Local version of library functions
local UIDropDownMenu_Initialize = UIDropDownMenu_Initialize --Local version of library functions
local UIDropDownMenu_SetWidth = UIDropDownMenu_SetWidth --Local version of library functions
local UIDropDownMenu_SetButtonWidth = UIDropDownMenu_SetButtonWidth --Local version of library functions
local UIDropDownMenu_JustifyText = UIDropDownMenu_JustifyText --Local version of library functions
local UIDropDownMenu_SetSelectedID = UIDropDownMenu_SetSelectedID --Local version of library functions
local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo --Local version of library functions
local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton --Local version of library functions
local UIDropDownMenu_SetSelectedValue = UIDropDownMenu_SetSelectedValue --Local version of library functions
local UIDropDownMenu_SetText = UIDropDownMenu_SetText --Local version of library functions
local PanelTemplates_Tab_OnClick = PanelTemplates_Tab_OnClick --Local version of library functions
local PanelTemplates_UpdateTabs = PanelTemplates_UpdateTabs --Local version of library functions
local PanelTemplates_TabResize = PanelTemplates_TabResize --Local version of library functions
local PanelTemplates_SetNumTabs = PanelTemplates_SetNumTabs --Local version of library functions
local PanelTemplates_SetTab = PanelTemplates_SetTab --Local version of library functions
local IsShiftKeyDown = IsShiftKeyDown --Local version of library functions
local UIParent = UIParent --Local version of library function

local function createLabel(text, x, y, parent, point, pointParent, fontsize, fontcolor, justifyH, justifyV)
	local label = parent:CreateFontString(nil, 'ARTWORK', 'GameFontWhiteSmall')
	label:SetPoint(point or "TOPLEFT", parent, pointParent or "TOPLEFT", x or 0, y or 0)
	label:SetText(text or "")
	fontFace, fontSize, fontFlags = label:GetFont()
	label:SetFont(fontFace, fontsize or fontSize, fontFlags)
	if fontcolor then
		label:SetTextColor(unpack(fontcolor))
	end
	label:SetJustifyH(justifyH or "LEFT")
	label:SetJustifyV(justifyV or "MIDDLE")
end
-- Creates drop down menus, menu input needs to be an array of info, including text key
local function createMenu(parent, x, y, w, buttonw, menu, toplabel, label)
	local menuFrame =   CreateFrame("Button", GetUniqueName(), parent, "UIDropDownMenuTemplate")
	menuFrame:ClearAllPoints()
	menuFrame:SetPoint("TOPLEFT", x, y)
	menuFrame:Show()
	
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(menuFrame, self:GetID())
		menuFrame.Value = self.value
	end
	
	local function initialize(self, level)
		if not level then return end
		wipe(info) -- Table is reused, local to this file
		info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(menu) do
			info = UIDropDownMenu_CreateInfo()
			if v.isTitle == true then
				info.IsTitle = true
				info.notCheckable = true
			end
			info.text = v.text
			info.value = v.value or v.text
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end 
	end
	
	local function GetValue(self)
		return self.Value
	end
	
	local function SetValue(self, value)
		self.Value = value
		UIDropDownMenu_SetSelectedValue(self, self.Value)
		-- This sets the intial text display
		if not menu[1].value then
			UIDropDownMenu_SetText(self, self.Value)
			return
		else
			for i = 1,#menu do
				if menu[i].value == self.Value then
					UIDropDownMenu_SetText(self, menu[i].text)
					return
				end
			end
		end
	end
	-- my input/output functions
	menuFrame.GetValue = GetValue
	menuFrame.SetValue = SetValue
	if toplabel then
		menuFrame.TopLabel = createLabel(toplabel, 20, 0, menuFrame, "BOTTOMLEFT", "TOPLEFT")
	end
	if label then
		menuFrame.Label = createLabel(label, -10, 2, menuFrame, "LEFT", "RIGHT")
	end
	UIDropDownMenu_Initialize(menuFrame, initialize)
	UIDropDownMenu_SetWidth(menuFrame, w);
	UIDropDownMenu_SetButtonWidth(menuFrame, buttonw)
	UIDropDownMenu_JustifyText(menuFrame, "LEFT")
	return menuFrame
end

local function tabOnClick(self)
	local parent = self:GetParent()
	--update tab selection
	PanelTemplates_Tab_OnClick(self, parent)
	PanelTemplates_UpdateTabs(parent)
	--hide any visible panels/tabs
	for i, tab in pairs(parent.tabs) do
		if tab ~= self then
			tab.panel:Hide()
			--tab.sl:Hide()
			--tab.sr:Hide()
		end
	end
	--show the top of the panel texture from our tab
	--self.sl:Show()
	--self.sr:Show()
	--show selected tab's panel
	self.panel:Show()
end

local function createTab(parent, id, name, panel)
	parent.tabs = parent.tabs or {}
	--create PanelArea if parent doesnt already have one
	if not parent.panelArea then
		parent.panelArea = CreateFrame('Frame', parent.name .. '_PanelArea', parent)
		parent.panelArea:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 12, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		parent.panelArea:SetPoint('TOPLEFT', 4, -36) --56
		parent.panelArea:SetPoint('BOTTOMRIGHT', -4, 4)
		parent.panelArea:SetBackdropColor(0, 0, 0, .9) 
	end
	
	local t = CreateFrame('Button', parent:GetName() .. 'Tab' .. (#parent.tabs + 1), parent, 'OptionsFrameTabButtonTemplate')
	tinsert(parent.tabs, t)

	t.panel = panel
	t.id = id
	t:SetText(name)
	t:SetScript('OnClick', tabOnClick)

	--this is the texture that makes up the top border around the main panel area
	--its here because each tab needs one to create the illusion of the tab popping out in front of the player
	--t.sl = t:CreateTexture(nil, 'BACKGROUND')
	-- t.sl:SetTexture([[Interface\OptionsFrame\UI-OptionsFrame-Spacer]])
	-- t.sl:SetPoint('BOTTOMRIGHT', t, 'BOTTOMLEFT', 11, -6)
	-- t.sl:SetPoint('BOTTOMLEFT', parent, 'TOPLEFT', 16, -(34 + t:GetHeight() + 7))

	-- t.sr = t:CreateTexture(nil, 'BACKGROUND')
	-- t.sr:SetTexture([[Interface\OptionsFrame\UI-OptionsFrame-Spacer]])
	-- t.sr:SetPoint('BOTTOMLEFT', t, 'BOTTOMRIGHT', -11, -6)
	-- t.sr:SetPoint('BOTTOMRIGHT', parent, 'TOPRIGHT', -16, -(34 + t:GetHeight() + 11))

	--place the new tab
	--if its the first tab, anchor to the main frame
	--if not, anchor to the right of the last tab
	local numTabs = #parent.tabs
	if numTabs > 1 then
		t:SetPoint('TOPLEFT', parent.tabs[numTabs - 1], 'TOPRIGHT', -8, 0)
		--t.sl:Hide()
		--t.sr:Hide()
	else
		t:SetPoint('TOPLEFT', parent, 'TOPLEFT', 12, -14)
		--t.sl:Show()
		--t.sr:Show()
	end
	t:SetID(numTabs)
	--adjust tab sizes and number of tabs
	PanelTemplates_TabResize(t, 0)
	PanelTemplates_SetNumTabs(parent, numTabs)
	--place the panel associated with the tab
	panel:SetParent(parent.panelArea)
	panel:SetAllPoints(parent.panelArea)
	--display the first tab, if its not already displayed
	PanelTemplates_SetTab(parent, 1)
	return t
end

-- ColorBox -- I copied these color box helper functions from somewhere, I forget where now
local CurrentColorBox 	-- This is storing the color box that the ColorPicker Frame is Pointing to
						-- so it can be updated
local prevColorValues = {0,0,0,0}
local function ColorChanged(oldValues)
	if oldValues then 
		r,g,b,a = unpack(oldValues)
		CurrentColorBox:SetBackdropColor(r,g,b,a)
	else
		a = OpacitySliderFrame:GetValue()
		r,g,b = ColorPickerFrame:GetColorRGB()
		CurrentColorBox:SetBackdropColor(r,g,b,a) --changed this from 1-a to a
	end
end

local function ShowColorPicker(ColorBox)
	CurrentColorBox = ColorBox
	r,g,b,a = ColorBox:GetBackdropColor()
	prevColorValues[1], prevColorValues[2], prevColorValues[3], prevColorValues[4] =  r,g,b,a
	ColorPickerFrame.previousValues  = prevColorValues
	ColorPickerFrame:SetColorRGB(r,g,b);
	ColorPickerFrame.hasOpacity = true
	ColorPickerFrame.opacity = a --changed this from 1-a to a
	ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = 	ColorChanged, ColorChanged, ColorChanged;
	ColorPickerFrame:Show();
end

local function CreateColorBox(parent, x, y, label)
	local r, g, b, a
	local colorbox = CreateFrame("Button", GetUniqueName(), parent)

	colorbox:SetPoint("TOPLEFT", x, y)
	colorbox:SetWidth(24)
	colorbox:SetHeight(24)
	colorbox:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameColorSwatch", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = false, tileSize = 16, edgeSize = 8, insets = { left = 1, right = 1, top = 1, bottom = 1 }})
	colorbox:SetScript("OnClick", function() ShowColorPicker(colorbox) end)
	if label ~= nil then
		colorbox.Label = createLabel(label, 4, 0, colorbox, "LEFT", "RIGHT")
	end
	colorbox.SetColor =
		function(self, c)
			colorbox:SetBackdropColor(c[1], c[2], c[3], c[4])
		end

	colorbox.GetColor =
		function(self, c)
			-- The point of this next if is to avoid creating a new table with the return function
			-- so the user has the option of passing a table to copy the values to
			-- if no table is passed, it just creates a new table and returns it
			if c and type(c) == "table" then
				c[1], c[2], c[3], c[4] = colorbox:GetBackdropColor()
				return
			else
				r,g,b,a = colorbox:GetBackdropColor()
				return {r,g,b,a}
			end
		end
	return colorbox
end

-- EditBox --
local function CreateEditBox(parent, x, y, w, label, toplabel, justifyH, minvalue, maxvalue, isNumeric, fonth, fontf)
	local fontHeight = fonth or 14
	local font = fontf or "Fonts\\ARIALN.TTF"
	local width = w or 50
	local defaultNum = 0
	-- The background frame for the edit box, height changes dynamically
	local OuterFrame = CreateFrame("Frame", GetUniqueName(), parent )
	OuterFrame:SetWidth(width)
	OuterFrame:SetHeight(1.5*fontHeight)
	OuterFrame:SetPoint("TOPLEFT", x, y)
	OuterFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
										edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
										tile = true, tileSize = 8, edgeSize = 8, 
										insets = { left = 1, right = 1, top = 1, bottom = 1 }
										});
	OuterFrame:SetBackdropColor(0, 0, 0, 1)
	OuterFrame:SetBackdropBorderColor(0.5, 0.5, 0.5, 1)
	-- Edit box sits ontop of the background frame, most functions are passed throughs
	local editbox = CreateFrame("EditBox", GetUniqueName(), OuterFrame)
	editbox:ClearAllPoints()
	editbox:SetMultiLine(true)
	editbox:SetPoint("TOPLEFT", OuterFrame, "TOPLEFT",  0, 0)
	editbox:SetWidth(width)
	editbox:SetAutoFocus(false)
	editbox:SetFont(font, fontHeight, "NONE")
	editbox:SetJustifyH(justifyH or "RIGHT")
	editbox:SetJustifyV("MIDDLE")
	editbox:SetTextInsets(fontHeight/2, fontHeight/2, fontHeight/4, fontHeight/4) --Left, Right, Top, Bottom
	editbox:SetText("0")
	if isNumeric then
		editbox:SetNumeric(true)
	end
	editbox:Show()
	if label ~= nil then
		editbox.Label = createLabel(label, 6, 0, editbox, "LEFT", "RIGHT")
	end
	if toplabel ~= nil then
		editbox.TopLabel = createLabel(toplabel, 0, 0, editbox, "BOTTOMLEFT", "TOPLEFT")
	end
	OuterFrame.editbox = editbox
	function OuterFrame:GetText() return editbox:GetText() end
	function OuterFrame:SetText(value) editbox:SetText(value); editbox:SetCursorPosition(0) end
	function OuterFrame:SetNumeric(value) editbox:SetNumeric(value) end
	function OuterFrame:SetNumber(value) defaultNum = value; editbox:SetNumber(value); editbox:SetCursorPosition(0) end
	function OuterFrame:SetJustifyH(value) editbox:SetJustifyH(value) end
	function OuterFrame:SetJustifyV(value) editbox:SetJustifyV(value) end
	function OuterFrame:SetCursorPosition(value) editbox:SetCursorPosition(value) end
	OuterFrame._SetWidth = OuterFrame.SetWidth
	function OuterFrame:SetWidth(value) OuterFrame:_SetWidth(value); editbox:SetWidth(value) end
	
	local checkNum
	local function GetNumber(self, value)
		checkNum = tonumber(self.editbox:GetText())
		if checkNum then
			if minvalue and maxvalue then
				--print("min, num, max:" ,minvalue, checkNum, maxvalue)
				return max(minvalue,min(maxvalue,checkNum))
			else
				return checkNum
			end
		else
			return defaultNum
		end
	end
	OuterFrame.GetNumber = GetNumber	
	-- This function dynamically changes the background to the multiline
	-- edit box when it wraps and becomes multiline
	local function resizeBackground()
		OuterFrame:SetHeight(editbox:GetHeight())
	end
	editbox:SetScript("OnTextChanged",resizeBackground)
	
	return OuterFrame
end

-- CheckButton --
local function CreateCheckButton(parent, x, y, label, labelw)
	local checkbutton = CreateFrame("CheckButton", GetUniqueName(), parent, "InterfaceOptionsCheckButtonTemplate" )
	checkbutton:SetPoint("TOPLEFT", x, y)
	checkbutton:SetWidth(24)
	checkbutton:SetHeight(24)
	_G[checkbutton:GetName() .. "Text"]:SetText(label)
	_G[checkbutton:GetName() .. "Text"]:SetWordWrap(true)
	_G[checkbutton:GetName() .. "Text"]:SetWidth(labelw or 500)
	return checkbutton
end

local minvaluelabel, maxvaluelabel -- locl variables used in CreateSlider()
local function CreateSlider(parent, x, y, toplabel, minvalue, maxvalue, step, rightlabel, minvaluelabel, maxvaluelabel)
	local myslider = CreateFrame("Slider", GetUniqueName(), parent, "OptionsSliderTemplate")
	myslider:SetPoint("TOPLEFT", x, y)
	myslider:SetWidth(150)
	myslider:SetHeight(20)
	myslider:SetMinMaxValues(minvalue, maxvalue)
	myslider:SetValueStep(step)
	minvaluelabel = minvaluelabel or minvalue
	maxvaluelabel = maxvaluelabel or maxvalue
	_G[myslider:GetName() .. "Text"]:SetText(toplabel)
	_G[myslider:GetName() .. "Low"]:SetText(minvaluelabel)
	_G[myslider:GetName() .. "High"]:SetText(maxvaluelabel)
	myslider.RightLabel = myslider:CreateFontString(nil, 'ARTWORK', 'GameFontWhiteSmall')
	myslider.RightLabel:SetPoint("TOPLEFT", myslider, "TOPRIGHT", 8, -7)
	myslider.RightLabel:SetText(rightlabel)
	myslider.valueLabel = myslider:CreateFontString(nil, 'ARTWORK', 'GameFontWhiteSmall')
	myslider.valueLabel:SetPoint("TOP", myslider, "BOTTOM", 0, 0)
	myslider.value = 1
	function myslider:SetValueLabel(value)
		myslider.valueLabel:SetText(value)
	end
	local function sliderValueChanged()
		myslider.value = myslider:GetValue()
		if myslider.value then
			myslider.valueLabel:SetFormattedText("%.2f",tonumber(myslider.value))
		end
	end
	myslider:SetScript("OnValueChanged", sliderValueChanged)
	
	return myslider
end

local function CreateActionLabel(text, x, y, parent)
	local actionlabel = parent:CreateFontString(nil, 'ARTWORK', 'GameFontWhiteSmall')
	actionlabel:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y)
	actionlabel:SetText(text)
end

local function SetText(self, text)
	self.label:SetText(text or "")
	if (text or "") == "" then
		self.left:SetPoint("RIGHT",self.frame,"RIGHT",-3,0)
		self.right:Hide()
	else
		self.left:SetPoint("RIGHT",self.label,"LEFT",-5,0)
		self.right:Show()
	end
end

local function CreateHeaderFrame(width, text, parent)
	local frame = CreateFrame("Frame",nil,parent)
	frame:SetHeight(18)
	frame:SetWidth(width)
	local label = frame:CreateFontString(frame,"OVERLAY","GameFontNormal")
	label:SetPoint("TOP",frame,"TOP",0,0)
	label:SetPoint("BOTTOM",frame,"BOTTOM",0,0)
	label:SetJustifyH("CENTER")
	label:SetHeight(18)
	label:SetText(text)
	frame.label = label
	frame.label:Show()
	
	local left = frame:CreateTexture(nil, "OVERLAY")
	frame.left = left
	left:SetHeight(8)
	left:SetPoint("LEFT",frame,"LEFT",3,0)
	left:SetPoint("RIGHT",label,"LEFT",-5,0)
	left:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	left:SetTexCoord(0.81, 0.94, 0.5, 1)
	frame.left:Show()
	
	local right = frame:CreateTexture(nil, "OVERLAY")
	frame.right = right
	right:SetHeight(8)
	right:SetPoint("RIGHT",frame,"RIGHT",-3,0)
	right:SetPoint("LEFT",label,"RIGHT",5,0)
	right:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	right:SetTexCoord(0.81, 0.94, 0.5, 1)
	frame.right:Show()
	return frame
end

-- ^-?[0-9]+\.[0-9]+
local function mysort(a,b)
	local aorder = tonumber(strmatch(a, "^[^%a]+"))
	local border = tonumber(strmatch(b, "^[^%a]+"))
	local aalpha = strmatch(a, "%a.*")
	local balpha = strmatch(b, "%a.*")
	if aorder and border and aorder ~= border then
		return aorder < border
	elseif aorder and border and aorder == border then
		return aalpha < balpha
	else
		return a < b
	end
end

-- Returns keys in in ascending numeric order by the value order,
-- If order field doesnt exist, sort naturally
-- This turned out to be a pain in the keister
local function pairsByOrder(t)
	--print("In pairsByOrder start")
	local a = {}	-- array of all the keys in table t
	local b = {}	-- table with keys made by concatenating order value and key from table a, the value is the index of the key in table a
	local c = {}	-- array of all keys in table b
	local newkey
	for key, value in pairs(t) do 
		tinsert(a, key)
	end
	for k = 1,#a do
		if t[a[k]].order then
			newkey = tostring(t[a[k]].order)..a[k]
			b[newkey] = k
		else
			b[a[k]] = k
		end
	end
	for key, value in pairs(b) do 
		tinsert(c, key)
	end
	sort(c, mysort)
	local i = 0      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1
		if a[b[c[i]]] == nil then 
			return nil
		else 
			return a[b[c[i]]], t[a[b[c[i]]]]
		end
	end
	return iter
end

local function CreateScrollWindow(parent, x, y, width, height, list, documentation)
	local BackgroundFrame = CreateFrame("Frame", "Background", parent)
	BackgroundFrame:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y)
	BackgroundFrame:SetSize(width+16, height+16)
	BackgroundFrame:SetBackdrop({bgFile = nil, edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 12, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	BackgroundFrame.texture = BackgroundFrame:CreateTexture(nil, "BACKGROUND")
	BackgroundFrame.texture:SetAllPoints(BackgroundFrame)
	BackgroundFrame.texture:SetTexture(0,0,0,1)
	
	local OuterFrame = CreateFrame("ScrollFrame", "ActionList", BackgroundFrame)
	OuterFrame:SetPoint("TOPLEFT", BackgroundFrame, "TOPLEFT", 8, -8)
	-- This is just a gray background with a border slightly larger than the outerframe
	
	-- The Scroll Child is the frame under the Outer Frame, It contains the data
	local ScrollChild = CreateFrame("Frame", "ActionListChild", OuterFrame)
	ScrollChild:SetPoint("TOPLEFT", OuterFrame, "TOPLEFT", 0, 0)
	-- The Slider Bar is the element on the right of the window that lets us scroll
	local SliderBar = CreateFrame("Slider", "ActionListScrollBar", OuterFrame)
	-- We create a background for the slider track
	if not SliderBar.bg then
		SliderBar.bg = SliderBar:CreateTexture(nil, "BACKGROUND")
		SliderBar.bg:SetAllPoints(true)
		SliderBar.bg:SetTexture(1, 1, 1, 0.5) -- we just set a gray background
	end
	-- We create the button we use to scroll with
	if not SliderBar.thumb then
		SliderBar.thumb = SliderBar:CreateTexture(nil, "OVERLAY")
		SliderBar.thumb:SetTexture("Interface\\Buttons\\UI-ScrollBar-Knob")
		SliderBar.thumb:SetSize(25, 25)
		SliderBar:SetThumbTexture(SliderBar.thumb)
	end
	-- Create a table that will contain the Action List strings themselves
	ScrollChild.ALstrings = ScrollChild.ALstrings or {}
	-- This changes the padding between font strings vertically
	local PADDING = 4
	-- Store the max width and overall height of the scroll child
	local SCheight = 0 -- This is different than the height of the Outer Frame
	local als
	local i = 1
	--local n = #actionlist
	-- Iterate the list 
	for k, v in pairsByOrder(list)  do
		if documentation then
			--print("Doc: ",i, k, v.info)
		end
		local fheight
		-- If the font string is not created, do so
		if strsub(v.info, 1, 6) == "header" then
			ScrollChild.ALstrings[i] = CreateHeaderFrame(width-32, k, ScrollChild)
			fheight = 18
		else
			ScrollChild.ALstrings[i] = ScrollChild:CreateFontString("action"..i,'ARTWORK', 'GameFontWhiteSmall')
			-- make a local reference for convenience
			als = ScrollChild.ALstrings[i]
			als:SetText(format("%s - %s", k, v.info)) -- Set the actual text of each list element
			als:SetJustifyH("LEFT") -- left justify all of them
			als:SetIndentedWordWrap(true) -- word wrap because some entries are too long
			als:SetWidth(width-32) -- we have to subtract some space for the Slider Bar and the borders
			fheight = als:GetStringHeight()
		end
		-- Place the font strings in rows starting at the top-left
		if i == 1 then
			ScrollChild.ALstrings[i]:SetPoint("TOPLEFT", 8, -4) -- we move the first element in from the upper left corner
			SCheight = SCheight + fheight -- keep track of the total height of ScrollChild
		else
			-- each element is left aligned with and placed below the first element spaced by PADDING
			ScrollChild.ALstrings[i]:SetPoint("TOPLEFT", ScrollChild.ALstrings[i - 1], "BOTTOMLEFT", 0, - PADDING)
			SCheight = SCheight + fheight + PADDING
		end
		i = i + 1
	end
	-- Set the size of the scroll child
	ScrollChild:SetSize(width, SCheight)
	-- Size and place the parent frame, and set the scrollchild to be the
	-- frame of font strings we've created
	OuterFrame:SetSize(width, height)
	OuterFrame:SetScrollChild(ScrollChild)
	OuterFrame:Show()

	-- Set up the scrollbar to work properly
	local scrollMax = max(0,SCheight - height)
	SliderBar:SetOrientation("VERTICAL");
	SliderBar:SetSize(16, height -10)
	SliderBar:SetPoint("TOPRIGHT", OuterFrame, "TOPRIGHT", -5, -5)
	SliderBar:SetMinMaxValues(0, scrollMax)
	SliderBar:SetValue(0)
	SliderBar:SetScript("OnValueChanged", function(self)
		OuterFrame:SetVerticalScroll(self:GetValue())
	end)
 
	-- Enable mousewheel scrolling
	OuterFrame:EnableMouseWheel(true)
	OuterFrame:SetScript("OnMouseWheel", function(self, delta)
		local current = SliderBar:GetValue()
		if IsShiftKeyDown() and (delta > 0) then
			SliderBar:SetValue(0)
		elseif IsShiftKeyDown() and (delta < 0) then
			SliderBar:SetValue(scrollMax)
		elseif (delta < 0) and (current < scrollMax) then
			SliderBar:SetValue(current + 20)
		elseif (delta > 0) and (current > 1) then
			SliderBar:SetValue(current - 20)
		end
	end)
	return BackgroundFrame
end

-- End of helper functions for GUI --
--------------------------------------------------------------------------------------------


local function Okay()
	--print("In Okay for config interface, start")
	checkedenabled = OptionsPanel.Widgets.enabled:GetChecked()
	if checkedenabled  and not DB.enabled then
		addonTable.Enable()
	elseif DB.enabled and not checkedenabled then
		addonTable.Disable()
	end
	DB.ShowOnlyInCombat = OptionsPanel.Widgets.ShowOnlyInCombat:GetChecked()
	DB.ShowAlwaysInRaid = OptionsPanel.Widgets.ShowAlwaysInRaid:GetChecked()
	DB.priorityActions = OptionsPanel.Widgets.priorityActions:GetChecked()
	DB.cdActions = OptionsPanel.Widgets.cdActions:GetChecked()
	DB.showRF = OptionsPanel.Widgets.showRF:GetChecked()
	DB.frequency = OptionsPanel.Widgets.frequency:GetValue()
	DB.scale = OptionsPanel.Widgets.scale:GetValue()
	--print("In Okay for config interface, end")
	--addonTable.Redraw()
end
local function Cancel()
	--print("In Cancel function")
end
local function Default()
	addonTable.ResetDB()
	--print("End of Default")
end
local function Refresh()
	OptionsPanel.Widgets.enabled:SetChecked(DB.enabled)
	OptionsPanel.Widgets.ShowOnlyInCombat:SetChecked(DB.ShowOnlyInCombat)
	OptionsPanel.Widgets.ShowAlwaysInRaid:SetChecked(DB.ShowAlwaysInRaid)
	OptionsPanel.Widgets.priorityActions:SetChecked(DB.priorityActions)
	OptionsPanel.Widgets.cdActions:SetChecked(DB.cdActions)
	OptionsPanel.Widgets.showRF:SetChecked(DB.showRF)
	OptionsPanel.Widgets.frequency:SetValue(DB.frequency)
	OptionsPanel.Widgets.scale:SetValue(DB.scale)
	--print("End of Refresh function")
end

local function MyDefault()
	addonTable.ResetDBValues()
	
	OptionsPanel.refresh()
	OPAD.refresh()
	OPLB.refresh()
	OPRot.refresh()
	OPRF.refresh()
	--print("End of MyDefault")
end
local function CreateOptionsPanel()
	OptionsPanel = CreateFrame("Frame", nil, UIParent)
	OptionsPanel.name = "DKOne"
	--OptionsPanel:SetWidth(300)
	--OptionsPanel:SetHeight(400)

	OptionsPanel.okay = Okay
	OptionsPanel.cancel = Cancel
	OptionsPanel.default = Default
	OptionsPanel.refresh = Refresh
	OptionsPanel.Widgets = {}
	InterfaceOptions_AddCategory(OptionsPanel, "DKOne", 1)
	
	OptionsPanel.Widgets.enabled = CreateCheckButton(OptionsPanel, 20, -20, "Enable Add On")
	OptionsPanel.Widgets.ShowOnlyInCombat = CreateCheckButton(OptionsPanel, 20, -50, "Only Show Buttons and Labels when in combat")
	OptionsPanel.Widgets.ShowAlwaysInRaid = CreateCheckButton(OptionsPanel, 20, -80, "Always show buttons when in Raids, Instances, Bgs and Arenas, overrides the only in combat choice")
	OptionsPanel.Widgets.priorityActions = CreateCheckButton(OptionsPanel, 20, -110, "Calculate and show the 2 priority action buttons")
	OptionsPanel.Widgets.cdActions = CreateCheckButton(OptionsPanel, 20, -140, "Calculate and show the 2 cooldown action buttons")
	OptionsPanel.Widgets.showRF = CreateCheckButton(OptionsPanel, 20, -170, "Calculate and show Rune Frame")
	OptionsPanel.Widgets.frequency = CreateSlider(OptionsPanel, 20, -210, nil, .05, 1, .05, "Frequency of updates (in secs)")
	OptionsPanel.Widgets.scale = CreateSlider(OptionsPanel, 20, -260, nil, .5, 3, .05, "Scale for all elements (shrink or enlarge)")
	local resetDefaults = CreateFrame("Button", nil, OptionsPanel, "UIPanelButtonTemplate")
	resetDefaults:SetWidth(225)
	resetDefaults:SetHeight(22)
	resetDefaults:SetText("Reset All Options to Default")
	resetDefaults:SetPoint("TOPLEFT", 20, -330)
	resetDefaults:SetScript("OnClick", MyDefault)
	local labeltext = "This will reset all the options for DKOne on every page.\nIf you want to reset options on a particular page (Category),\nincluding all the tabs on that page,\ngo to that page and hit the Defaults button on the lower left,\nthen choose 'These Settings' from the Pop Up Box."
	OptionsPanel.Widgets.resetLabel = createLabel(labeltext, 5, 0, resetDefaults, "LEFT", "RIGHT", 12, {1,1,1,1}, "LEFT")
end


local function OkayAD()
	--print("In Okay AD for config interface")
	-- 1st Action Button
	DB.Action1.show = OPAD.A1.Widgets.show:GetChecked()
	DB.Action1.locked = OPAD.A1.Widgets.locked:GetChecked()
	DB.Action1.size = OPAD.A1.Widgets.size:GetNumber()
	DB.Action1.x = OPAD.A1.Widgets.x:GetNumber()
	DB.Action1.y = OPAD.A1.Widgets.y:GetNumber()
	DB.Action1.alpha = OPAD.A1.Widgets.alpha:GetValue()
	DB.Action1.borderShow = OPAD.A1.Widgets.borderShow:GetChecked()
	DB.Action1.borderThickness = OPAD.A1.Widgets.borderThickness:GetValue()
	OPAD.A1.Widgets.borderColor:GetColor(DB.Action1.borderColor)
	OPAD.A1.Widgets.borderColorRange:GetColor(DB.Action1.borderColorRange)
	OPAD.A1.Widgets.borderColorAOE:GetColor(DB.Action1.borderColorAOE)
	-- 2nd action button
	DB.Action2.show = OPAD.A2.Widgets.show:GetChecked()
	DB.Action2.locked = OPAD.A2.Widgets.locked:GetChecked()
	DB.Action2.size = OPAD.A2.Widgets.size:GetNumber()
	DB.Action2.x = OPAD.A2.Widgets.x:GetNumber()
	DB.Action2.y = OPAD.A2.Widgets.y:GetNumber()
	DB.Action2.alpha = OPAD.A2.Widgets.alpha:GetValue()
	DB.Action2.borderShow = OPAD.A2.Widgets.borderShow:GetChecked()
	DB.Action2.borderThickness = OPAD.A2.Widgets.borderThickness:GetValue()
	OPAD.A2.Widgets.borderColor:GetColor(DB.Action2.borderColor)
	OPAD.A2.Widgets.borderColorRange:GetColor(DB.Action2.borderColorRange)
	OPAD.A2.Widgets.borderColorAOE:GetColor(DB.Action2.borderColorAOE)
	-- 1st CD Button
	DB.CD1.show = OPAD.CD1.Widgets.show:GetChecked()
	DB.CD1.locked = OPAD.CD1.Widgets.locked:GetChecked()
	DB.CD1.size = OPAD.CD1.Widgets.size:GetNumber()
	DB.CD1.x = OPAD.CD1.Widgets.x:GetNumber()
	DB.CD1.y = OPAD.CD1.Widgets.y:GetNumber()
	DB.CD1.alpha = OPAD.CD1.Widgets.alpha:GetValue()
	DB.CD1.borderShow = OPAD.CD1.Widgets.borderShow:GetChecked()
	DB.CD1.borderThickness = OPAD.CD1.Widgets.borderThickness:GetValue()
	OPAD.CD1.Widgets.borderColor:GetColor(DB.CD1.borderColor)
	OPAD.CD1.Widgets.borderColorCD:GetColor(DB.CD1.borderColorCD)
	OPAD.CD1.Widgets.borderColorCDUser:GetColor(DB.CD1.borderColorCDUser)
	OPAD.CD1.Widgets.buttonColorCD:GetColor(DB.CD1.buttonColorCD)
	-- 2nd CD Button
	DB.CD2.show = OPAD.CD2.Widgets.show:GetChecked()
	DB.CD2.locked = OPAD.CD2.Widgets.locked:GetChecked()
	DB.CD2.size = OPAD.CD2.Widgets.size:GetNumber()
	DB.CD2.x = OPAD.CD2.Widgets.x:GetNumber()
	DB.CD2.y = OPAD.CD2.Widgets.y:GetNumber()
	DB.CD2.alpha = OPAD.CD2.Widgets.alpha:GetValue()
	DB.CD2.borderShow = OPAD.CD2.Widgets.borderShow:GetChecked()
	DB.CD2.borderThickness = OPAD.CD2.Widgets.borderThickness:GetValue()
	--addonTable.Redraw()
	--print("End of OkayAD")
end
local function CancelAD()
	--print("In Cancel function")
end
local function DefaultAD()
	addonTable.ResetDBAD()
	--print("End of DefaultAD")
end
local function RefreshAD()
	--print("In refresh A1 for config interface, start")
	-- 1st Action Button
	OPAD.A1.Widgets.show:SetChecked(DB.Action1.show)
	OPAD.A1.Widgets.locked:SetChecked(DB.Action1.locked)
	OPAD.A1.Widgets.size:SetNumber(DB.Action1.size)
	OPAD.A1.Widgets.x:SetNumber(DB.Action1.x)
	OPAD.A1.Widgets.y:SetNumber(DB.Action1.y)
	OPAD.A1.Widgets.alpha:SetValue(DB.Action1.alpha)
	OPAD.A1.Widgets.borderShow:SetChecked(DB.Action1.borderShow)
	OPAD.A1.Widgets.borderThickness:SetValue(DB.Action1.borderThickness)
	OPAD.A1.Widgets.borderColor:SetColor(DB.Action1.borderColor)
	OPAD.A1.Widgets.borderColorRange:SetColor(DB.Action1.borderColorRange)
	OPAD.A1.Widgets.borderColorAOE:SetColor(DB.Action1.borderColorAOE)
	-- 2nd Action Button
	OPAD.A2.Widgets.show:SetChecked(DB.Action2.show)
	OPAD.A2.Widgets.locked:SetChecked(DB.Action2.locked)
	OPAD.A2.Widgets.size:SetNumber(DB.Action2.size)
	OPAD.A2.Widgets.x:SetNumber(DB.Action2.x)
	OPAD.A2.Widgets.y:SetNumber(DB.Action2.y)
	OPAD.A2.Widgets.alpha:SetValue(DB.Action2.alpha)
	OPAD.A2.Widgets.borderShow:SetChecked(DB.Action2.borderShow)
	OPAD.A2.Widgets.borderThickness:SetValue(DB.Action2.borderThickness)
	OPAD.A2.Widgets.borderColor:SetColor(DB.Action2.borderColor)
	OPAD.A2.Widgets.borderColorRange:SetColor(DB.Action2.borderColorRange)
	OPAD.A2.Widgets.borderColorAOE:SetColor(DB.Action2.borderColorAOE)
	-- 1st Cooldown Button
	OPAD.CD1.Widgets.show:SetChecked(DB.CD1.show)
	OPAD.CD1.Widgets.locked:SetChecked(DB.CD1.locked)
	OPAD.CD1.Widgets.size:SetNumber(DB.CD1.size)
	OPAD.CD1.Widgets.x:SetNumber(DB.CD1.x)
	OPAD.CD1.Widgets.y:SetNumber(DB.CD1.y)
	OPAD.CD1.Widgets.alpha:SetValue(DB.CD1.alpha)
	OPAD.CD1.Widgets.borderShow:SetChecked(DB.CD1.borderShow)
	OPAD.CD1.Widgets.borderThickness:SetValue(DB.CD1.borderThickness)
	OPAD.CD1.Widgets.borderColor:SetColor(DB.CD1.borderColor)
	OPAD.CD1.Widgets.borderColorCD:SetColor(DB.CD1.borderColorCD)
	OPAD.CD1.Widgets.borderColorCDUser:SetColor(DB.CD1.borderColorCDUser)
	OPAD.CD1.Widgets.buttonColorCD:SetColor(DB.CD1.buttonColorCD)
	-- 2nd Cooldown Button
	OPAD.CD2.Widgets.show:SetChecked(DB.CD2.show)
	OPAD.CD2.Widgets.locked:SetChecked(DB.CD2.locked)
	OPAD.CD2.Widgets.size:SetNumber(DB.CD2.size)
	OPAD.CD2.Widgets.x:SetNumber(DB.CD2.x)
	OPAD.CD2.Widgets.y:SetNumber(DB.CD2.y)
	OPAD.CD2.Widgets.alpha:SetValue(DB.CD2.alpha)
	OPAD.CD2.Widgets.borderShow:SetChecked(DB.CD2.borderShow)
	OPAD.CD2.Widgets.borderThickness:SetValue(DB.CD2.borderThickness)
	--print("End of RefreshAD function")
end
-- Actions Display
local function CreateOptionsPanelAD()
	OPAD = CreateFrame("Frame", "OPAD", OptionsPanel)
	OPAD.name = "Priority Display"
	OPAD.parent = "DKOne"
	OPAD:SetWidth(300)
	OPAD:SetHeight(400)
	OPAD.okay = OkayAD
	OPAD.cancel = CancelAD
	OPAD.default = DefaultAD
	OPAD.refresh = RefreshAD
	OPAD.tabs = {}
	InterfaceOptions_AddCategory(OPAD, "DKOne", 2)
	
	--Action 1
	OPAD.A1 = CreateFrame("Frame", "1st Action Button", OPAD)
	OPAD.A1.Widgets = {}
	OPAD.A1.Widgets.show = CreateCheckButton(OPAD.A1, 20, -30, "Show Primary Action Button")
	OPAD.A1.Widgets.locked = CreateCheckButton(OPAD.A1, 20, -60, "Lock Primary Action Button")
	OPAD.A1.Widgets.size = CreateEditBox(OPAD.A1, 20, -90, 50, "Size of Primary Action Button", nil, "RIGHT", 1, 200, true)
	OPAD.A1.Widgets.x = CreateEditBox(OPAD.A1, 20, -120, 50, "X location of Primary Action Button\nrelative to the center of the screen", nil, "RIGHT", -1500, 1500, false)
	OPAD.A1.Widgets.y = CreateEditBox(OPAD.A1, 20, -150, 50, "Y location of Primary Action Button\nrelative to the center of the screen", nil, "RIGHT", -1500, 1500, false)
	OPAD.A1.Widgets.alpha = CreateSlider(OPAD.A1, 20, -190, nil, 0, 1, .05, "Alpha value of Primary Action Button")
	OPAD.A1.Widgets.borderShow = CreateCheckButton(OPAD.A1, 20, -220, "Show Border on Primary Action Button")
	OPAD.A1.Widgets.borderThickness = CreateSlider(OPAD.A1, 20, -250, nil, 1, 3, 1, "Border Thickness of Primary Action Button", "Thin", "Thick")
	OPAD.A1.Widgets.borderThickness:SetValueLabel("Medium")
	OPAD.A1.Widgets.borderColor = CreateColorBox(OPAD.A1, 20, -280, "Default Border Color")
	OPAD.A1.Widgets.borderColorRange = CreateColorBox(OPAD.A1, 20, -310, "Border Color when target is at range")
	OPAD.A1.Widgets.borderColorAOE = CreateColorBox(OPAD.A1, 20, -340, "Border Color when using AOE priority")
	createTab(OPAD, 1, "1st Action Button", OPAD.A1)
	--Action 2
	OPAD.A2 = CreateFrame("Frame", "2nd Action Button", OPAD)
	OPAD.A2.Widgets = {}
	OPAD.A2.Widgets.show = CreateCheckButton(OPAD.A2, 20, -30, "Show Secondary Action Button")
	OPAD.A2.Widgets.locked = CreateCheckButton(OPAD.A2, 20, -60, "Lock Secondary Action Button")
	OPAD.A2.Widgets.size = CreateEditBox(OPAD.A2, 20, -90, 50, "Size of Secondary Action Button", nil, "RIGHT", 1, 200, true)
	OPAD.A2.Widgets.x = CreateEditBox(OPAD.A2, 20, -120, 50, "X location of left side of Secondary Action Button\nrelative to the right ride of the Primary Action Button", nil, "RIGHT", -1500, 1500, false)
	OPAD.A2.Widgets.y = CreateEditBox(OPAD.A2, 20, -150, 50, "Y location of the bottom of the Secondary Action Button\nrelative to the bottom of the Primary Action Button", nil, "RIGHT", -1500, 1500, false)
	OPAD.A2.Widgets.alpha = CreateSlider(OPAD.A2, 20, -190, nil, 0, 1, .05, "Alpha value of Secondary Action Button")
	OPAD.A2.Widgets.borderShow = CreateCheckButton(OPAD.A2, 20, -220, "Show Border on Secondary Action Button")
	OPAD.A2.Widgets.borderThickness = CreateSlider(OPAD.A2, 20, -250, nil, 1, 3, 1, "Border Thickness of Secondary Action Button", "Thin", "Thick")
	OPAD.A2.Widgets.borderThickness:SetValueLabel("Medium")
	OPAD.A2.Widgets.borderColor = CreateColorBox(OPAD.A2, 20, -280, "Default Border Color")
	OPAD.A2.Widgets.borderColorRange = CreateColorBox(OPAD.A2, 20, -310, "Border Color when target is at range")
	OPAD.A2.Widgets.borderColorAOE = CreateColorBox(OPAD.A2, 20, -340, "Border Color when using AOE priority")
	createTab(OPAD, 2, "2nd Action Button", OPAD.A2)
	--CD 1
	OPAD.CD1 = CreateFrame("Frame", "1st CD Button", OPAD)
	OPAD.CD1.Widgets = {}
	OPAD.CD1.Widgets.show = CreateCheckButton(OPAD.CD1, 20, -30, "Show Primary Cooldown Button")
	OPAD.CD1.Widgets.locked = CreateCheckButton(OPAD.CD1, 20, -60, "Lock Primary Cooldown Button")
	OPAD.CD1.Widgets.size = CreateEditBox(OPAD.CD1, 20, -90, 50, "Size of Primary Cooldown Button", nil, "RIGHT", 1, 200, true)
	OPAD.CD1.Widgets.x = CreateEditBox(OPAD.CD1, 20, -120, 50, "X location of Primary Cooldown Button\nrelative to the center of the screen", nil, "RIGHT", -1500, 1500, false)
	OPAD.CD1.Widgets.y = CreateEditBox(OPAD.CD1, 20, -150, 50, "Y location of Primary Cooldown Button\nrelative to the center of the screen", nil, "RIGHT", -1500, 1500, false)
	OPAD.CD1.Widgets.alpha = CreateSlider(OPAD.CD1, 20, -190, nil, 0, 1, .05, "Alpha value of Primary Cooldown Button")
	OPAD.CD1.Widgets.borderShow = CreateCheckButton(OPAD.CD1, 20, -220, "Show Border on Primary Cooldown Button")
	OPAD.CD1.Widgets.borderThickness = CreateSlider(OPAD.CD1, 20, -250, nil, 1, 3, 1, "Border Thickness of Primary Cooldown Button", "Thin", "Thick")
	OPAD.CD1.Widgets.borderThickness:SetValueLabel("Medium")
	OPAD.CD1.Widgets.borderColor = CreateColorBox(OPAD.CD1, 20, -280, "Default Border Color")
	OPAD.CD1.Widgets.borderColorCD = CreateColorBox(OPAD.CD1, 20, -310, "Border Color when Action is on Cooldown")
	OPAD.CD1.Widgets.borderColorCDUser = CreateColorBox(OPAD.CD1, 20, -340, "Border Color when Action is resource limited or on a user defined Cooldown")
	OPAD.CD1.Widgets.buttonColorCD = CreateColorBox(OPAD.CD1, 20, -370, "Button Tint when action is on Cooldown")
	createTab(OPAD, 3, "1st Cooldown Button", OPAD.CD1)
	--CD 2
	OPAD.CD2 = CreateFrame("Frame", "2nd CD Button", OPAD)
	OPAD.CD2.Widgets = {}
	OPAD.CD2.Widgets.show = CreateCheckButton(OPAD.CD2, 20, -30, "Show Secondary Cooldown Button")
	OPAD.CD2.Widgets.locked = CreateCheckButton(OPAD.CD2, 20, -60, "Lock Secondary Cooldown Button")
	OPAD.CD2.Widgets.size = CreateEditBox(OPAD.CD2, 20, -90, 50, "Size of Secondary Cooldown Button", nil, "RIGHT", 1, 200, true)
	OPAD.CD2.Widgets.x = CreateEditBox(OPAD.CD2, 20, -120, 50, "X location of left side of Secondary Cooldown Button\nrelative to the right ride of the Primary Cooldown Button", nil, "RIGHT", -1500, 1500, false)
	OPAD.CD2.Widgets.y = CreateEditBox(OPAD.CD2, 20, -150, 50, "Y location of the bottom of Secondary Cooldown Button\nrelative to the bottom of the Primary Cooldown Button", nil, "RIGHT", -1500, 1500, false)
	OPAD.CD2.Widgets.alpha = CreateSlider(OPAD.CD2, 20, -190, nil, 0, 1, .05, "Alpha value of Secondary Cooldown Button")
	OPAD.CD2.Widgets.borderShow = CreateCheckButton(OPAD.CD2, 20, -220, "Show Border on Secondary Cooldown Button")
	OPAD.CD2.Widgets.borderThickness = CreateSlider(OPAD.CD2, 20, -250, nil, 1, 3, 1, "Border Thickness of Secondary Cooldown Button", "Thin", "Thick")
	OPAD.CD2.Widgets.borderThickness:SetValueLabel("Medium")
	createTab(OPAD, 4, "2nd Cooldown Button", OPAD.CD2)
	tabOnClick(OPAD.tabs[1])
end

local function OkayLB()
	--print("In Okay A1 for config interface, start")
	-- AOE LAbel
	DB.AOELabel.show = OPLB.AOE.Widgets.show:GetChecked()
	DB.AOELabel.showAlways = OPLB.AOE.Widgets.showAlways:GetChecked()
	DB.AOELabel.fontSize = OPLB.AOE.Widgets.fontSize:GetNumber()
	DB.AOELabel.x = OPLB.AOE.Widgets.x:GetNumber()
	DB.AOELabel.y = OPLB.AOE.Widgets.y:GetNumber()
	DB.AOELabel.AOEPrefix = OPLB.AOE.Widgets.AOEPrefix:GetText()
	OPLB.AOE.Widgets.fontColor:GetColor(DB.AOELabel.fontColor)
	DB.AOELabel.includePeriodic = OPLB.AOE.Widgets.includePeriodic:GetChecked()
	DB.AOELabel.AOEWindow = OPLB.AOE.Widgets.AOEWindow:GetNumber()
	-- TTD Label
	DB.TTDLabel.show = OPLB.TTD.Widgets.show:GetChecked()
	DB.TTDLabel.TTDBossOnly = OPLB.TTD.Widgets.TTDBossOnly:GetChecked()
	DB.TTDLabel.fontSize = OPLB.TTD.Widgets.fontSize:GetNumber()
	DB.TTDLabel.x = OPLB.TTD.Widgets.x:GetNumber()
	DB.TTDLabel.y = OPLB.TTD.Widgets.y:GetNumber()
	DB.TTDLabel.TTDPrefix = OPLB.TTD.Widgets.TTDPrefix:GetText()
	OPLB.TTD.Widgets.fontColor:GetColor(DB.TTDLabel.fontColor)
	DB.TTDLabel.TTDMaxDisplay = OPLB.TTD.Widgets.TTDMaxDisplay:GetNumber()
	DB.TTDLabel.window = OPLB.TTD.Widgets.window:GetNumber()
	-- CD Text Label
	DB.CDText.show = OPLB.CDT.Widgets.show:GetChecked()
	DB.CDText.fontSize = OPLB.CDT.Widgets.fontSize:GetNumber()
	DB.CDText.x = OPLB.CDT.Widgets.x:GetNumber()
	DB.CDText.y = OPLB.CDT.Widgets.y:GetNumber()
	DB.CDText.CDLong = OPLB.CDT.Widgets.CDLong:GetNumber()
	DB.CDText.alpha = OPLB.CDT.Widgets.alpha:GetValue()
	OPLB.CDT.Widgets.fontColorLong:GetColor(DB.CDText.fontColorLong)
	OPLB.CDT.Widgets.fontColorShort:GetColor(DB.CDText.fontColorShort)
	OPLB.CDT.Widgets.fontColorUser:GetColor(DB.CDText.fontColorUser)
	DB.CDText.fontColorLong[4] = DB.CDText.alpha
	DB.CDText.fontColorShort[4] = DB.CDText.alpha
	DB.CDText.fontColorUser[4] = DB.CDText.alpha
	--addonTable.Redraw()
	--print("In Okay LB for config interface, end")
end
local function CancelLB()
	--print("In Cancel function")
end
local function DefaultLB()
	addonTable.ResetDBLB()
	--print("End of DefaultLB")
end
local function RefreshLB()
	--print("In refresh A1 for config interface, start")
	--AOE Label	
	OPLB.AOE.Widgets.show:SetChecked(DB.AOELabel.show)
	OPLB.AOE.Widgets.showAlways:SetChecked(DB.AOELabel.showAlways)
	OPLB.AOE.Widgets.fontSize:SetNumber(DB.AOELabel.fontSize)
	OPLB.AOE.Widgets.x:SetNumber(DB.AOELabel.x)
	OPLB.AOE.Widgets.y:SetNumber(DB.AOELabel.y)
	OPLB.AOE.Widgets.AOEPrefix:SetText(DB.AOELabel.AOEPrefix)
	OPLB.AOE.Widgets.fontColor:SetColor(DB.AOELabel.fontColor)
	OPLB.AOE.Widgets.includePeriodic:SetChecked(DB.AOELabel.includePeriodic)
	OPLB.AOE.Widgets.AOEWindow:SetNumber(DB.AOELabel.AOEWindow)
	-- TTD Label
	OPLB.TTD.Widgets.show:SetChecked(DB.TTDLabel.show)
	OPLB.TTD.Widgets.TTDBossOnly:SetChecked(DB.TTDLabel.TTDBossOnly)
	OPLB.TTD.Widgets.fontSize:SetNumber(DB.TTDLabel.fontSize)
	OPLB.TTD.Widgets.x:SetNumber(DB.TTDLabel.x)
	OPLB.TTD.Widgets.y:SetNumber(DB.TTDLabel.y)
	OPLB.TTD.Widgets.TTDPrefix:SetText(DB.TTDLabel.TTDPrefix)
	OPLB.TTD.Widgets.fontColor:SetColor(DB.TTDLabel.fontColor)
	OPLB.TTD.Widgets.TTDMaxDisplay:SetNumber(DB.TTDLabel.TTDMaxDisplay)
	OPLB.TTD.Widgets.window:SetNumber(DB.TTDLabel.window)
	-- CD Text Label
	OPLB.CDT.Widgets.show:SetChecked(DB.CDText.show)
	OPLB.CDT.Widgets.fontSize:SetNumber(DB.CDText.fontSize)
	OPLB.CDT.Widgets.x:SetNumber(DB.CDText.x)
	OPLB.CDT.Widgets.y:SetNumber(DB.CDText.y)
	OPLB.CDT.Widgets.CDLong:SetNumber(DB.CDText.CDLong)
	OPLB.CDT.Widgets.alpha:SetValue(DB.CDText.alpha)
	OPLB.CDT.Widgets.fontColorLong:SetColor(DB.CDText.fontColorLong)
	OPLB.CDT.Widgets.fontColorShort:SetColor(DB.CDText.fontColorShort)
	OPLB.CDT.Widgets.fontColorUser:SetColor(DB.CDText.fontColorUser)
	--print("End of RefreshLB function")
end

local function CreateOptionsPanelLB()
	OPLB = CreateFrame("Frame", "OPLB", OptionsPanel)
	OPLB.name = "AOE/TTD/CD Timers"
	OPLB.parent = "DKOne"
	OPLB:SetWidth(300)
	OPLB:SetHeight(400)
	OPLB.okay = OkayLB
	OPLB.cancel = CancelLB
	OPLB.default = DefaultLB
	OPLB.refresh = RefreshLB
	OPLB.tabs = {}
	InterfaceOptions_AddCategory(OPLB, "DKOne", 5)
	
	-- AOE LAbel
	OPLB.AOE = CreateFrame("Frame", "AOE Label", OPLB)
	OPLB.AOE.Widgets = {}
	OPLB.AOE.Widgets.show = CreateCheckButton(OPLB.AOE, 20, -30, "Show AOE Label with number of Targets when AOEing")
	OPLB.AOE.Widgets.showAlways = CreateCheckButton(OPLB.AOE, 20, -60, "Always show AOE Label with number of Targets")
	OPLB.AOE.Widgets.fontSize = CreateEditBox(OPLB.AOE, 20, -90, 50, "Font Size of AOE Label", nil, "RIGHT", 6, 32, true)
	OPLB.AOE.Widgets.x = CreateEditBox(OPLB.AOE, 20, -120, 50, "X location of AOE Label relative to the center of the button", nil, "RIGHT", -1500, 1500, false)
	OPLB.AOE.Widgets.y = CreateEditBox(OPLB.AOE, 20, -150, 50, "Y location of AOE Label relative to the bottom of the button", nil, "RIGHT", -1500, 1500, false)
	OPLB.AOE.Widgets.AOEPrefix = CreateEditBox(OPLB.AOE, 20, -180, 50, "Display Prefix before number of targets")
	OPLB.AOE.Widgets.fontColor = CreateColorBox(OPLB.AOE, 20, -220, "Text Color of AOE Label")
	OPLB.AOE.Widgets.includePeriodic = CreateCheckButton(OPLB.AOE, 20, -260, "Include periodic damage from dots when calculating number of targets")
	OPLB.AOE.Widgets.AOEWindow = CreateEditBox(OPLB.AOE, 20, -290, 50, "Window (in secs) for damage to count towards number of AOE targets", nil, "RIGHT", 0, 10, false)
	createTab(OPLB, 1, "AOE Label", OPLB.AOE)
	-- TTD Label
	OPLB.TTD = CreateFrame("Frame", "TTD Label", OPLB)
	OPLB.TTD.Widgets = {}
	OPLB.TTD.Widgets.show = CreateCheckButton(OPLB.TTD, 20, -30, "Show Time To Die Label with how long current target has to live in secs")
	OPLB.TTD.Widgets.TTDBossOnly = CreateCheckButton(OPLB.TTD, 20, -60, "Only show TTD when target is a Boss")
	OPLB.TTD.Widgets.fontSize = CreateEditBox(OPLB.TTD, 20, -90, 50, "Font Size of TTD Label", nil, "RIGHT", 6, 32, true)
	OPLB.TTD.Widgets.x = CreateEditBox(OPLB.TTD, 20, -120, 50, "X location of TTD Label relative to the center of the button", nil, "RIGHT", -1500, 1500, false)
	OPLB.TTD.Widgets.y = CreateEditBox(OPLB.TTD, 20, -150, 50, "Y location of TTD Label relative to the Top of the button", nil, "RIGHT", -1500, 1500, false)
	OPLB.TTD.Widgets.TTDPrefix = CreateEditBox(OPLB.TTD, 20, -180, 50, "Display Prefix before the Time To Die")
	OPLB.TTD.Widgets.fontColor = CreateColorBox(OPLB.TTD, 20, -220, "Text Color of TTD Label")
	OPLB.TTD.Widgets.TTDMaxDisplay = CreateEditBox(OPLB.TTD, 20, -290, 50, "Time to die must be less than this for TTD label to display (Max TTD is 600 secs)", nil, "RIGHT", 0, 600, true)
	OPLB.TTD.Widgets.window = CreateEditBox(OPLB.TTD, 20, -320, 50, "Window of time to average over for time to die estimate", nil, "RIGHT", 1, 20, true)
	createTab(OPLB, 2, "TTD Label", OPLB.TTD)
	-- CD Labels
	OPLB.CDT = CreateFrame("Frame", "Cooldown Labels", OPLB)
	OPLB.CDT.Widgets = {}
	OPLB.CDT.Widgets.show = CreateCheckButton(OPLB.CDT, 20, -30, "Show Text on Cooldown Buttons showing time left")
	OPLB.CDT.Widgets.fontSize = CreateEditBox(OPLB.CDT, 20, -60, 50, "Font Size of Text on Cooldown Buttons", nil, "RIGHT", 6, 32, true)
	OPLB.CDT.Widgets.x = CreateEditBox(OPLB.CDT, 20, -90, 50, "X location of Text on Cooldown Button relative to the center of the button", nil, "RIGHT", -1500, 1500, false)
	OPLB.CDT.Widgets.y = CreateEditBox(OPLB.CDT, 20, -120, 50, "Y location of Text on Cooldown Button relative to the center of the button", nil, "RIGHT", -1500, 1500, false)
	OPLB.CDT.Widgets.CDLong = CreateEditBox(OPLB.CDT, 20, -150, 50, "Time left on Cooldown when it switches from Long to Short", nil, "RIGHT", 1, 180, true)
	OPLB.CDT.Widgets.alpha = CreateSlider(OPLB.CDT, 20, -190, nil, 0, 1, .05, "Alpha value of Text on Cooldown Button")
	OPLB.CDT.Widgets.fontColorLong = CreateColorBox(OPLB.CDT, 20, -230, "Text Color when cooldown is still Long")
	OPLB.CDT.Widgets.fontColorShort = CreateColorBox(OPLB.CDT, 20, -260, "Text Color when cooldown is short")
	OPLB.CDT.Widgets.fontColorUser = CreateColorBox(OPLB.CDT, 20, -290, "Text Color when cooldown is resource limited or user set")
	createTab(OPLB, 3, "Cooldown Labels", OPLB.CDT)
	tabOnClick(OPLB.tabs[1])
end

local function OkayRot()
	--print("In OK Rot function")
	-- Blood
	DB.RotationBlood.prio = OPRot.Blood.Widgets.rot:GetText()
	DB.RotationBlood.prioR = OPRot.Blood.Widgets.rotR:GetText()
	DB.RotationBlood.prioAOE = OPRot.Blood.Widgets.rotAOE:GetText()
	DB.RotationBlood.aoenum = OPRot.Blood.Widgets.rotAOEnum:GetNumber()
	-- 2H Frost
	DB.RotationFrost.prio = OPRot.Frost.Widgets.rot:GetText()
	DB.RotationFrost.prioR = OPRot.Frost.Widgets.rotR:GetText()
	DB.RotationFrost.prioAOE = OPRot.Frost.Widgets.rotAOE:GetText()
	DB.RotationFrost.aoenum = OPRot.Frost.Widgets.rotAOEnum:GetNumber()
	-- DW Frost
	DB.RotationFrostDW.prio = OPRot.FrostDW.Widgets.rot:GetText()
	DB.RotationFrostDW.prioR = OPRot.FrostDW.Widgets.rotR:GetText()
	DB.RotationFrostDW.prioAOE = OPRot.FrostDW.Widgets.rotAOE:GetText()
	DB.RotationFrostDW.aoenum = OPRot.FrostDW.Widgets.rotAOEnum:GetNumber()
	-- Unholy
	DB.RotationUnholy.prio = OPRot.Unholy.Widgets.rot:GetText()
	DB.RotationUnholy.prioR = OPRot.Unholy.Widgets.rotR:GetText()
	DB.RotationUnholy.prioAOE = OPRot.Unholy.Widgets.rotAOE:GetText()
	DB.RotationUnholy.aoenum = OPRot.Unholy.Widgets.rotAOEnum:GetNumber()
	-- Cooldown Priorities
	DB.RotationFrost.prioCD = OPRot.CDs.Widgets.CDFrost:GetText()
	DB.RotationBlood.prioCD = OPRot.CDs.Widgets.CDBlood:GetText()
	DB.RotationUnholy.prioCD = OPRot.CDs.Widgets.CDUnholy:GetText()
	
	addonTable.UpdateRotation()
	--addonTable.Redraw()
	--print("End of OkayRot function")
end
local function CancelRot()
	--print("In Cancel Rot function")
end
local function DefaultRot()
	addonTable.ResetDBRot()
	--print("End of DefaultRot function")
end
local function RefreshRot()
	--print("In Refresh Rot function")
	-- Blood
	OPRot.Blood.Widgets.rot:SetText(DB.RotationBlood.prio)
	OPRot.Blood.Widgets.rotR:SetText(DB.RotationBlood.prioR)
	OPRot.Blood.Widgets.rotAOE:SetText(DB.RotationBlood.prioAOE)
	OPRot.Blood.Widgets.rotAOEnum:SetNumber(DB.RotationBlood.aoenum)
	-- 2H Frost
	OPRot.Frost.Widgets.rot:SetText(DB.RotationFrost.prio)
	OPRot.Frost.Widgets.rotR:SetText(DB.RotationFrost.prioR)
	OPRot.Frost.Widgets.rotAOE:SetText(DB.RotationFrost.prioAOE)
	OPRot.Frost.Widgets.rotAOEnum:SetNumber(DB.RotationFrost.aoenum)
	-- DW Frost
	OPRot.FrostDW.Widgets.rot:SetText(DB.RotationFrostDW.prio)
	OPRot.FrostDW.Widgets.rotR:SetText(DB.RotationFrostDW.prioR)
	OPRot.FrostDW.Widgets.rotAOE:SetText(DB.RotationFrostDW.prioAOE)
	OPRot.FrostDW.Widgets.rotAOEnum:SetNumber(DB.RotationFrostDW.aoenum)
	-- Unholy
	OPRot.Unholy.Widgets.rot:SetText(DB.RotationUnholy.prio)
	OPRot.Unholy.Widgets.rotR:SetText(DB.RotationUnholy.prioR)
	OPRot.Unholy.Widgets.rotAOE:SetText(DB.RotationUnholy.prioAOE)
	OPRot.Unholy.Widgets.rotAOEnum:SetNumber(DB.RotationUnholy.aoenum)
	-- Cooldown Priorities
	OPRot.CDs.Widgets.CDFrost:SetText(DB.RotationFrost.prioCD)
	OPRot.CDs.Widgets.CDBlood:SetText(DB.RotationBlood.prioCD)
	OPRot.CDs.Widgets.CDUnholy:SetText(DB.RotationUnholy.prioCD)
	--print("End of RefreshRot function")
end

local function CreateOptionsPanelRot()
	
	OPRot = CreateFrame("Frame","OPRot", OptionsPanel)
	OPRot.name = "Rotations"
	OPRot.parent = "DKOne"
	OPRot:SetWidth(400)
	OPRot:SetHeight(400)
	OPRot.okay = OkayRot
	OPRot.cancel = CancelRot
	OPRot.default = DefaultRot
	OPRot.refresh = RefreshRot
	OPRot.tabs = {}
	InterfaceOptions_AddCategory(OPRot, "DKOne", 3)
	-- Blood
	OPRot.Blood = CreateFrame("Frame", "Blood Rotation", OPRot)
	OPRot.Blood.Widgets = {}
	OPRot.Blood.Widgets.Legend = CreateScrollWindow(OPRot.Blood,20, -5, 550, 280, actionsBlood)
	OPRot.Blood.Widgets.rot = CreateEditBox(OPRot.Blood, 20, -330, 550, nil, "Blood Rotation Priority", "LEFT")
	OPRot.Blood.Widgets.rotR = CreateEditBox(OPRot.Blood, 20, -380, 550, nil, "Ranged Priority", "LEFT")
	OPRot.Blood.Widgets.rotAOE = CreateEditBox(OPRot.Blood, 20, -430, 550, nil, "AOE Priority", "LEFT")
	OPRot.Blood.Widgets.rotAOEnum = CreateEditBox(OPRot.Blood, 20, -470, 30, "Number of Targets to Trigger AOE Priority (0-10)", nil,"RIGHT", 0, 10, true)
	createTab(OPRot, 1, "Blood Rotation", OPRot.Blood)
	-- Frost 2H
	OPRot.Frost = CreateFrame("Frame", "2H Frost Rotation", OPRot)
	OPRot.Frost.Widgets = {}
	OPRot.Frost.Widgets.Legend = CreateScrollWindow(OPRot.Frost,20, -5, 550, 280, actionsFrost)
	OPRot.Frost.Widgets.rot = CreateEditBox(OPRot.Frost, 20, -330, 550, nil, "Frost Rotation Priority", "LEFT")
	OPRot.Frost.Widgets.rotR = CreateEditBox(OPRot.Frost, 20, -380, 550, nil, "Ranged Priority", "LEFT")
	OPRot.Frost.Widgets.rotAOE = CreateEditBox(OPRot.Frost, 20, -430, 550, nil, "AOE Priority", "LEFT")
	OPRot.Frost.Widgets.rotAOEnum = CreateEditBox(OPRot.Frost, 20, -470, 30, "Number of Targets to Trigger AOE Priority (0-10)", nil,"RIGHT", 0, 10, true)
	createTab(OPRot, 2, "2H Frost Rotation", OPRot.Frost)
	-- Frost DW
	OPRot.FrostDW = CreateFrame("Frame", "DW Frost Rotation", OPRot)
	OPRot.FrostDW.Widgets = {}
	OPRot.FrostDW.Widgets.Legend = CreateScrollWindow(OPRot.FrostDW,20, -5, 550, 280, actionsFrost)
	OPRot.FrostDW.Widgets.rot = CreateEditBox(OPRot.FrostDW, 20, -330, 550, nil, "Frost Rotation Priority", "LEFT")
	OPRot.FrostDW.Widgets.rotR = CreateEditBox(OPRot.FrostDW, 20, -380, 550, nil, "Ranged Priority", "LEFT")
	OPRot.FrostDW.Widgets.rotAOE = CreateEditBox(OPRot.FrostDW, 20, -430, 550, nil, "AOE Priority", "LEFT")
	OPRot.FrostDW.Widgets.rotAOEnum = CreateEditBox(OPRot.FrostDW, 20, -470, 30, "Number of Targets to Trigger AOE Priority (0-10)", nil,"RIGHT", 0, 10, true)
	createTab(OPRot, 3, "DW Frost Rotation", OPRot.FrostDW)
	-- Unholy
	OPRot.Unholy = CreateFrame("Frame", "Unholy Rotation", OPRot)
	OPRot.Unholy.Widgets = {}
	OPRot.Unholy.Widgets.Legend = CreateScrollWindow(OPRot.Unholy,20, -5, 550, 280, actionsUnholy)
	OPRot.Unholy.Widgets.rot = CreateEditBox(OPRot.Unholy, 20, -330, 550, nil, "Unholy Rotation Priority", "LEFT")
	OPRot.Unholy.Widgets.rotR = CreateEditBox(OPRot.Unholy, 20, -380, 550, nil, "Ranged Priority", "LEFT")
	OPRot.Unholy.Widgets.rotAOE = CreateEditBox(OPRot.Unholy, 20, -430, 550, nil, "AOE Priority", "LEFT")
	OPRot.Unholy.Widgets.rotAOEnum = CreateEditBox(OPRot.Unholy, 20, -470, 30, "Number of Targets to Trigger AOE Priority (0-10)", nil,"RIGHT", 0, 10, true)
	createTab(OPRot, 4, "Unholy Rotation", OPRot.Unholy)
	-- Cooldowns
	OPRot.CDs = CreateFrame("Frame", "Cooldown Priorities", OPRot)
	OPRot.CDs.Widgets = {}
	OPRot.CDs.Widgets.Legend = CreateScrollWindow(OPRot.CDs,20, -20, 550, 300, actionsCD)
	OPRot.CDs.Widgets.CDBlood = CreateEditBox(OPRot.CDs, 20, -360, 550, nil, "Blood Cooldown Priority", "LEFT")
	OPRot.CDs.Widgets.CDFrost = CreateEditBox(OPRot.CDs, 20, -400, 550, nil, "Frost Cooldown Priority", "LEFT")
	OPRot.CDs.Widgets.CDUnholy = CreateEditBox(OPRot.CDs, 20, -440, 550, nil, "Unholy Cooldown Priority", "LEFT")
	createTab(OPRot, 5, "Cooldown Priorities", OPRot.CDs)
	tabOnClick(OPRot.tabs[1])
end

local function OkayDoc()
	--print("In OK Doc function")
end
local function CancelDoc()
	--print("In Cancel Doc function")
end
local function DefaultDoc()
	--print("In Default Doc function")
end
local function RefreshDoc()
	--print("End of RefreshDoc function")
end
local function CreateOptionsPanelDoc()
	OPDoc = CreateFrame("Frame", nil, OptionsPanel)
	OPDoc.name = "Documentation"
	OPDoc.parent = "DKOne"
	OPDoc:SetWidth(400)
	OPDoc:SetHeight(400)
	OPDoc.okay = OkayDoc
	OPDoc.cancel = CancelDoc
	OPDoc.default = DefaultDoc
	OPDoc.refresh = RefreshDoc
	OPDoc.Widgets = {}
	InterfaceOptions_AddCategory(OPDoc, "DKOne", 5)
	
	local Documentation = {
		Overview = {order = 1, info = "header"},
		["Priority Buttons"] = {order = 2, info = "DKOne is a combat addon for Death Knights. It features 2 pairs of buttons and a rune display. The first pair of buttons are the priority action buttons. There is a primary button and a secondary button. They show icons for the next two recommended actions the DK should take. The second pair of buttons are the priority cooldown buttons. They show icons for the next two cooldowns that are available based on how long until they are off cooldown. The rune display contains a wealth of information, showing the current rune status in an easy to understand form, as well as information about current dots, runic power, blood shields and several proccs and other information"},
		["Priority Changes"] = {order = 3, info = "The recommeded priority changes dynamically in real time based on spec and whether you are at range from your target or you are AOEing."},
		["User Set Priority"] = {order = 4, info = "The user can set the priority for each of these situations separately by editing a space separated string of commands on the configuration screen"},
		["Tracks Status"] = {order = 5, info = "DKOne tracks the status of all relevent data in real time and that information can be used to design intricate priorities like Obliterate when 2 Unholy runes and 1 Blood or Frost rune are off cooldown and runic power is less than 90 for example. Or use the raise dead cooldown when the Pillar of Frost and Rune of the Fallen Crusader buffs are both up."},
		["Display"]={order =5.1, info = "All the necessary information is displayed in an easy to understand format to show you the information you need, without cluttering your display"},
		["Lots of Options"] = {order = 6, info = "The configuration panels let you control the look and behavior of the addon. See the descriptions below for a more detailed discussion of each part of the DKOne addon."},
		DKOne = {order = 7, info = "header",},
		Enabled = {order = 9, info = "The first choice you have on this panel is whether the addon should be enabled. Unchecking this button will turn the addon off. It won't erase all the stored memory (which is only about 700k in any event), but the addon won't be consumming any processing resources. It unregisters for all events, hides the buttons, and no longer updates. Rechecking this button will start the addon up again and it will function normally like you never turned it off.",},
		["Show Only in Combat"] = {order = 10, info = "Checking this option hides all 4 buttons and the labels associated with them when not in combat. It also stops calculation of both the action and cooldown priority. It still continues to update the status variables however." },
		["Show In Raid"] = {order = 11, info = "Always shows the 4 buttons and calculates priorities, when in an instanced area, like a raid or a battleground. This behavior overrides the Only In Combat choice above. So if both buttons are checked. It will show the buttons whenever you are in combat OR you are in an instanced area."},
		["Show Priority Action Buttons"] = {order = 12, info = "Toggles on and off the Action Buttons"},
		["Show Cooldown Action Buttons"] = {order = 13, info = "Toggles on and off the Cooldown Buttons"},
		["Show the Rune Frame"] = {order = 13.1, info = "Toggles on and off the Rune Frame Display"},
		["Frequency Slider"] = {order = 14, info = "This slider control the frequency at which the status variables are updated, new priorities are calculated , and the UI elements are redrawn. It has limits of 0.05 and 1, and increments in .05 sec steps. The default value is  0.1, so everything updates 10 times per second if not changed."},
		["Scale Slider"] = {order = 14.1, info = "This slider control the display scale of all the elements. It will basically shrink or enlarge everything uniformally. I still recommend leaving it at 1 and just changing the size of each element directly, but it works perfectly well."},
		["Reset All Options"] = {order = 15, info = "Clicking this box will reset all options to their defaults immediately. There isn't a secondary confirmation and it doesnt require clicking okay to finish."},
		["Priority Display"] = {order = 16, info = "header",},
		General = {order = 17, info = "This Category controls the display of the 4 main buttons you see on your screen. 2 buttons for the actions and 2 buttons for the cooldowns. Many of the option choices are similar for each button."},
		["1st Action Button"] = {order = 17.1, info = "This is the primary priority action button. It shows an icon for the next action you should take. It is updated based on the frequency set on the DKOne configuration screen. The icon it shows is the recommended ability you should use. That ability is calculated based on the priority list supplied on the configuration screen for your current spec. The priority algorithm goes through the priority list and finds the first ability that will be off cooldown when the current Global Cooldown ends and for which you have the necessary resources, runes and runic power namely.",},
		Show = {order = 18, info = "Unchecking this will hide the primary button. It will also hide all it's children, specifically, the secondary action button, the AOE label, and the TTD label."},
		Lock = {order = 19, info = "Unchecking this will allow you to move the button around on the screen by left clicking on it and dragging it to a new location. That location will be saved and the button will always appear there until you move it again. Its children, the secondary action button and the AOE and TTD labels, will also move with it. While it is unlocked you will not be able to click through it, say to drop a DnD, so it's good practice to relock it when you are done moving it."},
		Size = {order = 19, info = "The button is always square, this sets its size in terms of pixels. The entered value must be numeric and will default to 1 or 200 if the entered value is smaller or larger."},
		["X Location"] = {order = 20, info = "Rather than unlocking and dragging the button around, you can also input its location directly. The x location is the horizontal distance between the center of the button and the center of your screen in pixels. The right side of your screen would be positive and the left would be negative."},
		["Y Location"] = {order = 21, info = "The y location is the vertical distance between the center of the button and the center of your screen in pixels. The upper half of your screen would be positive and the lower half would be negative."},
		["Alpha Value Slider"] = {order = 22, info = "The alpha value controls how transparent the button is with 0 being completely transparent (invisible) and 1 being completely opaque. The current value is shown below the slider, which goes from 0 to 1 in  0.05 step increments. The alpha value also sets the alpha value for the secondary button and the AOE and TTD labels."},
		["Show Border"] = {order = 23, info = "Show the border around the button. The border conveys important information about whether the target is at range or you are aoeing."},
		["Border Thickness"] = {order = 24, info = "Sets how thick the border around the button is. There are 3 choices."},
		["Default Border Color"] = {order = 25, info = "The box shows the default border color that is displayed when you are in melee range and are not in the AOE mode. By clicking on the box, a color picker box pops up. The wheel part lets you set the red, blue, and green component. The middle column lets you set the darkness. The far right slider sets the alpha value. With those you can set the color and alpha value for the border. The color will be displayed in the box when you hit okay on the color picker box, but the value won't be saved and set on your actual border until you hit okay on the interface box."},
		["Range Border Color"] = {order = 26, info = "Everytime the addon updates it checks if you are in melee range. If you are not targeting anything or you are targeting a friendly mob, then it assumes you are in melee range as well. It only determines you are not in melee range if you have a targeted a hostile mob that cannot be hit with a melee attack. When it determines you are out of melee range it does two things, it changes the border color and it changes the priority to the range priority as set on the spec specific rotation configuration screen."},
		["AOE Border Color"] = {order = 27, info = "Similar to the range check, the addon also determines when you are AOEing. When it does, it changes the border color and priority as well. More description of how the Addon determines when you are aoeing can be found under the AOE label discussion."},
		["Second Action Button"] = {order = 28, info = "The secondary priority action button behaves similar to the primary one. It shows the recommeded action to be carried out after the first action. It accounts for the GCD which will pass between the two actions as well as the resources that will be used or gained by the first action. You can hide or show this button independently from the first one. Also it may be moved independently as well if unlocked. If you input the coordinates for the button, note they are relative to the primary action button, not the center of the screen. Specifically from the the lower right corner of the primary button to the lower left corner of the secondary action button."},
		["General Cooldown Info"] = {order = 28.1, info = "Cooldowns are similar to priority actions, but differ in subtle ways. Each spec has a priority list which is set on the Cooldown Priorities configuration screen. The addon goes through that list in order and returns the two cooldown actions that will be off cooldown first. The same cooldown action can't be returned twice even if it doesn't actually have any cooldown. Also the addon doesn't account for resources, for example it doesn't check that you have the runic power to cast dancing rune weapon, although it will let you know via border colors if this is the case as discussed below.\n \tVery complicated checks can be performed by editing the code to account for specific conditions. The best example of this is the raise dead cooldown while in frost spec. I have calculated very precise conditions as to when to use this cooldown, based on the two trinkets I typically use, Eye of Unmaking and Creche of the Final Dragon, as well as Pillar of Frost and Rune of the Fallen Crusader. Unfortunately I haven't done this for all specs and cooldowns or the various trinket combinations. However, I encourage people that are mildly savvy to dive in and modify the cooldown actions to exactly meet their needs. \n \tThe options for the Cooldown buttons are very similar to the Priority Action Buttons. The border colors are the principal difference."},
		["Border Color, Action is on Cooldown"] = {order = 28.2, info = "This color is applied to buttons border if the action is on its native cooldown."},
		["Border Color, User Defined Cooldown"] = {order = 28.3, info = "This color is applied to the button border if its off its native cooldown, but the cooldown shouldnt be used, either because you dont have the runes or runic power or because its on a user defined cooldown. A user defined cooldown might be used to sync it up with other cooldowns, like casting raise dead, when Pillar of Frost and Rune of the Fallen Crusader are up, or for something like Empower Rune Weapon, you only want to use it when you are low on resources."},
		["Button Tint, Action is on Cooldown"] = {order = 28.4, info = "This just gives the whole button a tint when the action is on its native cooldown (as opposed to just coloring the border.)"},
		["Second Cooldown Button"] = {order = 28.5, info = "The border colors and button tinting for the second button are the same as the first button. Although to be clear, the action in the first cooldown button might be on a native coolodwn and be one color and the action in the second button might be on a resource cooldown and be a different color, or vice versa."},
		["AOE/TTD/CD Timers"] = {order = 30, info = "header",},
		["AOE Label"] = {order = 31, info = "The addon tracks the unfiltered combat log events and keeps track of how many different mobs you have damaged recently, if it detects that you have damaged more than the AOE threshold number set on the spec rotation page then it goes into AOE mode. It changes the color of the button border and depending on the settings below shows a label with current number of mobs being damaged.",},
		["Show AOE Label"] = {order = 32, info = "When this is checked a label appears below the primary action button whenever you are in AOE mode showing the current number of mobs you are hitting.",},
		["Always Show AOE Label"] = {order = 33, info = "This overides the above behavior, so the AOE label with the current number of mobs is always displayed regardless of whether you are in AOE mode. The label will be displayed even if the Show AOE Labels option above is unchecked. If you want to completetly turn off the AOE label uncheck both of these buttons.",},
		["Font Size"] = {order = 34, info = "This controls the size of the label. Input a positive number, the minimum value is 6 and the maximum is 32."},
		["Location"] = {order = 35, info = "The x and y coordinates are relative to the bottom center of the Primary Action button and the top center of the AOE label."},
		["Prefix"] = {order = 36, info = "This is just a bit of text that gets put in front of the number of mobs you are hitting. Leave it empty if you just want the number displayed."},
		["Calculating Number of AOE Targets"] = {order = 37, info = "The addon keeps track of how many unique mobs you have damaged within a certain time frame. It keeps a table with each mobs unique id and the most recent time stamp when that mob was damaged. When a time stamp gets older than a certain cutoff (set below) that id is removed from the table. There is a bit of tradeoff here, we want the addon to be smart about switching modes, but we dont want to do a lot of extra calculations either. Many of the situations are very fight specific and you shouldnt be hesitant about changing settings between fights to get the right sort of behavior. If you dont want the addon ever switching into the AOE priority just set the number of required targets very high. You can also set the parameters below to help achieve the desired behavior."},
		["Periodic Damage"] = {order = 38, info = "Checking this box indicates that the damage from your diseases should be counted toward damaging mobs for the purposes of calculating the AOE number. Generally this should be checked. The situation when you might want to uncheck it is in fights when you are target switching while your current target is dotted up and still alive. If you run over to a new target, some distance away, while dots are still ticking on your old targets, the addon may think you should still be in AOE mode even though you are currently attacking a single target."},
		["AOE Window"] = {order = 39, info = "This is the timeframe which damage to mobs will count towards your AOE number. If it is set at 4 for example, a mob you damaged 5 seconds ago won't count, but one you damaged 3 seconds ago would. It really controls how fast you drop out of AOE mode. It has a minimum value of 0 and a maximum value of 10 seconds. You can enter AOE mode as soon as you hit the required number of targets, so a howling blast or a blood boil can put you into AOE mode instantly. However, if you have this parameter set to 10 seconds for example, even if all the mobs died from that initial howling blast, it would continue to recommend the AOE piority for 10 seconds. On the other hand if you set this to 1 second say, then the addon is probably going to be constantly swapping priorities from single target to AOE, since your howling blasts, for example, are more than 1 second apart. 3 seconds is an important benchmark since that's how often diseases tick. Dont be afraid to tweak this number to get the behavior that suits you best."},
		["Time To Die Label"] = {order = 41, info = "TTD is Time To Die, it's an estimate of how long until the current mob dies given the current rate of damage. The estimate is based on how much the current targets health has decreased recently. It isn't displayed if you dont have a target, your current target is not hostile, the current targets healh has not decreased, or the health goes up (due to healing). It is most accurate in large boss fights where the target is taking lots of steady damage. It's not as accurate if damage is sporadic or widely varying or you just switched to a new target."},
		["TTD Label Location"] = {order = 42, info = "The label location is in reference to the top center of the primary action button and the bottom center of the label."},
		["Display Time"] = {order = 43, info = "The TTD is only displayed when it is less than this number, between 0 and 600 (10 minutes)."},
		["Window of Time"] = {order = 44, info = "The TTD is calculated by how much the mob's health has decreased over a set period of time. The estimate starts immediately, so if you have only targeted a mob for half a second, it will look at how much the mob's health has gone down in the last half second and make an estimate of the TTD, it most likely won't be a very good one. As you target a mob continously, the addon has a longer window of time to observe the mob's health and make an estimate. When this parameter is set to 10 for example, once you have observed a mob for more than 10 seconds, it looks at how much the mobs health has decreased in the last 10 seconds to make an estimate."},
		["Cooldown Timers"] = {order = 45, info = "Many people use the addon OmniCC to automatically put actual timers on cooldowns (the clocklike swirl on the button). That functionality is turned off for the cooldown buttons, but this Text mimics that function. If this option is shown, then a timer in seconds is overlayed on both buttons showing how long the cooldown has left. The text of that timer can be 3 different colors. One color for when there is lots of time left on the cooldown, a second one when there is a short amount of time left on the cooldown, and a third color if the cooldown is created by a lack of resources or is user defined. You can also set the timing for when the color changes from long to short."},
		["Rotations"] = {order = 53, info = "header"},
		["Roatation Info"] = {order = 54, info = "There are 3 separate tabs to set the rotations for each spec. When you change specs, the addon automatically grabs the priorities listed on that tab. Each specs Rotation Configuration tab has a legend showing possible action choices and then 3 edit boxes where you can enter your priorities."},
		["Legend"] = {order = 55, info = "The legend is a scroll box containing all the possible actions you can enter into the priorities list. There is a one word key that you can enter into the priority list, followed by a description of that action. The list shows general abilities that every DK can use and the spec specific ones that are more aimed at specific specs. You are free to use actions from any spec, but the addon does an internal check and weeds out action that reference abilities which are not useable by you in your current spec."},
		["Rotation"] = {order = 56, info = "The first priority list is the general one, that is used when you are in melee range and not in AOE mode. It consists of a single space separated list of keys from the Legend Table."},
		["Ranged and AOE Rotations"] = {order = 57, info = "These lists work the same way as the general rotation list."},
		["Number of Targets"] = {order = 58, info = "This is the spec specific number of targets you must damage in the AOE window in order to trigger the AOE mode, which switches the priority to the AOE priority listed above."},
		["Cooldown Priorities"] = {order = 60, info = "The actions listed in the cooldown legend are different than the actions listed on the previous pages, even if you use the same name its referring to a different set of data, so for example you might have blood tap as a priority action and a cooldown action and they would be referring to two different checks."},
		["Rune Display"] = {order = 61, info = "header"},
		["Rune Frame"] = {order = 62, info = "This displays the runes. It is fully customizable. It includes lots of other information in addition to just the status of your runes, like dot timers, runic power, procs, and blood shields"},
		["Rune Frame Size"] = {order = 63, info = "The size of the Rune Frame is determined automatically by the size of the runes, their orientation and the padding between runes, all of which is set on the runes tab."},
		["Lock Rune Frame"] = {order = 64, info = "The Rune Frame and all its various parts can be dragged around when unlocked. I highly recommend relocking when you are done moving it, otherwise you wont be able to click the screen under the display."},
		["Order of Runes"] = {order = 65, info = "You can set the runes in any order you want, they are ordered from top to bottom or left to right depending on their orientation"},
		["Runes"] = {order = 66, info = "You can set the size and orientation of the runes, their colors under different circumstances, a label to appear on top of them showing time left on CD, and whether they flash when they come off cooldown"},
		["Rune Labels"] = {order = 67, info = "The time left on runes is how long in seconds until it comes off cooldown. You may like that feature or you may find it needlesly clutters your display. You can set the format to show one decimal place or not and whether to show overall duration after the current cooldown."},
		["Rune Flash"] = {order = 68, info = "This feature causes the runes to change colors (typically lighter, hence flash) for some period of time immediately after they come off cooldown."},
		["Rune Colors"] = {order = 69, info = "You can customize all the rune colors if you want, including their color when they are on cooldown, and when they have just come off cooldown."},
		["Dots"] = {order = 70, info = "Dots are the frost fever and blood plague on your current target. There is no support for multidotting or tracking dots on multiple mobs. Each dot has its own bar and label showing the time left on the dot."},
		["Location of Dot Bars"] = {order = 71, info = "You may not be familiar with the inner workings of the Warcraft UI, but everything displayed is located relative to something else. All the sub-elements of the Rune Display are located relative to the main block or rectangle of the Rune Frame. So when the option says Anchor From: TOPLEFT, that means the element, like the frost fever bar for example, is always placed placed relative to that corner and if you move the Rune Frame you will also move the frost fever bar."},
		["Runic Power"] = {order = 72, info = "This bar shows your current Runic Power. you can leave the width or height at zero if you want it to automatically match the width or height of the Rune Frame and you can turn on and off the label display"},
		["Dividing Lines"] = {order = 73, info = "This feature puts thin white lines indicating where each runic power dump falls. For example if you are a glyphed frost DK so Frost Strike costs 32 runic power it will put lines at 32, 64, 96, and 128 runic power. If you were unholy and death coil costs 34, then the lines are at 34, 68, and 102. For blood it would be at 30, 60, 90, and 120 for rune strike. Obviously it doesn't show the last line if your max runic power is less than that."},
		["Buttons 1-4"] = {order = 74, info = "These buttons show information about procs and other buffs. They change depending on what spec you are in and some buttons show multiple information, like button 3 for frost dks will show time left on the Pillar of Frost buff, or Bloodlust or how long you have left on your ghoul. They will show stacks for things like rime and sudden doom, or duration for things like ghoul or bloodlust."},
		["Blood Shield"] = {order = 75, info = "The blood shield information is only displayed in blood spec and is based on the information in the blood shield buff. The width of the bar is equal to your current maximum health which is the maximum value the shield can take. As you build up your blood shield it fills the bar, if you take damage and some of the shield is removed the value reduces."},
		["Duration Spark"] = {order = 76, info = "Blood shields last 10 seconds if they aren't refreshed. A small vertical line moves across the bottom of the blood shield bar from right to left indicating the time left before the shield falls off. This allows you to time your death strike to refresh it before it is lost."},
		}
	OPDocLegend = CreateScrollWindow(OPDoc,20, -20, 550, 500, Documentation, true)
end

local function OkayRF()
	--print("In OK RF function")
	-- RuneFrame
	DB.RuneFrame.locked = OPRF.RuneFrame.Widgets.locked:GetChecked()
	DB.RuneFrame.x = OPRF.RuneFrame.Widgets.x:GetNumber()
	DB.RuneFrame.y = OPRF.RuneFrame.Widgets.y:GetNumber()
	OPRF.RuneFrame.Widgets.colorRFbg:GetColor(DB.RuneFrame.colorRFbg)
	DB.RuneFrame.runeOrder = OPRF.RuneFrame.Widgets.runeOrder:GetValue()
	--Runes
	DB.RuneFrame.runeOrientation = OPRF.Runes.Widgets.runeOrientation:GetValue()
	DB.RuneFrame.widthR = OPRF.Runes.Widgets.widthR:GetNumber()
	DB.RuneFrame.heightR = OPRF.Runes.Widgets.heightR:GetNumber()
	DB.RuneFrame.padding = OPRF.Runes.Widgets.padding:GetNumber()
	OPRF.Runes.Widgets.colorRbg:GetColor(DB.RuneFrame.colorRbg)
	DB.RuneFrame.showRlabels = OPRF.Runes.Widgets.showRlabels:GetChecked()
	DB.RuneFrame.formatRlabels = OPRF.Runes.Widgets.formatRlabels:GetValue()
	DB.RuneFrame.offxRlabels = OPRF.Runes.Widgets.offxRlabels:GetNumber()
	DB.RuneFrame.offyRlabels = OPRF.Runes.Widgets.offyRlabels:GetNumber()
	DB.RuneFrame.fontsizeRlabels = OPRF.Runes.Widgets.fontsizeRlabels:GetNumber()
	DB.RuneFrame.doFlash = OPRF.Runes.Widgets.doFlash:GetChecked()
	DB.RuneFrame.flashTimer = OPRF.Runes.Widgets.flashTimer:GetValue()
	--Rune Colors
	OPRF.Runes.Widgets.colorRdarkB:GetColor(DB.RuneFrame.colorRdark[1])
	OPRF.Runes.Widgets.colorRdarkU:GetColor(DB.RuneFrame.colorRdark[2])
	OPRF.Runes.Widgets.colorRdarkF:GetColor(DB.RuneFrame.colorRdark[3])
	OPRF.Runes.Widgets.colorRdarkD:GetColor(DB.RuneFrame.colorRdark[4])
	OPRF.Runes.Widgets.colorRB:GetColor(DB.RuneFrame.colorR[1])
	OPRF.Runes.Widgets.colorRU:GetColor(DB.RuneFrame.colorR[2])
	OPRF.Runes.Widgets.colorRF:GetColor(DB.RuneFrame.colorR[3])
	OPRF.Runes.Widgets.colorRD:GetColor(DB.RuneFrame.colorR[4])
	OPRF.Runes.Widgets.colorRlightB:GetColor(DB.RuneFrame.colorRlight[1])
	OPRF.Runes.Widgets.colorRlightU:GetColor(DB.RuneFrame.colorRlight[2])
	OPRF.Runes.Widgets.colorRlightF:GetColor(DB.RuneFrame.colorRlight[3])
	OPRF.Runes.Widgets.colorRlightD:GetColor(DB.RuneFrame.colorRlight[4])
	--Dots
	DB.RuneFrame.showDots = OPRF.Dots.Widgets.showDots:GetChecked()
	DB.RuneFrame.orientDots = OPRF.Dots.Widgets.orientDots:GetValue()
	DB.RuneFrame.widthDots = OPRF.Dots.Widgets.widthDots:GetNumber()
	DB.RuneFrame.heightDots = OPRF.Dots.Widgets.heightDots:GetNumber()
	DB.RuneFrame.showDlabels = OPRF.Dots.Widgets.showDlabels:GetChecked()
	DB.RuneFrame.formatDlabels = OPRF.Dots.Widgets.formatDlabels:GetValue()
	DB.RuneFrame.offxDlabels = OPRF.Dots.Widgets.offxDlabels:GetNumber()
	DB.RuneFrame.offyDlabels = OPRF.Dots.Widgets.offyDlabels:GetNumber()
	DB.RuneFrame.fontsizeDlabels = OPRF.Dots.Widgets.fontsizeDlabels:GetNumber()
	DB.RuneFrame.pointFFparent = OPRF.Dots.Widgets.pointFFparent:GetValue()
	DB.RuneFrame.pointFF = OPRF.Dots.Widgets.pointFF:GetValue()
	DB.RuneFrame.offxFF = OPRF.Dots.Widgets.offxFF:GetNumber()
	DB.RuneFrame.offyFF = OPRF.Dots.Widgets.offyFF:GetNumber()
	DB.RuneFrame.pointBPparent = OPRF.Dots.Widgets.pointBPparent:GetValue()
	DB.RuneFrame.pointBP = OPRF.Dots.Widgets.pointBP:GetValue()
	DB.RuneFrame.offxBP = OPRF.Dots.Widgets.offxBP:GetNumber()
	DB.RuneFrame.offyBP = OPRF.Dots.Widgets.offyBP:GetNumber()
	OPRF.Dots.Widgets.colorFF:GetColor(DB.RuneFrame.colorFF)
	OPRF.Dots.Widgets.colorFFbg:GetColor(DB.RuneFrame.colorFFbg)
	OPRF.Dots.Widgets.colorBP:GetColor(DB.RuneFrame.colorBP)
	OPRF.Dots.Widgets.colorBPbg:GetColor(DB.RuneFrame.colorBPbg)
	--Runic Power
	DB.RuneFrame.showRP = OPRF.RP.Widgets.showRP:GetChecked()
	DB.RuneFrame.orientRP = OPRF.RP.Widgets.orientRP:GetValue()
	DB.RuneFrame.widthRP = OPRF.RP.Widgets.widthRP:GetNumber()
	DB.RuneFrame.heightRP = OPRF.RP.Widgets.heightRP:GetNumber()
	DB.RuneFrame.showRPlabels = OPRF.RP.Widgets.showRPlabels:GetChecked()
	DB.RuneFrame.formatRPlabels = OPRF.RP.Widgets.formatRPlabels:GetValue()
	DB.RuneFrame.offxRPlabels = OPRF.RP.Widgets.offxRPlabels:GetNumber()
	DB.RuneFrame.offyRPlabels = OPRF.RP.Widgets.offyRPlabels:GetNumber()
	DB.RuneFrame.fontsizeRPlabels = OPRF.RP.Widgets.fontsizeRPlabels:GetNumber()
	DB.RuneFrame.pointRPparent = OPRF.RP.Widgets.pointRPparent:GetValue()
	DB.RuneFrame.pointRP = OPRF.RP.Widgets.pointRP:GetValue()
	DB.RuneFrame.offxRP = OPRF.RP.Widgets.offxRP:GetNumber()
	DB.RuneFrame.offyRP = OPRF.RP.Widgets.offyRP:GetNumber()
	OPRF.RP.Widgets.colorRP:GetColor(DB.RuneFrame.colorRP)
	OPRF.RP.Widgets.colorRPbg:GetColor(DB.RuneFrame.colorRPbg)
	DB.RuneFrame.showSpark = OPRF.RP.Widgets.showSpark:GetChecked()
	--Buttons 1/2
	DB.RuneFrame.showB1 = OPRF.BT.Widgets.showB1:GetChecked()
	DB.RuneFrame.sizeB1 = OPRF.BT.Widgets.sizeB1:GetNumber()
	DB.RuneFrame.showB1labels = OPRF.BT.Widgets.showB1labels:GetChecked()
	DB.RuneFrame.offxB1labels = OPRF.BT.Widgets.offxB1labels:GetNumber()
	DB.RuneFrame.offyB1labels = OPRF.BT.Widgets.offyB1labels:GetNumber()
	DB.RuneFrame.fontsizeB1labels = OPRF.BT.Widgets.fontsizeB1labels:GetNumber()
	DB.RuneFrame.pointB1parent = OPRF.BT.Widgets.pointB1parent:GetValue()
	DB.RuneFrame.pointB1 = OPRF.BT.Widgets.pointB1:GetValue()
	DB.RuneFrame.offxB1 = OPRF.BT.Widgets.offxB1:GetNumber()
	DB.RuneFrame.offyB1 = OPRF.BT.Widgets.offyB1:GetNumber()
	OPRF.BT.Widgets.fontColorB1:GetColor(DB.RuneFrame.fontColorB1)
	DB.RuneFrame.showB2 = OPRF.BT.Widgets.showB2:GetChecked()
	DB.RuneFrame.sizeB2 = OPRF.BT.Widgets.sizeB2:GetNumber()
	DB.RuneFrame.showB2labels = OPRF.BT.Widgets.showB2labels:GetChecked()
	DB.RuneFrame.offxB2labels = OPRF.BT.Widgets.offxB2labels:GetNumber()
	DB.RuneFrame.offyB2labels = OPRF.BT.Widgets.offyB2labels:GetNumber()
	DB.RuneFrame.fontsizeB2labels = OPRF.BT.Widgets.fontsizeB2labels:GetNumber()
	DB.RuneFrame.pointB2parent = OPRF.BT.Widgets.pointB2parent:GetValue()
	DB.RuneFrame.pointB2 = OPRF.BT.Widgets.pointB2:GetValue()
	DB.RuneFrame.offxB2 = OPRF.BT.Widgets.offxB2:GetNumber()
	DB.RuneFrame.offyB2 = OPRF.BT.Widgets.offyB2:GetNumber()
	OPRF.BT.Widgets.fontColorB2:GetColor(DB.RuneFrame.fontColorB2)
	--Buttons 3/4
	DB.RuneFrame.showB3 = OPRF.BT2.Widgets.showB3:GetChecked()
	DB.RuneFrame.sizeB3 = OPRF.BT2.Widgets.sizeB3:GetNumber()
	DB.RuneFrame.showB3labels = OPRF.BT2.Widgets.showB3labels:GetChecked()
	DB.RuneFrame.offxB3labels = OPRF.BT2.Widgets.offxB3labels:GetNumber()
	DB.RuneFrame.offyB3labels = OPRF.BT2.Widgets.offyB3labels:GetNumber()
	DB.RuneFrame.fontsizeB3labels = OPRF.BT2.Widgets.fontsizeB3labels:GetNumber()
	DB.RuneFrame.pointB3parent = OPRF.BT2.Widgets.pointB3parent:GetValue()
	DB.RuneFrame.pointB3 = OPRF.BT2.Widgets.pointB3:GetValue()
	DB.RuneFrame.offxB3 = OPRF.BT2.Widgets.offxB3:GetNumber()
	DB.RuneFrame.offyB3 = OPRF.BT2.Widgets.offyB3:GetNumber()
	OPRF.BT2.Widgets.fontColorB3:GetColor(DB.RuneFrame.fontColorB3)
	DB.RuneFrame.showB4 = OPRF.BT2.Widgets.showB4:GetChecked()
	DB.RuneFrame.sizeB4 = OPRF.BT2.Widgets.sizeB4:GetNumber()
	DB.RuneFrame.showB4labels = OPRF.BT2.Widgets.showB4labels:GetChecked()
	DB.RuneFrame.offxB4labels = OPRF.BT2.Widgets.offxB4labels:GetNumber()
	DB.RuneFrame.offyB4labels = OPRF.BT2.Widgets.offyB4labels:GetNumber()
	DB.RuneFrame.fontsizeB4labels = OPRF.BT2.Widgets.fontsizeB4labels:GetNumber()
	DB.RuneFrame.pointB4parent = OPRF.BT2.Widgets.pointB4parent:GetValue()
	DB.RuneFrame.pointB4 = OPRF.BT2.Widgets.pointB4:GetValue()
	DB.RuneFrame.offxB4 = OPRF.BT2.Widgets.offxB4:GetNumber()
	DB.RuneFrame.offyB4 = OPRF.BT2.Widgets.offyB4:GetNumber()
	OPRF.BT2.Widgets.fontColorB4:GetColor(DB.RuneFrame.fontColorB4)
	--Blood Shield
	DB.RuneFrame.showBS = OPRF.BS.Widgets.showBS:GetChecked()
	DB.RuneFrame.showBSempty = OPRF.BS.Widgets.showBSempty:GetChecked()
	DB.RuneFrame.orientBS = OPRF.BS.Widgets.orientBS:GetValue()
	DB.RuneFrame.widthBS = OPRF.BS.Widgets.widthBS:GetNumber()
	DB.RuneFrame.heightBS = OPRF.BS.Widgets.heightBS:GetNumber()
	DB.RuneFrame.showBSlabels = OPRF.BS.Widgets.showBSlabels:GetChecked()
	DB.RuneFrame.showBSlabelszero = OPRF.BS.Widgets.showBSlabelszero:GetChecked()
	DB.RuneFrame.offxBSlabels = OPRF.BS.Widgets.offxBSlabels:GetNumber()
	DB.RuneFrame.offyBSlabels = OPRF.BS.Widgets.offyBSlabels:GetNumber()
	DB.RuneFrame.fontsizeBSlabels = OPRF.BS.Widgets.fontsizeBSlabels:GetNumber()
	DB.RuneFrame.pointBSparent = OPRF.BS.Widgets.pointBSparent:GetValue()
	DB.RuneFrame.pointBS = OPRF.BS.Widgets.pointBS:GetValue()
	DB.RuneFrame.offxBS = OPRF.BS.Widgets.offxBS:GetNumber()
	DB.RuneFrame.offyBS = OPRF.BS.Widgets.offyBS:GetNumber()
	OPRF.BS.Widgets.colorBS:GetColor(DB.RuneFrame.colorBS)
	OPRF.BS.Widgets.colorBSbg:GetColor(DB.RuneFrame.colorBSbg)
	DB.RuneFrame.showBSSpark = OPRF.BS.Widgets.showBSSpark:GetChecked()
	DB.RuneFrame.sparkWidth = OPRF.BS.Widgets.sparkWidth:GetNumber()
	DB.RuneFrame.sparkHeight = OPRF.BS.Widgets.sparkHeight:GetNumber()
	addonTable.Redraw()
	--print("End of OkayRF function")
end
local function CancelRF()
	--print("In Cancel RF function")
end
local function DefaultRF()
	addonTable.ResetDBRF()
	--print("End of DefaultRF function")
end
local function RefreshRF()
	--print("In Refresh RF function")
	-- RuneFrame
	OPRF.RuneFrame.Widgets.locked:SetChecked(DB.RuneFrame.locked)
	OPRF.RuneFrame.Widgets.x:SetNumber(DB.RuneFrame.x)
	OPRF.RuneFrame.Widgets.y:SetNumber(DB.RuneFrame.y)
	OPRF.RuneFrame.Widgets.colorRFbg:SetColor(DB.RuneFrame.colorRFbg)
	OPRF.RuneFrame.Widgets.runeOrder:SetValue(DB.RuneFrame.runeOrder)
	--Runes
	OPRF.Runes.Widgets.runeOrientation:SetValue(DB.RuneFrame.runeOrientation)
	OPRF.Runes.Widgets.widthR:SetNumber(DB.RuneFrame.widthR)
	OPRF.Runes.Widgets.heightR:SetNumber(DB.RuneFrame.heightR)
	OPRF.Runes.Widgets.padding:SetNumber(DB.RuneFrame.padding)
	OPRF.Runes.Widgets.colorRbg:SetColor(DB.RuneFrame.colorRbg)
	OPRF.Runes.Widgets.showRlabels:SetChecked(DB.RuneFrame.showRlabels)
	OPRF.Runes.Widgets.formatRlabels:SetValue(DB.RuneFrame.formatRlabels)
	OPRF.Runes.Widgets.offxRlabels:SetNumber(DB.RuneFrame.offxRlabels)
	OPRF.Runes.Widgets.offyRlabels:SetNumber(DB.RuneFrame.offyRlabels)
	OPRF.Runes.Widgets.fontsizeRlabels:SetNumber(DB.RuneFrame.fontsizeRlabels)
	OPRF.Runes.Widgets.doFlash:SetChecked(DB.RuneFrame.doFlash)
	OPRF.Runes.Widgets.flashTimer:SetValue(DB.RuneFrame.flashTimer)
	--Rune Colors
	OPRF.Runes.Widgets.colorRdarkB:SetColor(DB.RuneFrame.colorRdark[1])
	OPRF.Runes.Widgets.colorRdarkU:SetColor(DB.RuneFrame.colorRdark[2])
	OPRF.Runes.Widgets.colorRdarkF:SetColor(DB.RuneFrame.colorRdark[3])
	OPRF.Runes.Widgets.colorRdarkD:SetColor(DB.RuneFrame.colorRdark[4])
	OPRF.Runes.Widgets.colorRB:SetColor(DB.RuneFrame.colorR[1])
	OPRF.Runes.Widgets.colorRU:SetColor(DB.RuneFrame.colorR[2])
	OPRF.Runes.Widgets.colorRF:SetColor(DB.RuneFrame.colorR[3])
	OPRF.Runes.Widgets.colorRD:SetColor(DB.RuneFrame.colorR[4])
	OPRF.Runes.Widgets.colorRlightB:SetColor(DB.RuneFrame.colorRlight[1])
	OPRF.Runes.Widgets.colorRlightU:SetColor(DB.RuneFrame.colorRlight[2])
	OPRF.Runes.Widgets.colorRlightF:SetColor(DB.RuneFrame.colorRlight[3])
	OPRF.Runes.Widgets.colorRlightD:SetColor(DB.RuneFrame.colorRlight[4])
	--Dots
	OPRF.Dots.Widgets.showDots:SetChecked(DB.RuneFrame.showDots)
	OPRF.Dots.Widgets.orientDots:SetValue(DB.RuneFrame.orientDots)
	OPRF.Dots.Widgets.widthDots:SetNumber(DB.RuneFrame.widthDots)
	OPRF.Dots.Widgets.heightDots:SetNumber(DB.RuneFrame.heightDots)
	OPRF.Dots.Widgets.showDlabels:SetChecked(DB.RuneFrame.showDlabels)
	OPRF.Dots.Widgets.formatDlabels:SetValue(DB.RuneFrame.formatDlabels)
	OPRF.Dots.Widgets.offxDlabels:SetNumber(DB.RuneFrame.offxDlabels)
	OPRF.Dots.Widgets.offyDlabels:SetNumber(DB.RuneFrame.offyDlabels)
	OPRF.Dots.Widgets.fontsizeDlabels:SetNumber(DB.RuneFrame.fontsizeDlabels)
	OPRF.Dots.Widgets.pointFFparent:SetValue(DB.RuneFrame.pointFFparent)
	OPRF.Dots.Widgets.pointFF:SetValue(DB.RuneFrame.pointFF)
	OPRF.Dots.Widgets.offxFF:SetNumber(DB.RuneFrame.offxFF)
	OPRF.Dots.Widgets.offyFF:SetNumber(DB.RuneFrame.offyFF)
	OPRF.Dots.Widgets.pointBPparent:SetValue(DB.RuneFrame.pointBPparent)
	OPRF.Dots.Widgets.pointBP:SetValue(DB.RuneFrame.pointBP)
	OPRF.Dots.Widgets.offxBP:SetNumber(DB.RuneFrame.offxBP)
	OPRF.Dots.Widgets.offyBP:SetNumber(DB.RuneFrame.offyBP)
	OPRF.Dots.Widgets.colorFF:SetColor(DB.RuneFrame.colorFF)
	OPRF.Dots.Widgets.colorFFbg:SetColor(DB.RuneFrame.colorFFbg)
	OPRF.Dots.Widgets.colorBP:SetColor(DB.RuneFrame.colorBP)
	OPRF.Dots.Widgets.colorBPbg:SetColor(DB.RuneFrame.colorBPbg)
	-- Runic Power
	OPRF.RP.Widgets.showRP:SetChecked(DB.RuneFrame.showRP)
	OPRF.RP.Widgets.orientRP:SetValue(DB.RuneFrame.orientRP)
	OPRF.RP.Widgets.widthRP:SetNumber(DB.RuneFrame.widthRP)
	OPRF.RP.Widgets.heightRP:SetNumber(DB.RuneFrame.heightRP)
	OPRF.RP.Widgets.showRPlabels:SetChecked(DB.RuneFrame.showRPlabels)
	OPRF.RP.Widgets.formatRPlabels:SetValue(DB.RuneFrame.formatRPlabels)
	OPRF.RP.Widgets.offxRPlabels:SetNumber(DB.RuneFrame.offxRPlabels)
	OPRF.RP.Widgets.offyRPlabels:SetNumber(DB.RuneFrame.offyRPlabels)
	OPRF.RP.Widgets.fontsizeRPlabels:SetNumber(DB.RuneFrame.fontsizeRPlabels)
	OPRF.RP.Widgets.pointRPparent:SetValue(DB.RuneFrame.pointRPparent)
	OPRF.RP.Widgets.pointRP:SetValue(DB.RuneFrame.pointRP)
	OPRF.RP.Widgets.offxRP:SetNumber(DB.RuneFrame.offxRP)
	OPRF.RP.Widgets.offyRP:SetNumber(DB.RuneFrame.offyRP)
	OPRF.RP.Widgets.colorRP:SetColor(DB.RuneFrame.colorRP)
	OPRF.RP.Widgets.colorRPbg:SetColor(DB.RuneFrame.colorRPbg)
	OPRF.RP.Widgets.showSpark:SetChecked(DB.RuneFrame.showSpark)
	--Buttons 1/2
	OPRF.BT.Widgets.showB1:SetChecked(DB.RuneFrame.showB1)
	OPRF.BT.Widgets.sizeB1:SetNumber(DB.RuneFrame.sizeB1)
	OPRF.BT.Widgets.showB1labels:SetChecked(DB.RuneFrame.showB1labels)
	OPRF.BT.Widgets.offxB1labels:SetNumber(DB.RuneFrame.offxB1labels)
	OPRF.BT.Widgets.offyB1labels:SetNumber(DB.RuneFrame.offyB1labels)
	OPRF.BT.Widgets.fontsizeB1labels:SetNumber(DB.RuneFrame.fontsizeB1labels)
	OPRF.BT.Widgets.pointB1parent:SetValue(DB.RuneFrame.pointB1parent)
	OPRF.BT.Widgets.pointB1:SetValue(DB.RuneFrame.pointB1)
	OPRF.BT.Widgets.offxB1:SetNumber(DB.RuneFrame.offxB1)
	OPRF.BT.Widgets.offyB1:SetNumber(DB.RuneFrame.offyB1)
	OPRF.BT.Widgets.fontColorB1:SetColor(DB.RuneFrame.fontColorB1)
	OPRF.BT.Widgets.showB2:SetChecked(DB.RuneFrame.showB2)
	OPRF.BT.Widgets.sizeB2:SetNumber(DB.RuneFrame.sizeB2)
	OPRF.BT.Widgets.showB2labels:SetChecked(DB.RuneFrame.showB2labels)
	OPRF.BT.Widgets.offxB2labels:SetNumber(DB.RuneFrame.offxB2labels)
	OPRF.BT.Widgets.offyB2labels:SetNumber(DB.RuneFrame.offyB2labels)
	OPRF.BT.Widgets.fontsizeB2labels:SetNumber(DB.RuneFrame.fontsizeB2labels)
	OPRF.BT.Widgets.pointB2parent:SetValue(DB.RuneFrame.pointB2parent)
	OPRF.BT.Widgets.pointB2:SetValue(DB.RuneFrame.pointB2)
	OPRF.BT.Widgets.offxB2:SetNumber(DB.RuneFrame.offxB2)
	OPRF.BT.Widgets.offyB2:SetNumber(DB.RuneFrame.offyB2)
	OPRF.BT.Widgets.fontColorB2:SetColor(DB.RuneFrame.fontColorB2)
	--Buttons 3/4
	OPRF.BT2.Widgets.showB3:SetChecked(DB.RuneFrame.showB3)
	OPRF.BT2.Widgets.sizeB3:SetNumber(DB.RuneFrame.sizeB3)
	OPRF.BT2.Widgets.showB3labels:SetChecked(DB.RuneFrame.showB3labels)
	OPRF.BT2.Widgets.offxB3labels:SetNumber(DB.RuneFrame.offxB3labels)
	OPRF.BT2.Widgets.offyB3labels:SetNumber(DB.RuneFrame.offyB3labels)
	OPRF.BT2.Widgets.fontsizeB3labels:SetNumber(DB.RuneFrame.fontsizeB3labels)
	OPRF.BT2.Widgets.pointB3parent:SetValue(DB.RuneFrame.pointB3parent)
	OPRF.BT2.Widgets.pointB3:SetValue(DB.RuneFrame.pointB3)
	OPRF.BT2.Widgets.offxB3:SetNumber(DB.RuneFrame.offxB3)
	OPRF.BT2.Widgets.offyB3:SetNumber(DB.RuneFrame.offyB3)
	OPRF.BT2.Widgets.fontColorB3:SetColor(DB.RuneFrame.fontColorB3)
	OPRF.BT2.Widgets.showB4:SetChecked(DB.RuneFrame.showB4)
	OPRF.BT2.Widgets.sizeB4:SetNumber(DB.RuneFrame.sizeB4)
	OPRF.BT2.Widgets.showB4labels:SetChecked(DB.RuneFrame.showB4labels)
	OPRF.BT2.Widgets.offxB4labels:SetNumber(DB.RuneFrame.offxB4labels)
	OPRF.BT2.Widgets.offyB4labels:SetNumber(DB.RuneFrame.offyB4labels)
	OPRF.BT2.Widgets.fontsizeB4labels:SetNumber(DB.RuneFrame.fontsizeB4labels)
	OPRF.BT2.Widgets.pointB4parent:SetValue(DB.RuneFrame.pointB4parent)
	OPRF.BT2.Widgets.pointB4:SetValue(DB.RuneFrame.pointB4)
	OPRF.BT2.Widgets.offxB4:SetNumber(DB.RuneFrame.offxB4)
	OPRF.BT2.Widgets.offyB4:SetNumber(DB.RuneFrame.offyB4)
	OPRF.BT2.Widgets.fontColorB4:SetColor(DB.RuneFrame.fontColorB4)
	-- Blood Shield
	OPRF.BS.Widgets.showBS:SetChecked(DB.RuneFrame.showBS)
	OPRF.BS.Widgets.showBSempty:SetChecked(DB.RuneFrame.showBSempty)
	OPRF.BS.Widgets.orientBS:SetValue(DB.RuneFrame.orientBS)
	OPRF.BS.Widgets.widthBS:SetNumber(DB.RuneFrame.widthBS)
	OPRF.BS.Widgets.heightBS:SetNumber(DB.RuneFrame.heightBS)
	OPRF.BS.Widgets.showBSlabels:SetChecked(DB.RuneFrame.showBSlabels)
	OPRF.BS.Widgets.showBSlabelszero:SetChecked(DB.RuneFrame.showBSlabelszero)
	OPRF.BS.Widgets.offxBSlabels:SetNumber(DB.RuneFrame.offxBSlabels)
	OPRF.BS.Widgets.offyBSlabels:SetNumber(DB.RuneFrame.offyBSlabels)
	OPRF.BS.Widgets.fontsizeBSlabels:SetNumber(DB.RuneFrame.fontsizeBSlabels)
	OPRF.BS.Widgets.pointBSparent:SetValue(DB.RuneFrame.pointBSparent)
	OPRF.BS.Widgets.pointBS:SetValue(DB.RuneFrame.pointBS)
	OPRF.BS.Widgets.offxBS:SetNumber(DB.RuneFrame.offxBS)
	OPRF.BS.Widgets.offyBS:SetNumber(DB.RuneFrame.offyBS)
	OPRF.BS.Widgets.colorBS:SetColor(DB.RuneFrame.colorBS)
	OPRF.BS.Widgets.colorBSbg:SetColor(DB.RuneFrame.colorBSbg)
	OPRF.BS.Widgets.showBSSpark:SetChecked(DB.RuneFrame.showBSSpark)
	OPRF.BS.Widgets.sparkWidth:SetNumber(DB.RuneFrame.sparkWidth)
	OPRF.BS.Widgets.sparkHeight:SetNumber(DB.RuneFrame.sparkHeight)
	--print("End of RefreshRF function")
end

local function CreateOptionsPanelRF()
	OPRF = CreateFrame("Frame", "OPRF", OptionsPanel)
	OPRF.name = "Rune Display"
	OPRF.parent = "DKOne"
	OPRF:SetWidth(400)
	OPRF:SetHeight(400)
	OPRF.okay = OkayRF
	OPRF.cancel = CancelRF
	OPRF.default = DefaultRF
	OPRF.refresh = RefreshRF
	OPRF.Widgets = {}
	OPRF.tabs = {}
	InterfaceOptions_AddCategory(OPRF, "DKOne", 3)

	--RuneFrame
	OPRF.RuneFrame = CreateFrame("Frame", "Rune Frame", OPRF)
	OPRF.RuneFrame.Widgets = {}
	OPRF.RuneFrame.Widgets.RFHeader = createLabel("The Rune Frame size is set automatically by the size and orientation\nof the runes which can be changed on the next tab", 20, -20, OPRF.RuneFrame, "TOPLEFT", "TOPLEFT", 12, {1,1,0,1}, "LEFT")
	OPRF.RuneFrame.Widgets.locked = CreateCheckButton(OPRF.RuneFrame, 20, -60, "Lock Rune Frame")
	OPRF.RuneFrame.Widgets.x = CreateEditBox(OPRF.RuneFrame, 20, -90, 50, "X location of Rune Frame relative to the center of the screen", nil, "RIGHT", -1500, 1500, false)
	OPRF.RuneFrame.Widgets.y = CreateEditBox(OPRF.RuneFrame, 20, -120, 50, "Y location of Rune Frame relative to the center of the screen", nil, "RIGHT", -1500, 1500, false)
	OPRF.RuneFrame.Widgets.colorRFbg = CreateColorBox(OPRF.RuneFrame, 20, -160, "Color of the background for the Rune Frame")
	OPRF.RuneFrame.Widgets.runeOrder = createMenu(OPRF.RuneFrame, 5, -200, 108, 50, orderMenu, nil, "Order of Runes")
	createTab(OPRF, 1, "Rune Frame", OPRF.RuneFrame)
	--Runes
	OPRF.Runes = CreateFrame("Frame", "Runes", OPRF)
	OPRF.Runes.Widgets = {}
	OPRF.Runes.Widgets.runeOrientation = createMenu(OPRF.Runes, 5, -30, 108, 50, orientMenu, nil, "Orientation of Rune Bars")
	OPRF.Runes.Widgets.widthR = CreateEditBox(OPRF.Runes, 20, -60, 50, "Width of Runes", nil, "RIGHT", 1, 500, true)
	OPRF.Runes.Widgets.heightR = CreateEditBox(OPRF.Runes, 20, -90, 50, "Height of Runes", nil, "RIGHT", 1, 500, true)
	OPRF.Runes.Widgets.padding = CreateEditBox(OPRF.Runes, 20, -120, 50, "Padding between Runes", nil, "RIGHT", 0, 500, true)	
	OPRF.Runes.Widgets.colorRbg = CreateColorBox(OPRF.Runes, 20, -150, "Color of the background for individual Runes")
	OPRF.Runes.Widgets.showRlabels = CreateCheckButton(OPRF.Runes, 20, -180, "Show time left on Runes")
	OPRF.Runes.Widgets.formatRlabels = createMenu(OPRF.Runes, 5, -210, 108, 50, timeFormatMenu, nil, "Format for time left on Runes")
	OPRF.Runes.Widgets.offxRlabels = CreateEditBox(OPRF.Runes, 20, -240, 50, "x offset for time left on runes", nil, "RIGHT", -1500, 1500, false)
	OPRF.Runes.Widgets.offyRlabels = CreateEditBox(OPRF.Runes, 20, -270, 50, "y offset for time left on runes", nil, "RIGHT", -1500, 1500, false)
	OPRF.Runes.Widgets.fontsizeRlabels = CreateEditBox(OPRF.Runes, 20, -300, 50, "Size of Font for time left on runes", nil, "RIGHT", 6, 32, true)
	OPRF.Runes.Widgets.doFlash = CreateCheckButton(OPRF.Runes, 20, -330, "Flash runes brighter when they finish")
	OPRF.Runes.Widgets.flashTimer = CreateSlider(OPRF.Runes, 20, -360, nil, .1, 2.5, .1, "How long should runes flash brighter when they finish (in secs)")
	-- Rune Colors
	OPRF.Runes.Widgets.RTopHeader = createLabel("Rune Colors", 385, -35, OPRF.Runes, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.Runes.Widgets.RdarkHeader = createLabel("On CD", 370, -55, OPRF.Runes, "TOPLEFT", "TOPLEFT", 12, {1,1,0,1}, "LEFT")
	OPRF.Runes.Widgets.colorRdarkB = CreateColorBox(OPRF.Runes, 380, -70, "")
	OPRF.Runes.Widgets.colorRdarkU = CreateColorBox(OPRF.Runes, 380, -100, "")
	OPRF.Runes.Widgets.colorRdarkF = CreateColorBox(OPRF.Runes, 380, -130, "")
	OPRF.Runes.Widgets.colorRdarkD = CreateColorBox(OPRF.Runes, 380, -160, "")
	OPRF.Runes.Widgets.RHeader = createLabel("Ready", 424, -55, OPRF.Runes, "TOPLEFT", "TOPLEFT", 12, {1,1,0,1}, "LEFT")
	OPRF.Runes.Widgets.colorRB = CreateColorBox(OPRF.Runes, 430, -70, "")
	OPRF.Runes.Widgets.colorRU = CreateColorBox(OPRF.Runes, 430, -100, "")
	OPRF.Runes.Widgets.colorRF = CreateColorBox(OPRF.Runes, 430, -130, "")
	OPRF.Runes.Widgets.colorRD = CreateColorBox(OPRF.Runes, 430, -160, "")
	OPRF.Runes.Widgets.RdarkHeader = createLabel("Flash", 478, -55, OPRF.Runes, "TOPLEFT", "TOPLEFT", 12, {1,1,0,1}, "LEFT")
	OPRF.Runes.Widgets.colorRlightB = CreateColorBox(OPRF.Runes, 480, -70, "BLOOD")
	OPRF.Runes.Widgets.colorRlightU = CreateColorBox(OPRF.Runes, 480, -100, "UNHOLY")
	OPRF.Runes.Widgets.colorRlightF = CreateColorBox(OPRF.Runes, 480, -130, "FROST")
	OPRF.Runes.Widgets.colorRlightD = CreateColorBox(OPRF.Runes, 480, -160, "DEATH")
	createTab(OPRF, 2, "Runes", OPRF.Runes)
	-- Dots
	OPRF.Dots = CreateFrame("Frame", "Dots", OPRF)
	OPRF.Dots.Widgets = {}
	OPRF.Dots.Widgets.showDots = CreateCheckButton(OPRF.Dots, 20, -20, "Show Dots")
	OPRF.Dots.Widgets.orientDots = createMenu(OPRF.Dots, 5, -50, 108, 50, orientMenu, nil, "Orientation of Dot Bars")
	OPRF.Dots.Widgets.widthDots = CreateEditBox(OPRF.Dots, 20, -85, 50, "Width of Dot Bars", nil, "RIGHT", 1, 500, true)
	OPRF.Dots.Widgets.heightDots = CreateEditBox(OPRF.Dots, 20, -115, 50, "Height of Dot Bars", nil, "RIGHT", 1, 500, true)
	OPRF.Dots.Widgets.showDlabels = CreateCheckButton(OPRF.Dots, 300, -20, "Show Dot Time Left")
	OPRF.Dots.Widgets.formatDlabels = createMenu(OPRF.Dots, 285, -50, 108, 50, timeFormatMenu, nil, "Format for time left on Dots")
	OPRF.Dots.Widgets.offxDlabels = CreateEditBox(OPRF.Dots, 300, -85, 50, "x offset for Dots label from center of bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.Dots.Widgets.offyDlabels = CreateEditBox(OPRF.Dots, 300, -115, 50, "y offset for Dots label from center of bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.Dots.Widgets.fontsizeDlabels = CreateEditBox(OPRF.Dots, 300, -145, 50, "FontSize for Dots label", nil, "RIGHT", 6, 32, true)
	OPRF.Dots.Widgets.B1Header = createLabel("Frost Fever", 20, -180, OPRF.Dots, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.Dots.Widgets.pointFFparent = createMenu(OPRF.Dots, 5, -220, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.Dots.Widgets.pointFF = createMenu(OPRF.Dots, 5, -260, 108, 50, anchorMenu, "Anchor To:", "Of the Frost Fever\nStatus Bar")
	OPRF.Dots.Widgets.offxFF = CreateEditBox(OPRF.Dots, 20, -290, 50, "x offset for Frost Fever", nil, "RIGHT", -1500, 1500, false)
	OPRF.Dots.Widgets.offyFF = CreateEditBox(OPRF.Dots, 20, -310, 50, "y offset for Frost fever", nil, "RIGHT", -1500, 1500, false)
	OPRF.Dots.Widgets.B1Header = createLabel("Blood Plague", 300, -180, OPRF.Dots, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.Dots.Widgets.pointBPparent = createMenu(OPRF.Dots, 285, -220, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.Dots.Widgets.pointBP = createMenu(OPRF.Dots, 285, -260, 108, 50, anchorMenu, "Anchor To:", "Of the Blood Plague\nStatus Bar")
	OPRF.Dots.Widgets.offxBP = CreateEditBox(OPRF.Dots, 300, -290, 50, "x offset for Blood Plague", nil, "RIGHT", -1500, 1500, false)
	OPRF.Dots.Widgets.offyBP = CreateEditBox(OPRF.Dots, 300, -310, 50, "y offset for Blood Plague", nil, "RIGHT", -1500, 1500, false)
	OPRF.Dots.Widgets.colorFF = CreateColorBox(OPRF.Dots, 20, -340, "Frost Fever")
	OPRF.Dots.Widgets.colorFFbg = CreateColorBox(OPRF.Dots, 20, -370, "Frost Fever Background")
	OPRF.Dots.Widgets.colorBP = CreateColorBox(OPRF.Dots, 300, -340, "Blood Plague")
	OPRF.Dots.Widgets.colorBPbg = CreateColorBox(OPRF.Dots, 300, -370, "Blood Plague Background")
	createTab(OPRF, 3, "Dots", OPRF.Dots)
	--RunicPower
	OPRF.RP = CreateFrame("Frame", "Dots", OPRF)
	OPRF.RP.Widgets = {}
	OPRF.RP.Widgets.showRP = CreateCheckButton(OPRF.RP, 20, -20, "Show Runic Power")
	OPRF.RP.Widgets.orientRP = createMenu(OPRF.RP, 5, -50, 108, 50, orientMenu, nil, "Orientation of RP Bar")
	OPRF.RP.Widgets.widthRP = CreateEditBox(OPRF.RP, 20, -85, 50, "Width of Runic Power Bar\n(Set to 0 to make RP bar the\nsame width as the Rune Frame)", nil, "RIGHT", 0, 500, true)
	OPRF.RP.Widgets.heightRP = CreateEditBox(OPRF.RP, 20, -135, 50, "Height of Runic Power Bar\n(Set to 0 to make RP bar the\nsame height as the Rune Frame)", nil, "RIGHT", 0, 500, true)
	OPRF.RP.Widgets.showRPlabels = CreateCheckButton(OPRF.RP, 300, -20, "Show Runic Power Text")
	OPRF.RP.Widgets.formatRPlabels = createMenu(OPRF.RP, 285, -50, 108, 50, timeFormatMenu2, nil, "Format for Runic Power Text")
	OPRF.RP.Widgets.offxRPlabels = CreateEditBox(OPRF.RP, 300, -85, 50, "x offset for RP label from center of bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.RP.Widgets.offyRPlabels = CreateEditBox(OPRF.RP, 300, -115, 50, "y offset for RP label from center of bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.RP.Widgets.fontsizeRPlabels = CreateEditBox(OPRF.RP, 300, -145, 50, "FontSize for RP label", nil, "RIGHT", 6, 32, true)
	OPRF.RP.Widgets.pointRPparent = createMenu(OPRF.RP, 5, -220, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.RP.Widgets.pointRP = createMenu(OPRF.RP, 5, -260, 108, 50, anchorMenu, "Anchor To:", "Of the Runic Power Bar")
	OPRF.RP.Widgets.offxRP = CreateEditBox(OPRF.RP, 20, -290, 50, "x offset for the Runic Power Bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.RP.Widgets.offyRP = CreateEditBox(OPRF.RP, 20, -310, 50, "y offset for the Runic Power Bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.RP.Widgets.colorRP = CreateColorBox(OPRF.RP, 20, -340, "Runic Power")
	OPRF.RP.Widgets.colorRPbg = CreateColorBox(OPRF.RP, 20, -370, "Runic Power Background")
	OPRF.RP.Widgets.showSpark = CreateCheckButton(OPRF.RP, 300, -220, "Show dividing lines for runic power\ndumps on bar")
	createTab(OPRF, 4, "Runic Power", OPRF.RP)
	--Buttons 1/2
	OPRF.BT = CreateFrame("Frame", "Buttons 1/2", OPRF)
	OPRF.BT.Widgets = {}
	OPRF.BT.Widgets.B1Header = createLabel("Button 1", 20, -15, OPRF.BT, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.BT.Widgets.B1List = createLabel("Scent of Blood/Rime\nDark Transformation/Shadow Infusion", 20, -35, OPRF.BT, "TOPLEFT", "TOPLEFT", 10, {1,1,0,1}, "LEFT")
	OPRF.BT.Widgets.showB1 = CreateCheckButton(OPRF.BT, 20, -65, "Show Button 1")
	OPRF.BT.Widgets.sizeB1 = CreateEditBox(OPRF.BT, 20, -90, 50, "Size of Button 1", nil, "RIGHT", 1, 500, true)
	OPRF.BT.Widgets.pointB1parent = createMenu(OPRF.BT, 5, -130, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.BT.Widgets.pointB1 = createMenu(OPRF.BT, 5, -170, 108, 50, anchorMenu, "Anchor To:", "Of button 1")
	OPRF.BT.Widgets.offxB1 = CreateEditBox(OPRF.BT, 20, -200, 50, "x offset for Button 1", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.offyB1 = CreateEditBox(OPRF.BT, 20, -230, 50, "y offset for Button 1", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.showB1labels = CreateCheckButton(OPRF.BT, 20, -260, "Show Label on Button 1")
	OPRF.BT.Widgets.offxB1labels = CreateEditBox(OPRF.BT, 20, -290, 50, "x offset for text from center of button 1", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.offyB1labels = CreateEditBox(OPRF.BT, 20, -320, 50, "y offset for text from center of button 1", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.fontsizeB1labels = CreateEditBox(OPRF.BT, 20, -350, 50, "FontSize for button 1 text", nil, "RIGHT", 6, 32, true)
	OPRF.BT.Widgets.fontColorB1 = CreateColorBox(OPRF.BT, 20, -380, "Font Color for text of button 1")
	OPRF.BT.Widgets.B2Header = createLabel("Button 2", 300, -15, OPRF.BT, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.BT.Widgets.B2List = createLabel("Will of Necropolis(Rune Tap)\nKilling Machine/Sudden Doom", 300, -35, OPRF.BT, "TOPLEFT", "TOPLEFT", 10, {1,1,0,1}, "LEFT")
	OPRF.BT.Widgets.showB2 = CreateCheckButton(OPRF.BT, 300, -65, "Show Button 2")
	OPRF.BT.Widgets.sizeB2 = CreateEditBox(OPRF.BT, 300, -90, 50, "Size of Button 2", nil, "RIGHT", 1, 500, true)
	OPRF.BT.Widgets.pointB2parent = createMenu(OPRF.BT, 285, -130, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.BT.Widgets.pointB2 = createMenu(OPRF.BT, 285, -170, 108, 50, anchorMenu, "Anchor To:", "Of button 2")
	OPRF.BT.Widgets.offxB2 = CreateEditBox(OPRF.BT, 300, -200, 50, "x offset for Button 2", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.offyB2 = CreateEditBox(OPRF.BT, 300, -230, 50, "y offset for Button 2", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.showB2labels = CreateCheckButton(OPRF.BT, 300, -260, "Show Label on Button 2")
	OPRF.BT.Widgets.offxB2labels = CreateEditBox(OPRF.BT, 300, -290, 50, "x offset for text from center of button 2", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.offyB2labels = CreateEditBox(OPRF.BT, 300, -320, 50, "y offset for text from center of button 2", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT.Widgets.fontsizeB2labels = CreateEditBox(OPRF.BT, 300, -350, 50, "FontSize for button 2 text", nil, "RIGHT", 6, 32, true)
	OPRF.BT.Widgets.fontColorB2 = CreateColorBox(OPRF.BT, 300, -380, "Font Color for text of button 2")
	createTab(OPRF, 5, "Buttons 1/2", OPRF.BT)
	-- Buttons 3/4
	OPRF.BT2 = CreateFrame("Frame", "Buttons 3/4", OPRF)
	OPRF.BT2.Widgets = {}
	OPRF.BT2.Widgets.B3Header = createLabel("Button 3", 20, -15, OPRF.BT2, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.BT2.Widgets.B3List = createLabel("Ghoul/Pillar of Frost\nBlood Lust/Unholy Frenzy", 20, -35, OPRF.BT2, "TOPLEFT", "TOPLEFT", 10, {1,1,0,1}, "LEFT")
	OPRF.BT2.Widgets.showB3 = CreateCheckButton(OPRF.BT2, 20, -65, "Show Button 3")
	OPRF.BT2.Widgets.sizeB3 = CreateEditBox(OPRF.BT2, 20, -90, 50, "Size of Button 3", nil, "RIGHT", 1, 500, true)
	OPRF.BT2.Widgets.pointB3parent = createMenu(OPRF.BT2, 5, -130, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.BT2.Widgets.pointB3 = createMenu(OPRF.BT2, 5, -170, 108, 50, anchorMenu, "Anchor To:", "Of button 3")
	OPRF.BT2.Widgets.offxB3 = CreateEditBox(OPRF.BT2, 20, -200, 50, "x offset for Button 3", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.offyB3 = CreateEditBox(OPRF.BT2, 20, -230, 50, "y offset for Button 3", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.showB3labels = CreateCheckButton(OPRF.BT2, 20, -260, "Show Label on Button 1")
	OPRF.BT2.Widgets.offxB3labels = CreateEditBox(OPRF.BT2, 20, -290, 50, "x offset for text from center of button 3", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.offyB3labels = CreateEditBox(OPRF.BT2, 20, -320, 50, "y offset for text from center of button 3", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.fontsizeB3labels = CreateEditBox(OPRF.BT2, 20, -350, 50, "FontSize for button 3 text", nil, "RIGHT", 6, 32, true)
	OPRF.BT2.Widgets.fontColorB3 = CreateColorBox(OPRF.BT2, 20, -380, "Font Color for text of button 3")
	OPRF.BT2.Widgets.B4Header = createLabel("Button 4", 300, -15, OPRF.BT2, "TOPLEFT", "TOPLEFT", 18, {1,1,0,1}, "LEFT")
	OPRF.BT2.Widgets.B4List = createLabel("Bone Shield\nRune of the Fallen Crusader", 300, -35, OPRF.BT2, "TOPLEFT", "TOPLEFT", 10, {1,1,0,1}, "LEFT")
	OPRF.BT2.Widgets.showB4 = CreateCheckButton(OPRF.BT2, 300, -65, "Show Button 4")
	OPRF.BT2.Widgets.sizeB4 = CreateEditBox(OPRF.BT2, 300, -90, 50, "Size of Button 4", nil, "RIGHT", 1, 500, true)
	OPRF.BT2.Widgets.pointB4parent = createMenu(OPRF.BT2, 285, -130, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.BT2.Widgets.pointB4 = createMenu(OPRF.BT2, 285, -170, 108, 50, anchorMenu, "Anchor To:", "Of button 4")
	OPRF.BT2.Widgets.offxB4 = CreateEditBox(OPRF.BT2, 300, -200, 50, "x offset for Button 4", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.offyB4 = CreateEditBox(OPRF.BT2, 300, -230, 50, "y offset for Button 4", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.showB4labels = CreateCheckButton(OPRF.BT2, 300, -260, "Show Label on Button 4")
	OPRF.BT2.Widgets.offxB4labels = CreateEditBox(OPRF.BT2, 300, -290, 50, "x offset for text from center of button 4", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.offyB4labels = CreateEditBox(OPRF.BT2, 300, -320, 50, "y offset for text from center of button 4", nil, "RIGHT", -1500, 1500, false)
	OPRF.BT2.Widgets.fontsizeB4labels = CreateEditBox(OPRF.BT2, 300, -350, 50, "FontSize for button 4 text", nil, "RIGHT", 6, 32, true)
	OPRF.BT2.Widgets.fontColorB4 = CreateColorBox(OPRF.BT2, 300, -380, "Font Color for text of button 4")
	createTab(OPRF, 6, "Buttons 3/4", OPRF.BT2)
	--Blood Shield
	OPRF.BS = CreateFrame("Frame", "Blood Shield", OPRF)
	OPRF.BS.Widgets = {}
	OPRF.BS.Widgets.showBS = CreateCheckButton(OPRF.BS, 20, -20, "Show Blood Shield")
	OPRF.BS.Widgets.showBSempty = CreateCheckButton(OPRF.BS, 20, -50, "Show Blood Shield Bar even when zero")
	OPRF.BS.Widgets.orientBS = createMenu(OPRF.BS, 5, -80, 108, 50, orientMenu, nil, "Orientation of BS Bar")
	OPRF.BS.Widgets.widthBS = CreateEditBox(OPRF.BS, 20, -120, 50, "Width of Blood Shield Bar\n(Set to 0 to make BS bar the\nsame width as the Rune Frame)", nil, "RIGHT", 0, 500, true)
	OPRF.BS.Widgets.heightBS = CreateEditBox(OPRF.BS, 20, -160, 50, "Height of Blood Shield Bar\n(Set to 0 to make BS bar the\nsame height as the Rune Frame)", nil, "RIGHT", 0, 500, true)
	OPRF.BS.Widgets.showBSlabels = CreateCheckButton(OPRF.BS, 300, -20, "Show Blood Shield Text")
	OPRF.BS.Widgets.showBSlabelszero = CreateCheckButton(OPRF.BS, 300, -50, "Show Blood Shield Text even when zero")
	OPRF.BS.Widgets.offxBSlabels = CreateEditBox(OPRF.BS, 300, -80, 50, "x offset for BS label from center of bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.BS.Widgets.offyBSlabels = CreateEditBox(OPRF.BS, 300, -115, 50, "y offset for BS label from center of bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.BS.Widgets.fontsizeBSlabels = CreateEditBox(OPRF.BS, 300, -145, 50, "FontSize for BS label", nil, "RIGHT", 6, 32, true)
	OPRF.BS.Widgets.pointBSparent = createMenu(OPRF.BS, 5, -220, 108, 50, anchorMenu, "Anchor From:", "Of the Rune Display")
	OPRF.BS.Widgets.pointBS = createMenu(OPRF.BS, 5, -260, 108, 50, anchorMenu, "Anchor To:", "Of the Blood Shield Bar")
	OPRF.BS.Widgets.offxBS = CreateEditBox(OPRF.BS, 20, -290, 50, "x offset for the Blood Shield Bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.BS.Widgets.offyBS = CreateEditBox(OPRF.BS, 20, -310, 50, "y offset for the Blood Shield Bar", nil, "RIGHT", -1500, 1500, false)
	OPRF.BS.Widgets.colorBS = CreateColorBox(OPRF.BS, 20, -340, "Blood Shield")
	OPRF.BS.Widgets.colorBSbg = CreateColorBox(OPRF.BS, 20, -370, "Blood Shield Background")
	OPRF.BS.Widgets.showBSSpark = CreateCheckButton(OPRF.BS, 300, -220, "Show Blood Shield Duration Spark")
	OPRF.BS.Widgets.sparkWidth = CreateEditBox(OPRF.BS, 300, -250, 50, "Width of Blood Shield Duration Spark", nil, "RIGHT", 2, 30, true)
	OPRF.BS.Widgets.sparkHeight = CreateEditBox(OPRF.BS, 300, -280, 50, "Height of Blood Shield Duration Spark", nil, "RIGHT", 2, 500, true)
	createTab(OPRF, 7, "Blood Shield", OPRF.BS)
	
	tabOnClick(OPRF.tabs[1])
end

-- This global function calls the individual functions that create all the panels
function addonTable.DKOneOptions()
	DB = DKOneDB
	actions = addonTable.DKOneActionList()
	for k,v in pairs(actions) do
		if v.order == nil or v.order ==  0 then
			actionsBlood[k] = {}
			actionsFrost[k] = {}
			actionsUnholy[k] = {}
			actionsBlood[k].order = v.order or nil
			actionsBlood[k].info = v.info or ""
			actionsFrost[k].order = v.order or nil
			actionsFrost[k].info = v.info or ""
			actionsUnholy[k].order = v.order or nil
			actionsUnholy[k].info = v.info or ""
		elseif v.order ==  1 then
			actionsBlood[k] = {}
			actionsBlood[k]["order"] = v.order or nil
			actionsBlood[k]["info"] = v.info or ""
		elseif v.order ==  2 then
			actionsFrost[k] = {}
			actionsFrost[k].order = v.order or nil
			actionsFrost[k].info = v.info or ""
		elseif v.order ==  3 then
			actionsUnholy[k] = {}
			actionsUnholy[k].order = v.order or nil
			actionsUnholy[k].info = v.info or ""
		end
	end			
	actionsBlood["Any Rotation"] = {order = -.5, info = "header"}
	actionsFrost["Any Rotation"] = {order = -.5, info = "header"}
	actionsUnholy["Any Rotation"] = {order = -.5, info = "header"}
	actionsBlood["Blood Rotation"] = {order = .5, info = "header"}
	actionsFrost["Frost Rotation"] = {order = 1.5, info = "header"}
	actionsUnholy["Unholy Rotation"] = {order = 2.5, info = "header"}
	actionsCD = addonTable.DKOneActionCDList()
	actionsCD["Any Cooldown"] = {order = -.5, info = "header"}
	actionsCD["Blood Cooldown"] = {order = .5, info = "header"}
	actionsCD["Frost Cooldown"] = {order = 1.5, info = "header"}
	actionsCD["Unholy Cooldown"] = {order = 2.5, info = "header"}
	CreateOptionsPanel()
	CreateOptionsPanelAD()
	CreateOptionsPanelLB()
	CreateOptionsPanelRot()
	CreateOptionsPanelRF()
	CreateOptionsPanelDoc()
end